﻿SystemOrganization addCategory: #'GdsCompiler-DGL'!
SystemOrganization addCategory: #'GdsCompiler-Data'!
SystemOrganization addCategory: #'GdsCompiler-Kernel'!
SystemOrganization addCategory: #'GdsCompiler-Seaside'!
SystemOrganization addCategory: #'GdsCompiler-Service'!
SystemOrganization addCategory: #'GdsCompiler-Test'!
SystemOrganization addCategory: #'GdsCompiler-Commands'!
SystemOrganization addCategory: #'GdsCompiler-Misc'!

!String methodsFor: '*GdsCompiler' stamp: 'kf 5/23/2009 17:01'!
asGdsValue
	self isEmpty ifTrue: [^GdsNull fromSmalltalkObject: self].
	^GdsString fromSmalltalkObject: self.! !

TcpService subclass: #GdsServer
	instanceVariableNames: 'evaluter sessionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Service'!

GdsServer class
	instanceVariableNames: 'server'!

!GdsServer commentStamp: 'kf 5/31/2009 23:06' prior: 0!
A GdsServer is xxxxxxxxx.

Instance Variables
	evaluter:		<GplEvaluter>
	sessionMap:		<Dictionary<Integer,GdsIoSession>>

evaluter
	- xxxxx

sessionMap
	- xxxxx
!

GdsServer class
	instanceVariableNames: 'server'!

!GdsServer class methodsFor: 'convert' stamp: 'kf 6/8/2009 17:12'!
chomp: aString
	| lastIndex index|
	aString isEmpty ifTrue: [^''].
	lastIndex :=  aString size.
	index := lastIndex.
	[index >= 1]
		whileTrue: [
			| c |
			c := aString at: index.
			((c = Character lf) or: [c = Character cr])
				ifFalse: [^aString copyFrom: 1 to: index].
			index := index - 1.].
	^aString.! !

!GdsServer class methodsFor: 'constant' stamp: 'kf 4/23/2009 10:44'!
eoString
	^(Character value: 0) asString! !

!GdsServer class methodsFor: 'accessing' stamp: 'kf 5/21/2009 17:30'!
showsLog: aBoolean
	server ifNotNil: [server showsLog: aBoolean].! !

!GdsServer class methodsFor: 'accessing' stamp: 'kf 4/23/2009 13:54'!
start
	server ifNotNil: [
		Transcript cr; show: '!!!!!! Server already running !!!!!!'. 
		^self]. 
	server := self startOn: 9999 named: 'gds'.
	! !

!GdsServer class methodsFor: 'accessing' stamp: 'kf 4/23/2009 13:56'!
stop
	server ifNil: [
		Transcript cr; show: '!!!!!! Server already stopped !!!!!!'. 
		^self]. 
	server stop.
	server := nil.
	! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/6/2009 11:06'!
clearSession
	sessionMap := nil.
	evaluter flushContextStacks.
		! !

!GdsServer methodsFor: 'accessing' stamp: 'kf 6/5/2009 17:46'!
debugLog: aObject
	evaluter debugLog: aObject.! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/6/2009 11:06'!
endSession
	self clearSession


		! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/8/2009 14:01'!
getReciveSession: aGdsInRecord
	| session |
	session := self sessionOfNumber: aGdsInRecord session.
	session addRecord: aGdsInRecord.
	^session! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/8/2009 14:40'!
implementedMethodNames
	| col |
	col := OrderedCollection new.
	col addAll: GplHandler commandNames.
	col addAll: (GplToken implementedMonadicMethods
		collect: [:each | each asString]).
	col addAll: (GplToken implementedDyadicMethods
		collect: [:each | each asString]).
	^col asSet asArray.! !

!GdsServer methodsFor: 'initialization' stamp: 'kf 4/22/2009 00:22'!
initialize
	super initialize.
	evaluter := GplEvaluter new.! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/5/2009 17:38'!
send: aString on: aSocket
	aSocket sendData: ((self class chomp: aString), self class eoString) .
	self debugLog: (self class chomp: aString).
! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/5/2009 15:00'!
serve: aSocket 
	| reciveData bytes |
	reciveData := aSocket receiveData. 
	bytes := reciveData asByteArray.
	"self halt."
	(bytes isEmpty not and: [(#(0 1 2) includes: (bytes first))]) 
		ifTrue: [self serveNew: aSocket reciveData: reciveData]
		ifFalse: [self serveClassic: aSocket reciveData: reciveData].! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/5/2009 17:41'!
serveClassic: aSocket reciveData: reciveData
	| data |
	data := self class chomp: reciveData.
	data ifEmpty: [^self].
	self debugLog: (Time now printString, ': ' ,'<',data,'>').
	[| reply | 
	  reply := evaluter evaluteConsoleLine: data.
	 self send: reply on: aSocket .]
		on: Error do: [:ex | self send: ex asString on: aSocket].! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/10/2009 16:50'!
serveNew: aSocket reciveData: reciveData 
	| ioForInspect session replySession reply isPrompt arg evaluteBlock |
	ioForInspect := GdsIoRecive fromByteArray: reciveData asByteArray.
	ioForInspect isSessionEnter
		ifTrue: [^ self startSession: aSocket].	
				
	ioForInspect isSessionExit
		ifTrue: [^ self endSession].		
	session := self getReciveSession: ioForInspect.
	session hasMoreData ifTrue: [^ self].

	arg := session asString.
	evaluteBlock := [:arg1 | evaluter evaluteConsoleLine: arg1].
	ioForInspect isTypePromptReply 
		ifTrue: [ 
			evaluter pushResult:  session asString.
			evaluteBlock := [:arg1 | 
				evaluter evaluteAsString: [evaluter resume]]].

	replySession := GdsReplySession new session: session session.
	isPrompt := false.

	self debugLog: Time now printString , ': ' , '<' , arg asString, '>'.
	reply := [evaluteBlock value: arg] on: Error
				do: 
					[:ex | 
					(ex isKindOf: GplPromptException) 
						ifTrue: 
							[isPrompt := true.
							ex messageText]
						ifFalse: [ex asString]].
	reply isNil ifTrue: [reply := ''].
	self debugLog: Time now printString , ': ' , '[' , reply , ']'.
	replySession setPrommptState: isPrompt.
	replySession message: reply.
	self 
		debugLog: Time now printString , ': ' , '(' , replySession message , ')'.
	replySession send: aSocket! !

!GdsServer methodsFor: 'accessing' stamp: 'kf 5/31/2009 18:27'!
sessionOfNumber: aNumber
	sessionMap ifNil: [sessionMap := Dictionary new].
	^sessionMap at: aNumber ifAbsentPut: [GdsIoSession new session: aNumber].
	! !

!GdsServer methodsFor: 'accessing' stamp: 'kf 5/21/2009 17:29'!
showsLog
	^evaluter showsLog! !

!GdsServer methodsFor: 'accessing' stamp: 'kf 5/21/2009 17:29'!
showsLog: aBoolean
	evaluter showsLog: aBoolean! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/8/2009 14:50'!
startSession: aSocket
	| replySession |
	self clearSession.
	replySession := GdsReplySession new session: 0.
	replySession setCodeCompleteState: true.
	replySession message: 
		(self implementedMethodNames joinUsing: String cr).
	replySession send: aSocket	! !

!GdsServer methodsFor: 'conversation' stamp: 'kf 6/6/2009 11:12'!
suspendedGplExpressionLateResult: aResult 
	| context suspendToken |
	"self halt."
	evaluter pushResult: aResult.
	context := evaluter peekSuspendContext.
	suspendToken := context tempAt: 1.
	self assert: (suspendToken isMemberOf: GplToken).
	^ suspendToken parser source! !

!Collection methodsFor: '*GdsCompiler' stamp: 'kf 5/23/2009 19:31'!
asGdsValue
	self isEmpty ifTrue: [^ GdsNull fromSmalltalkObject: self].
	^ GdsVector fromSmalltalkObject: self! !

TestCase subclass: #GdsTestCase
	instanceVariableNames: 'evaluter model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

GdsTestCase subclass: #GdsBooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 5/23/2009 14:49'!
testAcceptableExpression
	| input result expResult |
	input := '1'.
	expResult := true.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.

	input := '0'.
	expResult := true.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.
	
	input := 'TRUE'.
	expResult := true.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.

	input := 'FALSE'.
	expResult := true.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.
	
	input := '1.0'.
	expResult := false.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.		

	input := '0.0'.
	expResult := false.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.
	
	input := 'false'. "disallow lowercase"
	expResult := false.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.
	
	input := '1E-17'. "disallow floating point"
	expResult := false.
	result := GdsBoolean acceptableExpression: input.
	self assert: result = expResult.
	! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 5/27/2009 16:04'!
testFromLiteral
	self assert: [(GdsBoolean fromLiteral: 'TRUE') asSmalltalkValue = 1].
	self assert: [(GdsBoolean fromLiteral: 'FALSE') asSmalltalkValue = 0].
	self assert: [(GdsBoolean fromLiteral: '1') asSmalltalkValue = 1].		
	self assert: [(GdsBoolean fromLiteral: '0') asSmalltalkValue = 0].	

	"only use 0 1 TRUE FALSE"
	self should: [(GdsBoolean fromLiteral: '2')] raise: GplSyntaxError.	
	self should: [(GdsBoolean fromLiteral: '0000000001')] raise: GplSyntaxError.	

	"cant ue real"
	self should: [(GdsBoolean fromLiteral: '1.0')] raise: GplSyntaxError.	
	self should: [(GdsBoolean fromLiteral: '0.0')] raise: GplSyntaxError.	

	"currently spec. only UPPECALSE"
	self should: [(GdsBoolean fromLiteral: 'true')] raise: GplSyntaxError.	
	self should: [(GdsBoolean fromLiteral: 'false')] raise: GplSyntaxError.	
	self should: [(GdsBoolean fromLiteral: 'True')] raise: GplSyntaxError.	
	self should: [(GdsBoolean fromLiteral: 'False')] raise: GplSyntaxError.	

	"currently spec. both side space is error"
	self should: [(GdsBoolean fromLiteral: ' 1')] raise: GplSyntaxError.	
	self should: [(GdsBoolean fromLiteral: '1 ')] raise: GplSyntaxError.	
	self should: [(GdsBoolean fromLiteral: ' 1 ')] raise: GplSyntaxError.	
					! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 6/11/2009 20:49'!
testIsList			
	self deny: [(GdsBoolean fromLiteral: 'TRUE') isList].	! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 5/27/2009 14:11'!
testLength
	self assert: [(true asGdsValue) length = 1].	
	self assert: [(false asGdsValue) length = 1].		
		! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:21'!
testMode		
	self assert: [(GdsBoolean fromLiteral: 'TRUE') mode = 1].
	self assert: [(GdsBoolean fromLiteral: 'FALSE') mode = 1].
	! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 4/28/2009 01:12'!
testRank			
	self assert: [(GdsBoolean fromLiteral: 'TRUE') rank = 0].	! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:19'!
testShape			
	self assert: [(GdsBoolean fromLiteral: 'TRUE') shape = #()].	! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:19'!
testSize			
	self assert: [(GdsBoolean fromLiteral: 'TRUE') size = 1].	! !

!GdsBooleanTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:20'!
testTypeString			
	self assert: [(GdsBoolean fromLiteral: 'TRUE') typeString = 'LOGICAL'].
	self assert: [(GdsBoolean fromLiteral: 'FALSE') typeString = 'LOGICAL'].
	! !

GdsTestCase subclass: #GdsIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 5/24/2009 22:34'!
testAcceptableExpression
	| input result expResult |
	input := '1'.
	expResult := true.
	result := GdsInteger acceptableExpression: input.
	self assert: result = expResult.
	
	input := '1.0'.
	expResult := false.
	result := GdsInteger acceptableExpression: input.
	self assert: result = expResult.
	
	input := '+1'.
	expResult := true.
	result := GdsInteger acceptableExpression: input.
	self deny: result = expResult description: 'can''t use + sign'.
	
	input := '32767'.
	expResult := true.
	result := GdsInteger acceptableExpression: input.
	self assert: result = expResult.
	
	input := '32768'. "overflow "
	expResult := false.
	result := GdsInteger acceptableExpression: input.
	self assert: result = expResult.
	
	input := '-32768'. " "
	expResult := true.
	result := GdsInteger acceptableExpression: input.
	self assert: result = expResult.
	
	input := '-32769'. " "
	expResult := false.
	result := GdsInteger acceptableExpression: input.
	self assert: result = expResult.
	
	input := '1E-17'. "disallow floating point"
	expResult := false.
	result := GdsInteger acceptableExpression: input.
	self assert: result = expResult.
	! !

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 5/27/2009 16:04'!
testFromLiteral
	self assert: [(GdsInteger fromLiteral: '1') asSmalltalkValue = 1].		
	self assert: [(GdsInteger fromLiteral: '0') asSmalltalkValue = 0].	
	self assert: [(GdsInteger fromLiteral: '0000000001') asSmalltalkValue = 1].	
	self assert: [(GdsInteger fromLiteral: '-32768') asSmalltalkValue = -32768].

	"cant use + sign"		
	self should:  [(GdsInteger fromLiteral: '+32767')] raise: GplSyntaxError.		

	self should:  [(GdsInteger fromLiteral: '1.0')] raise: GplSyntaxError.		

	"currently spec. both side space is error"
	self should: [(GdsInteger fromLiteral: ' 1')] raise: GplSyntaxError.	
	self should: [(GdsInteger fromLiteral: '1 ')] raise: GplSyntaxError.	
	self should: [(GdsInteger fromLiteral: ' 1 ')] raise: GplSyntaxError.	
					! !

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 6/11/2009 20:49'!
testIsList			
	self deny: [(GdsInteger fromLiteral: '1') isList].	
! !

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 5/25/2009 00:10'!
testMode		
	self assert: [(GdsInteger fromLiteral: '1') mode = 2].! !

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 4/28/2009 01:12'!
testRank			
	self assert: [(GdsInteger fromLiteral: '1') rank = 0].	! !

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:15'!
testShape			
	self assert: [(GdsInteger fromLiteral: '1') shape = #()].	
! !

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:16'!
testSize			
	self assert: [(GdsInteger fromLiteral: '1') size = 1].	
! !

!GdsIntegerTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:15'!
testTypeString			
	self assert: [(GdsInteger fromLiteral: '1') typeString = 'INTEGER'].	
! !

GdsTestCase subclass: #GdsListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsListTest methodsFor: 'private' stamp: 'kf 5/25/2009 21:34'!
sampleList
	^evaluter evaluteLine: '"ABC" ; IOTA 3 ; 3 4 RESHAPE IOTA 12'.! !

!GdsListTest methodsFor: 'tests' stamp: 'kf 5/29/2009 17:14'!
testAtSubscript
	evaluter evaluteLine: 'L := "ABC"; IOTA 3'.
	self should: [evaluter evaluteLine: 'L[0]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'L[3]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'L[]' ] raise: GplRuntimeError.
	self shouldnt: [evaluter evaluteLine: 'L[1.0]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'L[1.1]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'L[2;2]' ] raise: GplRuntimeError.
	self shouldnt: [evaluter evaluteLine: 'L[1]' ] raise: GplRuntimeError.
	self shouldnt: [evaluter evaluteLine: 'L[2]' ] raise: GplRuntimeError.
	! !

!GdsListTest methodsFor: 'tests' stamp: 'kf 6/11/2009 20:48'!
testIsList			
	self assert: [self sampleList isList].	
	! !

!GdsListTest methodsFor: 'tests' stamp: 'kf 5/25/2009 20:54'!
testLength
	self assert: [self sampleList length = 3]
	! !

!GdsListTest methodsFor: 'tests' stamp: 'kf 5/25/2009 20:49'!
testMode
	self assert: [self sampleList mode = 6] 
	! !

!GdsListTest methodsFor: 'tests' stamp: 'kf 5/27/2009 16:40'!
testShape
	self should: [self sampleList shape] raise: GplError
	! !

!GdsListTest methodsFor: 'tests' stamp: 'kf 5/27/2009 15:25'!
testSize
	self should: [self sampleList size] raise: GplError
	! !

!GdsListTest methodsFor: 'tests' stamp: 'kf 5/25/2009 20:50'!
testTypeString
	self assert: [self sampleList typeString = 'LIST'] 
	! !

GdsTestCase subclass: #GdsMatrixTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsMatrixTest methodsFor: 'private' stamp: 'kf 5/25/2009 21:34'!
sampleMatrix
	^evaluter evaluteLine: '3 4 RESHAPE IOTA 12'.! !

!GdsMatrixTest methodsFor: 'tests' stamp: 'kf 6/11/2009 20:49'!
testIsList			
	self deny: [self sampleMatrix isList].	


! !

!GdsMatrixTest methodsFor: 'tests' stamp: 'kf 5/25/2009 21:05'!
testLength
	self assert: [self sampleMatrix length = 1].
! !

!GdsMatrixTest methodsFor: 'tests' stamp: 'kf 5/25/2009 21:05'!
testMode
	self assert: [self sampleMatrix mode = 2].! !

!GdsMatrixTest methodsFor: 'tests' stamp: 'kf 5/25/2009 21:05'!
testShape
	self assert: [self sampleMatrix shape = #(3 4)].
! !

!GdsMatrixTest methodsFor: 'tests' stamp: 'kf 6/7/2009 18:03'!
testSize
	self assert: [self sampleMatrix size = 12].

	evaluter evaluteLine: 'M := 3 4 RESHAPE IOTA 12'.
	"SIZE INVARIANT using MONADIC operators"
	self assert: [(evaluter evaluteLine: 'SIZE M') asSmalltalkValue  = 12].
	self assert: [(evaluter evaluteLine: 'SIZE -M') asSmalltalkValue  = 12].	
	self assert: [(evaluter evaluteLine: 'SIZE +M') asSmalltalkValue  = 12].		
	self assert: [(evaluter evaluteLine: 'SIZE *M') asSmalltalkValue  = 12].			
	self assert: [(evaluter evaluteLine: 'SIZE %M') asSmalltalkValue  = 12].								! !

!GdsMatrixTest methodsFor: 'tests' stamp: 'kf 5/25/2009 21:07'!
testTypeString
	self deny: [self sampleMatrix typeString = 'MATRIX'].
	self assert: [self sampleMatrix typeString = 'INTEGER'].


! !

GdsTestCase subclass: #GdsNullTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/24/2009 22:42'!
testAcceptableExpression
	| input result expResult |
	input := '""'.
	expResult := true.
	result := GdsNull acceptableExpression: input.
	self assert: result = expResult.
	
	input := 'NULL'. "not represents NULL"
	expResult := false.
	result := GdsNull acceptableExpression: input.
	self assert: result = expResult.
	
	input := ''''''. "not single qute"
	expResult := false.
	result := GdsNull acceptableExpression: input.
	self assert: result = expResult.

	input := '" "'. "not inside space"
	expResult := false.
	result := GdsNull acceptableExpression: input.
	self assert: result = expResult.
! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/27/2009 16:56'!
testAtSubscript
	self should: [GdsNull instance atSubscript: (1 asGdsValue)] raise: GplRuntimeError.
	self should: [GdsNull instance atSubscript: (#(1 2) asGdsValue)] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '""[1]' ] raise: GplRuntimeError.
! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/27/2009 16:13'!
testFromLiteral
	self 
		should: [ GdsNull fromLiteral: '0' ]
		raise: GplSyntaxError .
	self 
		should: [ GdsNull fromLiteral: 'NULL' ]
		raise: GplSyntaxError.
	self 
		should: [ GdsNull fromLiteral: 'nil' ]
		raise: GplSyntaxError.
	self 
		should: [ GdsReal fromLiteral: '" "' ]
		raise: GplSyntaxError.
	self 
		should: [ GdsReal fromLiteral: '"' ]
		raise: GplSyntaxError.
	self 
		should: [ GdsReal fromLiteral: '''''' ]
		raise: GplSyntaxError.
	self 
		should: [ GdsReal fromLiteral: $" ]
		raise: GplSyntaxError.
	self 
		should: [ GdsReal fromLiteral: $' ]
		raise: GplSyntaxError.
	self assert: [ (GdsNull fromLiteral: '""') == GdsNull instance ]! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 6/11/2009 20:50'!
testIsList			
	self deny: [GdsNull instance isList].	
! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/24/2009 22:43'!
testMode			
	self assert: [(GdsNull instance) mode = 5].	! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:18'!
testRank			
	self assert: [GdsNull instance rank = 1].		
! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/19/2009 13:59'!
testShape			
	self assert: [GdsNull instance shape = #()].		
! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/25/2009 20:59'!
testSize			
	| result expResult |
	self assert: [GdsNull instance size = 0].		

	expResult := 0.	
	result := (GdsString fromLiteral: '""') size.
	self assert: result = expResult.	! !

!GdsNullTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:18'!
testTypeString			
	self assert: [(GdsNull instance) typeString = 'NULL'].	! !

GdsTestCase subclass: #GdsRealTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsRealTest methodsFor: 'test' stamp: 'kf 5/24/2009 22:23'!
testAcceptableExpression
	| input result expResult |
	input := '1'.
	expResult := true.
	result := GdsReal acceptableExpression: input.
	self assert: result = expResult.
	
	input := '-1'.
	expResult := true.
	result := GdsReal acceptableExpression: input.
	self assert: result = expResult.
	
	input := '+1'.
	expResult := false. "cant use +sign "
	result := GdsReal acceptableExpression: input.
	self assert: result = expResult.
	
	input := '1.0'.
	expResult := true.
	result := GdsReal acceptableExpression: input.
	self assert: result = expResult.
	
	input := '1E-17'.
	expResult := true.
	result := GdsReal acceptableExpression: input.
	self assert: result = expResult.
	
	input := '1E+17'.
	expResult := true.
	result := GdsReal acceptableExpression: input.
	self deny: [result = expResult] description: 'can''t use exponensial + sign'.
	
	input := '-1.0E+17'.
	expResult := true.
	result := GdsReal acceptableExpression: input.
	self deny: result = expResult.
	
	input := '-1.0e+17'. "disallow lowercase e on GPL"
	expResult := false.
	result := GdsReal acceptableExpression: input.
	self assert: result = expResult.
	! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 5/27/2009 16:05'!
testFromLiteral
	self assert: [(GdsReal fromLiteral: '1') asSmalltalkValue isKindOf: Float].		
	self should:  [(GdsReal fromLiteral: 'TRUE')] raise: GplSyntaxError.	
			
	self should:  [(GdsReal fromLiteral: '+1.0')] raise: GplSyntaxError.		
	self shouldnt:  [(GdsReal fromLiteral: '-1.0')] raise: GplSyntaxError.		

	self shouldnt:  [(GdsReal fromLiteral: '1E16')] raise: GplSyntaxError.		
	self should:  [(GdsReal fromLiteral: '1E+16')] raise: GplSyntaxError.		
	self should:  [(GdsReal fromLiteral: '1e-16')] raise: GplSyntaxError.		

	self assert: [(GdsReal fromLiteral: '1.000000') gplString = '1.'].		
	self assert: [(GdsReal fromLiteral: '0.000000') gplString = '0.'].		
	self assert: [(GdsReal fromLiteral: '0.1234') gplString = '.1234'].		
					! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 6/11/2009 20:51'!
testIsList			
	self deny: [(GdsReal fromLiteral: '1.0') isList].	
	! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 5/27/2009 14:12'!
testLength
	self assert: [(1.0 asGdsValue) length = 1].	
! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:08'!
testMode			
	self assert: [(GdsReal fromLiteral: '1.0') mode = 3].	
	! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 4/28/2009 01:13'!
testRank			
	self assert: [(GdsReal fromLiteral: '1.0') rank = 0].	
	self assert: [(GdsReal fromLiteral: '1.0') rank = (GdsReal fromLiteral: '1E-16') rank].		! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:10'!
testShape			
	self assert: [(GdsReal fromLiteral: '1.0') shape = #()].	
	! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:17'!
testSize			
	self assert: [(GdsReal fromLiteral: '1.0') size = 1].	

	! !

!GdsRealTest methodsFor: 'test' stamp: 'kf 5/19/2009 14:14'!
testTypeString			
	self assert: [(GdsReal fromLiteral: '1.0') typeString = 'REAL'].	
	! !

GdsTestCase subclass: #GdsScalarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsScalarTest methodsFor: 'tests' stamp: 'kf 5/26/2009 14:46'!
testApplySymbolTo
	| expResult result |
	
	"not a GdsDataStructure"
	self should: [(1 asGdsValue applySymbol: #+ to: 1) ] raise: Exception.

	"not a GdsDataStructure"
	self should: [(1 asGdsValue applySymbol: #+ to: GdsNull instance) ] raise: Exception.

	
	"{scalar} {scalar}"
	expResult := 2.0.
	result := (1 asGdsValue applySymbol: #+ to: (1 asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].
	
	"{scalar} {vector}"
	expResult := #(2.0 3.0).
	result := (1 asGdsValue applySymbol: #+ to: (#(1 2) asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].

	"{scalar} {scalar}"
	expResult := 0.0.
	result := (1 asGdsValue applySymbol: #- to: (1 asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].
	
	"{scalar} {vector}"
	expResult := #(0.0 -1.0).
	result := (1 asGdsValue applySymbol: #- to: (#(1 2) asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].

	"{scalar} {scalar}"
	expResult := 1.0.
	result := (1 asGdsValue applySymbol: #* to: (1 asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].
	
	"{scalar} {vector}"
	expResult := #(2.0 4.0).
	result := (2 asGdsValue applySymbol: #* to: (#(1 2) asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].

	"{scalar} {scalar}"
	expResult := 1.0.
	result := (1 asGdsValue applySymbol: #% to: (1 asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].
	
	"{scalar} {vector}"
	expResult := #(1.0 0.5).
	result := (1 asGdsValue applySymbol: #% to: (#(1 2) asGdsValue)) asSmalltalkValue.
	self assert: [result = expResult].

	"other alithmetic operator"
	self should: [(1 asGdsValue applySymbol: #/ to: (1 asGdsValue)) ] raise: Exception.
	self should: [(1 asGdsValue applySymbol: #// to: (1 asGdsValue)) ] raise: Exception.
	self should: [(1 asGdsValue applySymbol: #\\ to: (1 asGdsValue)) ] raise: Exception.
	
! !

!GdsScalarTest methodsFor: 'tests' stamp: 'kf 5/27/2009 16:35'!
testAtSubscript
	self should: [1 asGdsValue atSubscript: (1 asGdsValue)] raise: GplRuntimeError.
	self should: [1.0 asGdsValue atSubscript: (#(1 2) asGdsValue)] raise: GplRuntimeError.
	self should: [$a asGdsValue atSubscript: (GdsNull instance)] raise: GplRuntimeError.
	
	evaluter evaluteLine: 'S := 1'.	
	self should: [evaluter evaluteLine: 'S[1]'] raise: GplRuntimeError.

! !

!GdsScalarTest methodsFor: 'tests' stamp: 'kf 6/11/2009 20:51'!
testIsList			
	self deny: [(1.0 asGdsValue)  isList].! !

!GdsScalarTest methodsFor: 'tests' stamp: 'kf 5/27/2009 14:08'!
testLength
	self assert: [(1 asGdsValue) length = 1].
	self assert: [(1.0 asGdsValue) length = 1].	
	self assert: [(true asGdsValue) length = 1].	
	self assert: [(false asGdsValue) length = 1].		
	self assert: [($a asGdsValue) length = 1].		
		! !

GdsTestCase subclass: #GdsStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/24/2009 22:47'!
testAcceptableExpression
	self deny:  (GdsString acceptableExpression: '').
	self deny:  (GdsString acceptableExpression: '"').
	self deny:  (GdsString acceptableExpression: $' asString).		
	self assert:  (GdsString acceptableExpression: '""').				! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/27/2009 15:26'!
testApplySymbolTo
	| sample |
	sample := 'ABC' asGdsValue.
	"not a GdsDataStructure"
	self should: [(sample applySymbol: #+ to: 1) ] raise: GplError.
	
	"self + self"
	self should: [(sample applySymbol: #+ to: sample) ] raise: GplError.
	
	"self -  self"
	self should: [(sample applySymbol: #- to: sample) ] raise: GplError.
	
	"self *  self"
	self should: [(sample applySymbol: #* to: sample) ] raise: GplError.
	
	"self %  self"
	self should: [(sample applySymbol: #% to: sample) ] raise: GplError.! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/27/2009 16:43'!
testFromLiteral
	| result expResult |
	expResult := GdsNull instance.	
	result := GdsString fromLiteral: '""'.
	self assert: result = expResult.	

	self shouldnt: [(GdsString fromLiteral: '"ABC"') ] raise: GplSyntaxError.

	self should: [(GdsString fromLiteral: '"') ] raise: GplSyntaxError.
	self should: [(GdsString fromLiteral: '"ABC') ] raise: GplSyntaxError.
	self should: [(GdsString fromLiteral: '''ABC''') ] raise: GplSyntaxError.

	

	! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/25/2009 17:59'!
testFromLiteralExtension
	| result expResult msg |
	msg :=  'TODO: implement < > notation in string context'.
	
	expResult := (Character value: 0) asString .
	result := (GdsString fromLiteral: '"<NUL>"') asSmalltalkValue.
	self assert: result = expResult description: msg.
	
	expResult := (Character value: 8r7) asString .
	result := (GdsString fromLiteral: '"<BEL>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := String tab .
	result := (GdsString fromLiteral: '"<TAB>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := String lf .
	result := (GdsString fromLiteral: '"<LF>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := (Character value: 8r14) asString .
	result := (GdsString fromLiteral: '"<FF>"') asSmalltalkValue.
	self assert: result = expResult description: msg.
	
	expResult := String cr .
	result := (GdsString fromLiteral: '"<CR>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := (Character value: 8r15) asString .
	result := (GdsString fromLiteral: '"<NL>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := (Character value: 8r33) asString .
	result := (GdsString fromLiteral: '"<ESC>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := (Character value: 8r36) asString .
	result := (GdsString fromLiteral: '"<BROFF>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := (Character value: 8r37) asString .
	result := (GdsString fromLiteral: '"<BRON>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := (Character value: 8r42) asString .
	result := (GdsString fromLiteral: '"<QT>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := '<' .
	result := (GdsString fromLiteral: '"<74>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := '>' .
	result := (GdsString fromLiteral: '"<76>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := (Character value: 8r177) asString .
	result := (GdsString fromLiteral: '"<DEL>"') asSmalltalkValue.
	self assert: result = expResult description: msg.

	expResult := '"ABC"'.
	result := (GdsString fromLiteral: '"<QT>ABC<QT>"') asSmalltalkValue.
	self assert: result = expResult description: msg.
	
	expResult := 'ABC
DEF'.
	result := (GdsString fromLiteral: '"ABC<CR>DEF"') asSmalltalkValue.
	self assert: result = expResult description: msg.
	
	expResult := '<CR>'.
	result := (GdsString fromLiteral: '"<74>CR<76>"') asSmalltalkValue.
	self assert: result = expResult description: msg.
! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 6/11/2009 20:52'!
testIsList
	self deny: [(GdsString fromLiteral: '"ABC"') isList].	
! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/25/2009 20:57'!
testLength
	self assert: [(GdsString fromLiteral: '"A"') length = 1].
	self assert: [(GdsString fromLiteral: '"AB"') length = 1].
	self assert: [(GdsString fromLiteral: '"ABC"') length = 1].
			! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/19/2009 14:05'!
testMode
	| result expResult |
	expResult := 4.	
	result := (GdsString fromLiteral: '"ABC"') mode.
	self assert: result = expResult.	
! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/19/2009 13:49'!
testRank
	| result expResult |
	expResult := 1.	
	result := (GdsString fromLiteral: '"ABC"') rank.
	self assert: result = expResult.	
! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/19/2009 13:54'!
testShape
	| result expResult |
	expResult := 3.	
	result := (GdsString fromLiteral: '"ABC"') shape.
	self assert: result = expResult.	
! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/25/2009 20:58'!
testSize
	| result expResult |
	expResult := 1.	
	result := (GdsString fromLiteral: '"A"') size.
	self assert: result = expResult.	

	expResult := 2.	
	result := (GdsString fromLiteral: '"AB"') size.
	self assert: result = expResult.	

	expResult := 3.	
	result := (GdsString fromLiteral: '"ABC"') size.
	self assert: result = expResult.	

! !

!GdsStringTest methodsFor: 'tests' stamp: 'kf 5/20/2009 00:30'!
testTypeString
	| result expResult |
	expResult := 'CHAR'.	
	result := (GdsString fromLiteral: '"ABC"') typeString.
	self assert: result = expResult.	
	expResult := 'NULL'.	
	result := (GdsString fromLiteral: '""') typeString.
	self assert: result = expResult.	
! !

!GdsTestCase methodsFor: 'running' stamp: 'kf 5/25/2009 21:30'!
setUp
	super setUp.
	evaluter := GplEvaluter new.
	! !

!GdsTestCase methodsFor: 'running' stamp: 'kf 5/29/2009 11:56'!
tearDown
	evaluter := nil.
	model := nil.
	! !

GdsTestCase subclass: #GdsVectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/27/2009 15:27'!
testApplySymbolTo
	| expResult result |	
	"{vector} {scalr}"
	expResult := #(2.0 3.0 4.0).
	result := ((#(1 2 3) asGdsValue)  applySymbol: #+ to: (1 asGdsValue) ) asSmalltalkValue.
	self assert: [result = expResult].

	"{vector} {vector}"
	expResult := #(5.0 7.0 9.0).
	result := ((#(1 2 3) asGdsValue)  applySymbol: #+ to: (#(4 5 6) asGdsValue) ) asSmalltalkValue.
	self assert: [result = expResult].

	"{vector} {scalr}"
	expResult := #(0.0 1.0 2.0).
	result := ((#(1 2 3) asGdsValue)  applySymbol: #- to: (1 asGdsValue) ) asSmalltalkValue.
	self assert: [result = expResult].

	"{vector} {vector}"
	expResult := #(-3.0 -3.0 -3.0).
	result := ((#(1 2 3) asGdsValue)  applySymbol: #- to: (#(4 5 6) asGdsValue) ) asSmalltalkValue.
	self assert: [result = expResult].

	"{illigal data}"
	self should: [(#(1 2 3) asGdsValue)  applySymbol: #- to: GdsNull instance ] raise: GplError.

	"{illigal data}"
	self should: [(#(1 2 3) asGdsValue)  applySymbol: #- to: (GdsString fromLiteral: '"ABC"') ] raise: GplError.
	
	"{illigal size}"
	self should: [(#(1 2 3) asGdsValue)  applySymbol: #- to: (#(4 5 6 7) asGdsValue) ] raise: GplError
! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/29/2009 17:14'!
testAtSubscript
	self assert: [((GdsVector fromLiteral: '1 2 3') atSubscript: (1 asGdsValue)) asSmalltalkValue = 1] .
	self shouldnt: [evaluter evaluteLine: '(1 2 3)[1]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '(1 2 3)[]' ] raise: GplRuntimeError.
	self shouldnt: [evaluter evaluteLine: '(1 2 3)[1.0]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '(1 2 3)[""]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '(1 2 3)[0]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '(1 2 3)[4]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '(1 2 3)[-1]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '(1 2 3)[1;]' ] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: '(1 2 3)[;1]' ] raise: GplRuntimeError.

	evaluter evaluteLine: 'V := IOTA 3'.	
	"out of range"	
	self should: [evaluter evaluteLine: 'V[0]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V[4]'] raise: GplRuntimeError.
	"empty sabscript"
	self should: [evaluter evaluteLine: 'V[]'] raise: GplRuntimeError.

	"illigal data mode"
	self should: [evaluter evaluteLine: 'V[""]'] raise: GplRuntimeError.
	self shouldnt: [evaluter evaluteLine: 'V[1.0]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V[1.1]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V["ABC"]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V["1 2 3"]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V[2 1 RESHAPE 1]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V[1 2 RESHAPE 1]'] raise: GplRuntimeError.

	"list access"
	self should: [evaluter evaluteLine: 'V[;]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V[3;]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V[;4]'] raise: GplRuntimeError.
	self should: [evaluter evaluteLine: 'V[3;4]'] raise: GplRuntimeError.
! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/27/2009 16:20'!
testFromLiteral
	| result expResult |
	expResult := GdsVector fromLiteral: '1. 1. 0. 1.'.
	result := GdsVector fromLiteral: '1 TRUE FALSE 1.0'.
	self assert: result = expResult.
	self should: [GdsVector fromLiteral: '""'] raise: GplSyntaxError .
	self should: [GdsVector fromLiteral: '"ABC"'] raise: GplSyntaxError! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/23/2009 19:31'!
testIsAcceptableSmalltalkObject
	self assert: [(GdsVector isAcceptableSmalltalkObject: 1) = false]
		description: 'Vector not aceptable scalar value'.
	self assert: 
			[(GdsVector isAcceptableSmalltalkObject: #(
						1
						$a
						'abc'
						#baka
					)) 
				= false]
		description: 'Vector not aceptable non number value'.
	self 
		assert: [(GdsVector isAcceptableSmalltalkObject: #(false true false )) = true]
		description: 'Vector not aceptable boolean collection'.
	self assert: 
			[(GdsVector isAcceptableSmalltalkObject: #(
						1
						2
						3
						4
						5.0
						6.0
					)) 
				= true]
		description: 'Vector not aceptable non number value'.
	self assert: [(GdsVector isAcceptableSmalltalkObject: #()) = false]
		description: 'Vector not aceptable empty collection'! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 6/11/2009 20:53'!
testIsList
	self deny: [(GdsVector fromLiteral: '1 1 1 1') isList].
! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/25/2009 20:56'!
testLength
	self assert: [(GdsVector fromLiteral: '1 ') length = 1].
	self assert: [(GdsVector fromLiteral: '1 1 ') length = 1].
	self assert: [(GdsVector fromLiteral: '1 1 1') length = 1].
! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/23/2009 19:31'!
testMode
	self assert: (GdsVector fromLiteral: '1 1 1 1') mode = 1.
	self assert: (GdsVector fromLiteral: '1 1 1 1.0') mode = 3! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/23/2009 19:31'!
testShape
	self assert: (GdsVector fromLiteral: '1 1 1 1') shape = 4.
	self assert: (GdsVector fromLiteral: '1 1 1 1.0 5.0') shape = 5! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/23/2009 19:31'!
testSize
	self assert: (GdsVector fromLiteral: '1 1 1 1') size = 4.
	self assert: (GdsVector fromLiteral: '1 1 1 1.0 5.0') size = 5! !

!GdsVectorTest methodsFor: 'tests' stamp: 'kf 5/23/2009 19:31'!
testTypeString
	self assert: (GdsVector fromLiteral: '1 1 1 1') typeString = 'LOGICAL'.
	self assert: (GdsVector fromLiteral: '1 1 1 1.0 5.0') typeString = 'REAL'.
	self assert: (GdsVector fromLiteral: '1 1 256 1') typeString = 'INTEGER'! !

GdsTestCase subclass: #GplEvaluterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GplEvaluterTest methodsFor: 'tests' stamp: 'kf 5/25/2009 21:31'!
testEvaluteConsoleLine
	| input result expResult |
	input := '1'.
	expResult := '1'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := '1.00000000'.
	expResult := '1.'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := '0.0'.
	expResult := '0.'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := '0.01'.
	expResult := '.01'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := 'FALSE'.
	expResult := '0'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := 'TRUE'.
	expResult := '1'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := 'true'.	"disallow lowercase"
	expResult := '1'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result ~= expResult.	
	
	input := 'false'.	"disallow lowercase"
	expResult := '0'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result ~= expResult.	
	
	input := '"GDSII"'.
	expResult := 'GDSII'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := '"GDSII"[1]'.
	expResult := 'G'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult
	     description: 'vector [] operation must impiment'.	

	input := '1 + 1'.
	expResult := '2'.	
	result := evaluter evaluteConsoleLine: input.
	self assert: result ~= expResult.	
	
	input := '1 + 1'.
	expResult := '2.'.	
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := '+ 1'.
	expResult := '1.'.	 "monadic + is a operation like as asFloating "
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult
			description: 'monadic + must implement'.	
		
	input := '5 - 9'.
	expResult := '-4.'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
	
	input := '5-9'.
	expResult := '5 -9'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	

	input := '5- 9'.
	expResult := '-4.'.
	result := evaluter evaluteConsoleLine: input.
	self assert: result = expResult.	
! !

!GplEvaluterTest methodsFor: 'tests' stamp: 'kf 5/27/2009 15:28'!
testEvaluteJoinVector
	self should: [(evaluter evaluteLine: '"ABC" ,1')] raise: GplError.
	self should: [(evaluter evaluteLine: '1, "ABC"')] raise: GplError.	
	self assert: ((evaluter evaluteLine: '1, 1.0 2') gplString = '1. 1. 2.').
	self assert: ((evaluter evaluteLine: '1 1, 2') gplString = '1 1 2').
	self assert: ((evaluter evaluteLine: '"ABC", "DEF"') gplString = 'ABCDEF').
! !

!GplEvaluterTest methodsFor: 'tests' stamp: 'kf 5/27/2009 16:45'!
testEvaluteReshape
	self should: [evaluter evaluteLine: 'RESHAPE '] raise: GplRuntimeError.

	"missing right"
	self should: [evaluter evaluteLine: '2 3 RESHAPE '] raise: GplRuntimeError.

	"missing left"
	self should: [evaluter evaluteLine: 'RESHAPE IOTA 3'] raise: GplRuntimeError.

	"NULL Vector"
	self should: [evaluter evaluteLine: '"" RESHAPE IOTA 3'] raise: GplRuntimeError.

	"Real mode Vector"
	self should: [evaluter evaluteLine: '2.0 3.5 RESHAPE IOTA 3'] raise: GplRuntimeError.

	"Character mode Vector"
	self should: [evaluter evaluteLine: '"A B" RESHAPE IOTA 3'] raise: GplRuntimeError.

	"left operands vector max size  =  2"
	self should: [evaluter evaluteLine: '2 3 4 RESHAPE IOTA 3'] raise: GplRuntimeError.

	"not a array"
	self should: [evaluter evaluteLine: '2 3 RESHAPE ("ABC" ; 1 2 3) '] raise: GplRuntimeError.
! !

GdsTestCase subclass: #GplHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GplHandlerTest methodsFor: 'as yet unclassified' stamp: 'kf 6/5/2009 09:47'!
testIsVoid
	self assert: [
		GplToken builtinMethods allSatisfy: [:each | 
			(GplHandler isVoid: each) not]].
	! !

GdsTestCase subclass: #GplParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GplParserTest methodsFor: 'tests' stamp: 'kf 5/24/2009 22:32'!
testSplitTokens
	| input result expResult |
	input := 'var$1:=-5 + 3 + 4 + 6 - 10.'.
	expResult := { 'var$1' . ':=' . '-5' . '+' . '3' . '+' . '4' . '+' . '6' . '-' . '10.'}.
	result := GplParser splitTokens: input.
	self assert: result = expResult.	
	
	input := 'var$1 := 1 + 1'.
	expResult := { 'var$1' . ':=' . '1' . '+' . '1'}.
	result := GplParser splitTokens: input.
	self assert: result = expResult.	
	
	input := 'foo[;6]:=1+1'.
	expResult := { 'foo' . '[' . ';' . '6' . ']' . ':=' . '1' . '+' . '1'}.
	result := GplParser splitTokens: input.
	self assert: result = expResult.
	
	input := '(1234 1235 1236)[6] | Oh Bad Access!!!!'.
	expResult := #('(' '1234' '1235' '1236' ')' '[' '6' ']' '| Oh Bad Access!!!!').
	result := GplParser splitTokens: input.
	self assert: result = expResult.
	
	input := 'LABEL:K:=K+1'.
	expResult := #('LABEL' ':' 'K' ':=' 'K' '+' '1').
	result := GplParser splitTokens: input.
	self assert: result = expResult.

	input := 'IF 1 <> 2 THEN'.
	expResult := #('IF' '1' '<>' '2' 'THEN').
	result := GplParser splitTokens: input.
	self assert: result = expResult.
	
	input := '"this is a basic" INDECES_OF "fuck"    '.
	expResult := #('"this is a basic"' 'INDECES_OF' '"fuck"').
	result := GplParser splitTokens: input.
	self assert: result = expResult.

	input := 
'IF FOO = BAR THEN
  BAZ
ENDIF'.
	expResult := #('IF' 'FOO' '=' 'BAR' 'THEN' #cr 'BAZ' #cr 'ENDIF').
	result := GplParser splitTokens: input.
	self assert: result = expResult.
	
	input := 
'1 1 1 ^
+ 2 2 2'.
	expResult := #('1' '1' '1' '+' '2' '2' '2').
	result := GplParser splitTokens: input.
	self assert: result = expResult 
	     description: 'can''t eat lineEnding escape character ^'.

	input := '(1234 1235 1236)[6] ` Oh Bad Access!!!!'''.
	expResult := #('(' '1234' '1235' '1236' ')' '[' '6' ']' '` Oh Bad Access!!!!''').
	result := GplParser splitTokens: input.
	self assert: result = expResult.

	input := 'IF LIB="" THEN "<BEL>"'.
	expResult := #('IF' 'LIB' '=' '""' 'THEN' '"<BEL>"').
	result := GplParser splitTokens: input.
	self assert: result = expResult.

	input := '5-9'.
	expResult := #('5' '-9').
	result := GplParser splitTokens: input.
	self assert: result = expResult.

	input := '5 - 9'.
	expResult := #('5' '-' '9').
	result := GplParser splitTokens: input.
	self assert: result = expResult.

	input := '5- 9'.
	expResult := #('5' '-' '9').
	result := GplParser splitTokens: input.
	self assert: result = expResult.

! !

GdsTestCase subclass: #GplSyntaxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Test'!

!GplSyntaxTest methodsFor: 'as yet unclassified' stamp: 'kf 5/29/2009 12:00'!
check: aGplStatement
	| tokens |
	tokens := GplParser tokensFrom: aGplStatement.
	model checkFromTokens: tokens.! !

!GplSyntaxTest methodsFor: 'running' stamp: 'kf 5/29/2009 18:12'!
setUp
	super setUp.
	model := GplSyntax new.
	evaluter evaluteLine: 'A:=1'.
	model model: evaluter.
	! !

!GplSyntaxTest methodsFor: 'tests' stamp: 'kf 6/12/2009 08:54'!
testAssignCheck

	"not presents ':=' "
	self shouldnt: [self check: 'PAN  0 0'] raise: GplSyntaxError .

	"missing both"
	self should: [self check: ':='] raise: GplSyntaxError .
	"missing right"
	self should: [self check: 'A :='] raise: GplSyntaxError .		
	"missing left"
	self should: [self check: ':= 1'] raise: GplSyntaxError .		
	"method name"
	self should: [self check: 'COORDS := 1'] raise: GplSyntaxError .	
	"method name with subscript "
	self should: [self check: 'COORDS[1] := 1'] raise: GplSyntaxError .		
	"left operand has function call"
	self should: [self check: '(A) := 1'] raise: GplSyntaxError .	
	"left operand has function call with subscript"
	self should: [self check: '(A)[1] := 1'] raise: GplSyntaxError .			
	"right operand has non return value operation like as procedure"
	self should: [self check: 'A := CLOSELIB'] raise: GplSyntaxError .
	self should: [self check: 'A := PAN'] raise: GplSyntaxError .
	self should: [self check: 'A := MARK'] raise: GplSyntaxError .
	
	"bi context handlers"
	self shouldnt: [self check: 'A := SETVIEW'] raise: GplSyntaxError .

	"function only"
	self shouldnt: [self check: 'A := DAY'] raise: GplSyntaxError .
	self shouldnt: [self check: 'A := TOD'] raise: GplSyntaxError .

	! !

!GplSyntaxTest methodsFor: 'tests' stamp: 'kf 6/5/2009 15:10'!
testDeclareCheck

	self shouldnt: [self check: ''] raise: GplSyntaxError .
	self shouldnt: [self check: String tab] raise: GplSyntaxError .
	self shouldnt: [self check: String tab] raise: GplSyntaxError .
	
	self should: [self check: 'A := B'] raise: GplSyntaxError .
	self shouldnt: [self check: 'A[1] := 1'] raise: GplSyntaxError .
	self shouldnt: [self check: 'B := 1'] raise: GplSyntaxError .
	self shouldnt: [self check: '(1 2 3)[1]'] raise: GplSyntaxError .
	self shouldnt: [self check: 'A := (1 + 1)'] raise: GplSyntaxError .
	
	"not a command"
	self should: [self check: '(SETVIEW2)'] raise: GplSyntaxError .
	self should: [self check: 'CORDS'] raise: GplSyntaxError .

! !

!GplSyntaxTest methodsFor: 'tests' stamp: 'kf 5/29/2009 18:12'!
testDepthCheck

	
	"not presents ':=' "
	self shouldnt: [self check: 'PAN  0 0'] raise: GplSyntaxError .

	"missing right parlen"
	self shouldnt: [self check: '([A + 1])'] raise: GplSyntaxError .

	"missing right parlen"
	self should: [self check: '([A + 1]'] raise: GplSyntaxError .

	"missing left parlen"
	self should: [self check: '[A + 1])'] raise: GplSyntaxError .

	"missing right subscript"
	self should: [self check: '([A + 1)'] raise: GplSyntaxError .

	"missing left subscript"
	self should: [self check: '(A + 1])'] raise: GplSyntaxError .

	"empty paren"
	self should: [self check: '(   )[A]'] raise: GplSyntaxError .

	"empty subscript"
	self should: [self check: '(A)[ ]'] raise: GplSyntaxError .
	
	"mismatch "
	self should: [self check: '[(A + 1])'] raise: GplSyntaxError .

	"mismatch "
	self should: [self check: '([A + 1)]'] raise: GplSyntaxError .

! !

Object subclass: #GdsIoRecord
	instanceVariableNames: 'kind desc session nSplit consume fragmentSize phase base64'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Service'!

!GdsIoRecord commentStamp: 'kf 5/31/2009 23:05' prior: 0!
A GdsIoRecord is xxxxxxxxx.

Instance Variables
	consume:		<Integer>
	desc:		<Byte>
	fragmentSize:		<Integer>
	kind:		<Byte>
	nSplit:		<Integer>
	phase:		<Integer>
	session:		<Integer>

consume
	- xxxxx

desc
	- xxxxx

fragmentSize
	- xxxxx

kind
	- xxxxx

nSplit
	- xxxxx

phase
	- xxxxx

session
	- xxxxx
!

GdsIoRecord subclass: #GdsIoRecive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Service'!

!GdsIoRecive methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 00:06'!
asString
	^ GdsServer chomp: (Base64MimeConverter
		mimeDecodeToChars: (ReadStream on: base64)) contents! !

!GdsIoRecive methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 00:05'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream print: self asString.
	aStream nextPut: $).
	
	! !

!GdsIoRecord class methodsFor: 'constants' stamp: 'kf 6/1/2009 14:04'!
bufferSize
	^2000! !

!GdsIoRecord class methodsFor: 'accessing' stamp: 'kf 6/1/2009 14:04'!
fragmentSize
	^self bufferSize - self headerSize ! !

!GdsIoRecord class methodsFor: 'instance creation' stamp: 'kf 5/31/2009 18:01'!
fromByteArray: aByteArray
	^self new byteArray: aByteArray! !

!GdsIoRecord class methodsFor: 'constants' stamp: 'kf 6/1/2009 14:04'!
headerSize
	^20! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 14:56'!
base64
	^base64! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 14:56'!
base64: aString
	base64 := aString.
	fragmentSize := aString size.! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 5/31/2009 23:34'!
byteArray: aByteArray
	| stream  |
	self assert: aByteArray size = 2000.
	stream := aByteArray readStream.
	phase := stream next.
	kind := stream next.
	desc := stream next.
	stream next. "padd"
	session := stream nextInt32. 
	nSplit := stream nextInt32.
	consume := stream nextInt32.
	fragmentSize := stream nextInt32.
	base64 := (stream next: fragmentSize) asString
	 ! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 14:31'!
consume: aNumber
	consume := aNumber
	 ! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 15:47'!
contentsOn: aWriteStream
	| fillSize |
	self headerOn: aWriteStream.
	aWriteStream nextPutAll: self base64 asByteArray.
	fillSize := self class bufferSize - (self class headerSize + fragmentSize).
	fillSize timesRepeat: [aWriteStream nextPut:0 ].

	 ! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 5/31/2009 18:23'!
hasMoreData
	^consume < nSplit ! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 15:42'!
headerOn: aWriteStream
	aWriteStream nextPut: phase.
	aWriteStream nextPut: kind.
	aWriteStream nextPut: desc.
	aWriteStream nextPut: 0.
	aWriteStream nextInt32Put: session.
	aWriteStream nextInt32Put: nSplit.
	aWriteStream nextInt32Put: consume.
	aWriteStream nextInt32Put: fragmentSize.

	 ! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 14:21'!
initialize
	phase := self sessionRunLoop .
	kind := self typeNormal.
	desc := 1.
	session := 1.
	nSplit := 1.
	consume := 1.
	fragmentSize := 0.
	base64 := ''.
	 ! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/3/2009 14:11'!
isSessionEnter
	^ phase = self sessionEnter! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/3/2009 14:11'!
isSessionExit
	^ phase = self sessionExit! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:17'!
isTypeNormal
	^kind =  self typeNormal! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:17'!
isTypePrompt
	^kind = self typePrompt! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:17'!
isTypePromptReply
	^kind =  self typePromptReply! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 15:08'!
nSplit: aNumber
	nSplit := aNumber! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 5/31/2009 18:29'!
session
	^session! !

!GdsIoRecord methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 14:21'!
session: aNumber
	session := aNumber
	 ! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:18'!
sessionEnter
	^1! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:18'!
sessionExit
	^2! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:18'!
sessionRunLoop
	^0! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/8/2009 14:52'!
type: aInteger
	({ self typeNormal . self typePrompt . self typePromptReply . self typeCodeComplete}
		includes: aInteger)
		ifFalse: [^self error: 'invarid argument for #type:'].
	kind := aInteger! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/8/2009 13:24'!
typeCodeComplete
	^3! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:16'!
typeNormal
	^0! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:16'!
typePrompt
	^1! !

!GdsIoRecord methodsFor: 'testing' stamp: 'kf 6/1/2009 14:16'!
typePromptReply
	^2! !

GdsIoRecord subclass: #GdsIoReply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Service'!

!GdsIoReply class methodsFor: 'as yet unclassified' stamp: 'kf 6/8/2009 14:12'!
consume: aindex  base64: aString
	| reply |
	reply := self  new.
	reply consume: aindex.
	reply base64: aString.
	^reply
	 ! !

!GdsIoReply methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 15:48'!
contents
	| s |
	s := WriteStream on: (ByteArray new: self class bufferSize).
	self contentsOn: s.
	^s contents.
	! !

!GdsIoReply methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 14:50'!
message: aString
	self base64: (Base64MimeConverter
		mimeDecodeToBytes: (ReadStream on: aString)) contents.
			! !

Object subclass: #GdsIoSession
	instanceVariableNames: 'session records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Service'!

!GdsIoSession commentStamp: 'kf 5/31/2009 23:05' prior: 0!
A GdsIoSession is xxxxxxxxx.

Instance Variables
	records:		<OrderedCollection>
	session:		<Integer>

records
	- xxxxx

session
	- xxxxx
!

!GdsIoSession methodsFor: 'as yet unclassified' stamp: 'kf 5/31/2009 18:32'!
addRecord: aGdsIoRecord
	records ifNil: [records := OrderedCollection new].
	records add: aGdsIoRecord.
	! !

!GdsIoSession methodsFor: 'as yet unclassified' stamp: 'kf 6/3/2009 14:15'!
asString
	records ifEmpty: [^''].
	records size = 1 
		ifTrue: [^records first asString].
	^(records collect: [:each | each asString ]) joinUsing: String cr.! !

!GdsIoSession methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 13:51'!
hasMoreData
	^records  last hasMoreData! !

!GdsIoSession methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 14:30'!
initialize
	super initialize.
	records := OrderedCollection new.
	! !

!GdsIoSession methodsFor: 'as yet unclassified' stamp: 'kf 6/1/2009 11:28'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	records size = 1 
		ifTrue: [aStream print: records first asString ].
	aStream nextPut: $).	! !

!GdsIoSession methodsFor: 'as yet unclassified' stamp: 'kf 5/31/2009 18:25'!
session
	^session
	! !

!GdsIoSession methodsFor: 'as yet unclassified' stamp: 'kf 5/31/2009 18:25'!
session: aNumber
	session := aNumber 
	! !

GdsIoSession subclass: #GdsRecieveSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Service'!

GdsIoSession subclass: #GdsReplySession
	instanceVariableNames: 'isPrompt isCodeComplete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Service'!

!GdsReplySession methodsFor: 'initialize-release' stamp: 'kf 6/8/2009 14:07'!
initialize
	super initialize.
	isPrompt  := false.
	isCodeComplete := false.! !

!GdsReplySession methodsFor: 'testing' stamp: 'kf 6/8/2009 14:07'!
isCodeComplete
	^isCodeComplete! !

!GdsReplySession methodsFor: 'testing' stamp: 'kf 6/5/2009 16:14'!
isPrompt
	^isPrompt! !

!GdsReplySession methodsFor: 'accessing' stamp: 'kf 6/1/2009 15:17'!
message
	| stream |
	stream := WriteStream on: (String new: 4096).
	records do: [:each |
		stream nextPutAll: each base64].
	^(Base64MimeConverter
		mimeDecodeToChars: stream contents readStream) contents	! !

!GdsReplySession methodsFor: 'accessing' stamp: 'kf 6/8/2009 14:16'!
message: aString
	| base64 nSplit unit rest start end fragment reply consume |
	records := OrderedCollection new.
	base64 := (Base64MimeConverter
		mimeEncode: (ReadStream on: aString)) contents.	
	unit := GdsIoReply fragmentSize.
	nSplit := base64 size // unit.
	rest := base64 size \\ unit.
	consume := 1.

	1 to: nSplit do: [:index |
		start := (index - 1) * unit + 1.
		end := start + unit - 1.
		fragment := base64 copyFrom: start to: end .
		reply := GdsIoReply consume: index base64: fragment.
		self addRecord: reply.
		consume := consume + 1].
	
	rest > 0
		ifTrue: [
			nSplit := nSplit + 1.
			reply := GdsIoReply consume:  consume base64: (base64 last: rest).
			self addRecord: reply.].

	records 
		ifEmpty: [
			reply := GdsIoReply consume:  consume base64: ''.
			self addRecord: reply.].

	self setSplitNumber: nSplit.
! !

!GdsReplySession methodsFor: 'action' stamp: 'kf 6/8/2009 17:11'!
send: aSocket
	| data |
	self assert: [records isEmpty not].
	records do: [:each |
		data := each contents .
		"data explore."
		aSocket sendData: data].
	records := nil.! !

!GdsReplySession methodsFor: 'accessing' stamp: 'kf 6/8/2009 14:06'!
setCodeCompleteState: aBoolean
	isCodeComplete := aBoolean.
	! !

!GdsReplySession methodsFor: 'accessing' stamp: 'kf 6/5/2009 16:12'!
setPrommptState: aBoolean
	isPrompt := aBoolean.
	! !

!GdsReplySession methodsFor: 'accessing' stamp: 'kf 6/8/2009 14:15'!
setSplitNumber: nSplit
	records do: [:each | 
		each session: self session.
		self isPrompt 
			ifTrue: [
				each type: each typePrompt].
		self isCodeComplete  
			ifTrue: [
				each type: each typeCodeComplete ].
		each nSplit: nSplit].
! !

Object subclass: #GdsObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

GdsObject subclass: #GdsDataStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsDataStructure commentStamp: 'kf 5/21/2009 13:24' prior: 0!
A GdsDataStructure is abstract class for GPLII core data.

Instance Variables

!

GdsDataStructure subclass: #GdsArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsArray methodsFor: 'arithmetic' stamp: 'kf 5/27/2009 16:33'!
applySymbol: aSymbol to: aObject 
	| col |
	self applySymbolCheck: aSymbol to: aObject.
	self assert: [self isScalar not].
	
	((aObject isMemberOf: GdsVector) or: [(aObject isMemberOf: GdsMatrix) ])
		ifTrue: 
			[self size = aObject size ifFalse: [^self runtimeError: 'ILLIGAL DATA SIZE'].
			col := OrderedCollection new.
			self elements doWithIndex: 
					[:value :index | 
					col add: ((value perform: aSymbol with: (aObject at: index)))].
			^ GdsVector withAll: col].
	^ GdsVector withAll: (self elements 
				collect: [:value | (value perform: aSymbol with: aObject)])! !

!GdsArray methodsFor: 'convert' stamp: 'kf 5/23/2009 23:17'!
asGdsFloating
	^ self vectorClass withAll: (self elements collect: [:v | v asGdsFloating])! !

!GdsArray methodsFor: 'error handling' stamp: 'kf 5/23/2009 23:32'!
doesNotUnderstand: aMessage
	"Transcript cr; show: aMessage."
	^self newElementSelector: aMessage selector.
! !

!GdsArray methodsFor: 'private' stamp: 'kf 5/23/2009 23:21'!
newElementSelector: aSelector 
	^ self vectorClass withAll: (self elements collect: [:v | v perform: aSelector])! !

!GdsArray methodsFor: 'testing' stamp: 'kf 5/28/2009 15:49'!
sameAsInteger
	^ self asVector elements allSatisfy: [:v | v sameAsInteger]! !

GdsArray subclass: #GdsMatrix
	instanceVariableNames: 'stMatrix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsMatrix commentStamp: 'kf 5/21/2009 13:24' prior: 0!
A GdsDataMatrix is GPLII's Matrix.

Instance Variables
	stMatrix:		<Matrix<GdsDglType>>

stMatrix
	- sclar elements Smallk's value holder 
!

!GdsMatrix class methodsFor: 'as yet unclassified' stamp: 'kf 5/19/2009 00:29'!
fromGdsVector: aGdsDataVector col: aColCount 
	^self fromGdsVector: aGdsDataVector  row: 1 col: aColCount! !

!GdsMatrix class methodsFor: 'as yet unclassified' stamp: 'kf 5/19/2009 00:27'!
fromGdsVector: aGdsDataVector row: aRowCount col: aColCount 
	| size fillSize appends total fillCount vector |
	vector := aGdsDataVector asVector.
	size := aColCount * aRowCount.
	fillSize := 0.
	total := OrderedCollection new.
	appends := #().
	(vector size < size )
		ifTrue: [
			fillSize := size rem: vector size.
			fillCount := size quo: vector size.
			fillCount timesRepeat: [total addAll: vector elements].
			appends := fillSize > 0 
				ifTrue: [
					vector copyFrom: 1 to: fillSize] ifFalse: [appends]]
		ifFalse: [total addAll: (vector copyFrom: 1 to: size)].
	total addAll: appends.
	^self new rows: aRowCount columns: aColCount contents: total.
		! !

!GdsMatrix class methodsFor: 'as yet unclassified' stamp: 'kf 5/30/2009 09:58'!
fromOrigin: anOrigin corner: aCorner
	| gplVec |
	gplVec := {anOrigin x . anOrigin y . aCorner x . aCorner y} asGdsValue.
	^GdsMatrix fromGdsVector: gplVec  row: 2 col: 2. ! !

!GdsMatrix class methodsFor: 'as yet unclassified' stamp: 'kf 5/30/2009 10:03'!
fromRectangle: aRectangle
	^self fromOrigin: aRectangle  origin corner: aRectangle corner! !

!GdsMatrix class methodsFor: 'accessing' stamp: 'kf 4/26/2009 11:51'!
rank
	^2! !

!GdsMatrix methodsFor: 'arithmetic' stamp: 'kf 6/7/2009 17:50'!
applySymbol: aSymbol to: aObject 
	| target calcedVec |
	self applySymbolCheck: aSymbol to: aObject.
	self assert: [self isScalar not].
	target := aObject.
	((aObject isKindOf: GdsScalar) or: [aObject isMemberOf: GdsMatrix]) 
		ifTrue: [
			target := aObject asVector: self size ]
		ifFalse: [
			(self shape = aObject shape)
				ifFalse: [^self error: 'INVALID SHAPE ']].
	calcedVec := self asVector applySymbol: aSymbol to: target.
	^self  fromGdsVector: calcedVec! !

!GdsMatrix methodsFor: 'convert' stamp: 'kf 5/26/2009 15:21'!
asGdsFloating
	^ self fromGdsVector:  super asGdsFloating! !

!GdsMatrix methodsFor: 'convert' stamp: 'kf 5/23/2009 22:48'!
asVector
	^ self vectorClass withAll: stMatrix contents copy! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 6/10/2009 16:25'!
at: aInteger
	^[self asVector at: aInteger] on: Error do: [:ex |
		self runtimeError: 'SUBSCRIPTION OUT OF RANGE'].! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/23/2009 22:38'!
at: rowIndex at: columnIndex
	^stMatrix at: rowIndex at: columnIndex! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/25/2009 23:05'!
atSubscript: aSubscript 
	| mat result |
	"self subscriptArgumentCheck: aSubscript."
	mat := self subscriptMatrix: aSubscript.
	(mat rowCount = 1 and: [mat columnCount = 1]) 
		ifTrue: [^ (mat at: 1 at: 1) copy].
	(mat rowCount = 1 and: [mat columnCount ~= 1]) 
		ifTrue: [^ self vectorClass withAll: (mat atRow: 1)].
	(mat rowCount ~= 1 and: [mat columnCount = 1]) 
		ifTrue: [^ self vectorClass withAll: (mat atColumn: 1)].
	result := self class new.
	result instVarNamed: 'stMatrix' put: mat copy.
	^ result! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/25/2009 23:05'!
atSubscript: aSubscript put: aGdsValue
	| mat  pair pairs reshapedValue |
	"self subscriptArgumentCheck: aSubscript."
	mat := self subscriptIndexMatrix: aSubscript.
	reshapedValue := aGdsValue.
	(mat rowCount = 1 and: [mat columnCount = 1]) 
		ifTrue: [
			(aGdsValue isKindOf: GdsScalar)
				ifFalse: [self error: 'ONLY: [r;c] := {Scalar}']. 
			pair :=mat at: 1 at: 1.
			stMatrix at: pair first at: pair second put: aGdsValue copy.
			^aGdsValue].
				
	(mat rowCount = 1 and: [mat columnCount ~= 1]) 
		ifTrue: [
			(aGdsValue isKindOf: GdsScalar)
				ifTrue: [reshapedValue := aGdsValue asVector: stMatrix columnCount ].
			(reshapedValue isKindOf: GdsVector)
				ifFalse: [^self error: 'ONLY: [r; ] := {Vector}']. 
			(reshapedValue size = stMatrix columnCount)
				ifFalse: [^self error: 'VECTOR SIZE MUST: ', stMatrix columnCount asString, ' BUT: ', reshapedValue size asString].
			pairs :=mat atRow: 1.
			pairs do: [:each |
				stMatrix 
					atRow: each first
					put: (reshapedValue elements)].
				^aGdsValue].
			
	(mat rowCount ~= 1 and: [mat columnCount = 1]) 
		ifTrue: [
			(aGdsValue isKindOf: GdsScalar)
				ifTrue: [reshapedValue := aGdsValue asVector: stMatrix rowCount].
			(reshapedValue isKindOf: GdsVector)
				ifFalse: [^self error: 'ONLY: [;c] := {Vector}']. 
			(reshapedValue size = stMatrix rowCount)
				ifFalse: [^self error: 'VECTOR SIZE MUST: ', stMatrix rowCount asString, ' BUT: ', aGdsValue size asString].
			pairs :=mat atColumn: 1.
			pairs do: [:each |
				stMatrix 
					atColumn: each second
					put: (reshapedValue elements )].
				^aGdsValue].

	(aGdsValue isKindOf: GdsScalar)
		ifTrue: [
			reshapedValue := GdsMatrix
				fromGdsVector: aGdsValue  row: mat rowCount  col: mat columnCount.].
	((Array with: mat rowCount with: mat columnCount)  = aGdsValue shape)
		ifFalse: [^self error: 'SUBSCRIPT SHAPE MISS MATCH MUST: '].
	(1 to: mat rowCount) do: [:ri |
		(1 to: mat columnCount) do: [:ci |
			pair :=mat at: ri at: ci.
			stMatrix at: pair first at: pair second put: (reshapedValue at: ri at: ci) copy].].
	^ aGdsValue! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/22/2009 23:58'!
columnCount
	^stMatrix columnCount! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/23/2009 18:02'!
elements
	^stMatrix readStream contents asArray.! !

!GdsMatrix methodsFor: 'instance creation' stamp: 'kf 5/26/2009 15:20'!
fromGdsScalar: aGdsScalar
	self assert: [(aGdsScalar isKindOf: GdsScalar)].
	^self class 
			fromGdsVector: (aGdsScalar asVector: self size) 
			row: self rowCount
			col: self columnCount.
	! !

!GdsMatrix methodsFor: 'instance creation' stamp: 'kf 6/12/2009 09:10'!
fromGdsVector: aGdsVector
	self assert: [(aGdsVector isMemberOf: GdsVector) or: [aGdsVector isCharVector]].
	^self class 
			fromGdsVector: (aGdsVector) 
			row: self rowCount
			col: self columnCount.
	! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/20/2009 15:46'!
gplString
	(self typeString startsWith: 'REAL')
		ifTrue: [^self gplStringFloating].
	^self gplStringNonFloating ! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 5/23/2009 19:31'!
gplStringFloating
	| maxWidths strings |
	(stMatrix contents anySatisfy: [:each | each gplString includes: $E]) 
		ifTrue: [^ self gplStringNonFloating].
	maxWidths := self maxGplStringWidthPair.
	strings := OrderedCollection new.
	1 to: stMatrix rowCount
		do: 
			[:index | 
			strings add: (GdsVector 
						gplStringValues: (stMatrix atRow: index)
						paddLeftWidth: maxWidths first
						rightWidth: maxWidths second)].
	^ strings joinUsing: String cr! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 5/23/2009 19:31'!
gplStringNonFloating
	| strings maxWidth |
	maxWidth := self maxGplStringWidth.
	strings := OrderedCollection new.
	1 to: stMatrix rowCount
		do: 
			[:index | 
			strings 
				add: (GdsVector gplStringValues: (stMatrix atRow: index) paddWidth: maxWidth)].
	^ strings joinUsing: String cr! !

!GdsMatrix methodsFor: 'convert' stamp: 'kf 5/23/2009 19:31'!
gplValueOfShape
	^ GdsVector withAll: { 
				(GdsInteger fromLiteral: stMatrix rowCount).
				(GdsInteger fromLiteral: stMatrix columnCount)}! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 5/23/2009 21:43'!
indexesOf: aGdsDataStructure at: aIndex
	| indexes gplValue ranges outRanges |
	ranges := (1 to: (aIndex = 1 ifTrue: [self rowCount] ifFalse: [self columnCount])). 	indexes := ranges asArray.
		
	gplValue := aGdsDataStructure at: aIndex.
	gplValue rank = 0
		ifTrue: [
			indexes := Array with: gplValue asSmalltalkValue.].
	(gplValue rank = 1 and: [gplValue ~= GdsNull instance])
		ifTrue: [
			indexes := gplValue asSmalltalkValue].
	outRanges := (indexes reject: [:each | ranges includes: each ]).
	outRanges isEmpty ifFalse: [^self error: 'SUBSCRIPT OUT OF RANGE ', outRanges printString].
	^indexes.	! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 5/20/2009 15:21'!
maxGplStringWidth
	^(stMatrix contents collect: [:each | each gplString size]) max! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 5/20/2009 17:23'!
maxGplStringWidthPair
	"{ leftWidth . rightWidth }" 
	| leftMax rightMax |
	leftMax := 0.
	rightMax := 0.
	stMatrix contents do: [:each |
		| s items| 
		s := each gplString.
		items := { s copyFrom: 1 to: (s indexOf: $.) - 1 . s copyFrom: (s indexOf: $.) + 1 to: (s size) }.
		leftMax := leftMax max: (items first size).
		rightMax := rightMax max: (items second size).].
	^Array with:  leftMax with: rightMax! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/19/2009 00:46'!
mode
	stMatrix  ifNil: [^GdsNull mode].
	stMatrix asOrderedCollection ifEmpty: [^GdsNull mode].
	^stMatrix asOrderedCollection first mode! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 6/7/2009 17:57'!
newElementSelector: aSelector 
	| gdsArray |
	gdsArray := super newElementSelector: aSelector.
	^self class fromGdsVector: gdsArray row: self rowCount col: self columnCount
! !

!GdsMatrix methodsFor: 'printing' stamp: 'kf 5/23/2009 19:31'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	(1 to: stMatrix rowCount) do: 
			[:index | 
			aStream nextPut: $[.
			aStream nextPutAll: (GdsVector gplStringValues: (stMatrix atRow: index)).
			aStream nextPut: $].
			aStream nextPut: $,].
	aStream skip: -1.
	aStream nextPut: $)! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/22/2009 23:58'!
rowCount
	^stMatrix rowCount! !

!GdsMatrix methodsFor: 'initialize-release' stamp: 'kf 5/18/2009 22:50'!
rows: rows columns: columns contents: anArray
	stMatrix := Matrix rows: rows columns: columns contents: anArray.! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/19/2009 01:15'!
shape
	^Array with: stMatrix rowCount with: stMatrix columnCount! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/19/2009 01:13'!
size
	^stMatrix size! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/25/2009 23:52'!
subscriptCheckFor: aSubscript 
	(aSubscript isMemberOf: GdsList) 
		ifFalse: [^ self error: 'ILLIGAL SUBSCRIPT ACCESS. only [row;col]'].
	aSubscript length = 2 
		ifFalse: [^ self error: 'ILLIGAL SUBSCRIPT ACCESS. only [row;col]'].
	super subscriptCheckFor: (aSubscript at: 1).
	super subscriptCheckFor: (aSubscript at: 2).
	^aSubscript! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 5/23/2009 20:47'!
subscriptIndexMatrix: aGdsDataStructure
	| rowIndexes columnIndexes  mat |
	rowIndexes := self indexesOf: aGdsDataStructure at: 1.
	columnIndexes := self indexesOf: aGdsDataStructure at: 2.
	mat := Matrix rows: rowIndexes size columns: columnIndexes size.
	rowIndexes doWithIndex: [:ra :ri |
		columnIndexes doWithIndex: [:ca :ci |
			mat at: ri at: ci  put: (Array with: ra with: ca).]].
	^mat.
	! !

!GdsMatrix methodsFor: 'private' stamp: 'kf 5/23/2009 00:44'!
subscriptMatrix: aGdsDataStructure
	| rowIndexes columnIndexes  mat |
	rowIndexes := self indexesOf: aGdsDataStructure at: 1.
	columnIndexes := self indexesOf: aGdsDataStructure at: 2.
	mat := Matrix rows: rowIndexes size columns: columnIndexes size.
	rowIndexes doWithIndex: [:ra :ri |
		columnIndexes doWithIndex: [:ca :ci |
			mat at: ri at: ci  put: (stMatrix at: ra at: ca).]].
	^mat.
	! !

!GdsMatrix methodsFor: 'accessing' stamp: 'kf 5/19/2009 14:44'!
typeString
	stMatrix  ifNil: [^GdsNull typeString].
	stMatrix asOrderedCollection ifEmpty: [^GdsNull typeString].
	^stMatrix asOrderedCollection first typeString! !

GdsArray subclass: #GdsScalar
	instanceVariableNames: 'stringValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsScalar commentStamp: 'kf 5/21/2009 13:22' prior: 0!
A GdsDataScalar is GPLII's Scalar.

Instance Variables
	stringValue:		<ByteSyting>

stringValue
	- GPLII literal expression.
!

GdsScalar subclass: #GdsDglType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsDglType commentStamp: 'kf 11/10/2008 22:35' prior: 0!
A GdsDglType is DATAGENERAL DATA TYPES.

Instance Variables
!

GdsDglType subclass: #GdsCharacter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsCharacter commentStamp: 'kf 4/21/2009 23:34' prior: 0!
A GdsCharacter is Character on GDSII.

Character literal expression is not GPL.

"A" is a shpe 1 vector.
real character represents "A"[1].

special characters are:

readable notation           octal notation
"<NUL>"          equivarent "<0>"
"<BEL>"          equivarent "<7>"
"<TAB>"          equivarent "<11>"
"<LF>"           equivarent "<12>"
"<FF>"           equivarent "<14>"
"<CR>"           equivarent "<15>"
"<NL>"           equivarent "<15>"
"<ESC>"          equivarent "<33>"
"<BROFF>"        equivarent "<36>"
"<BRON>"         equivarent "<37>"
"<QT>"           equivarent "<42>"
                            "<74>"   less than
                            "<75>"   grator than
"<DEL>"          equivarent "<177>"


 

!

!GdsCharacter class methodsFor: 'accessing' stamp: 'kf 4/21/2009 22:12'!
acceptRegexPattern
	^'[0-9]+'! !

!GdsCharacter class methodsFor: 'testing' stamp: 'kf 4/22/2009 16:02'!
acceptableExpression: aString
	^false.! !

!GdsCharacter class methodsFor: 'instance creation' stamp: 'kf 4/27/2009 17:04'!
fromAsciiValue: asciiValue
	^self new stringValue: asciiValue! !

!GdsCharacter class methodsFor: 'instance creation' stamp: 'kf 4/27/2009 17:07'!
fromLiteral: aString
	^self error: 'GdsCharacter can''t instanciate by #fromLiteral:'! !

!GdsCharacter class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 15:38'!
fromSmalltalk: aObject
	^self fromAsciiValue: aObject asciiValue ! !

!GdsCharacter class methodsFor: 'testing' stamp: 'kf 5/23/2009 14:20'!
isAcceptableSmalltalkObject: anObject
	^anObject isCharacter and: [anObject isOctetCharacter]! !

!GdsCharacter class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:42'!
maxValue
	^255! !

!GdsCharacter class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:42'!
minValue
	^0! !

!GdsCharacter class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:40'!
mode
	^4! !

!GdsCharacter class methodsFor: 'accessing' stamp: 'kf 11/11/2008 17:28'!
storageCost
	^ 1! !

!GdsCharacter class methodsFor: 'accessing' stamp: 'kf 4/27/2009 21:24'!
typeString
	^'CHAR'! !

!GdsCharacter methodsFor: 'as yet unclassified' stamp: 'kf 4/26/2009 15:50'!
gplString
	^(Character value: (self asSmalltalkValue asInteger)) asString! !

!GdsDglType class methodsFor: 'testing' stamp: 'kf 4/21/2009 22:38'!
acceptableExpression: aString
	|num|
	(aString matchesRegex: self acceptRegexPattern)
		ifFalse: [^false].
	num := aString asNumber.
	num ifNil: [^false].
	^(num >= self minValue) and: [num <= self maxValue]! !

!GdsDglType class methodsFor: 'private' stamp: 'kf 4/22/2009 16:08'!
bestClassOfStatement: aString
	| classes |
	classes := (self handledClassesOfStatement: aString) asArray.
	classes ifEmpty: [^nil].
	classes size = 1 ifTrue: [^classes last].
	^(classes sort: [:a :b | a storageCost < b storageCost]) first.! !

!GdsDglType class methodsFor: 'printing' stamp: 'kf 11/11/2008 20:40'!
displayName
	^(self name asString allButFirst: 3) asUppercase.! !

!GdsDglType class methodsFor: 'private' stamp: 'kf 4/26/2009 12:00'!
handledClassesOfStatement: aString
	^self instanciateClasses select: [:clazz |
		clazz acceptableExpression: aString]! !

!GdsDglType class methodsFor: 'private' stamp: 'kf 4/27/2009 21:22'!
instanciateClasses 
	^{ GdsBoolean . GdsCharacter . GdsInteger . GdsInteger2. GdsReal}.! !

!GdsDglType class methodsFor: 'accessing' stamp: 'kf 4/26/2009 12:19'!
maxValue
	self subclassResponsibility.
! !

!GdsDglType class methodsFor: 'accessing' stamp: 'kf 4/26/2009 12:19'!
minValue
	self subclassResponsibility.
! !

!GdsDglType class methodsFor: 'accessing' stamp: 'kf 4/27/2009 14:56'!
precisionRank
	^-1! !

!GdsDglType class methodsFor: 'accessing' stamp: 'kf 5/19/2009 14:13'!
shape
	^#() copy! !

!GdsDglType class methodsFor: 'accessing' stamp: 'kf 4/26/2009 12:03'!
storageCost
	^ 0! !

!GdsDglType class methodsFor: 'accessing' stamp: 'kf 4/24/2009 13:45'!
typeString
	^self name asString asUppercase allButFirst: 3.! !

!GdsDglType methodsFor: 'convert' stamp: 'kf 4/25/2009 14:56'!
asSmalltalkValue
	^self stringValue asNumber! !

!GdsDglType methodsFor: 'printing' stamp: 'kf 11/11/2008 20:42'!
displayName
	^self class displayName! !

!GdsDglType methodsFor: 'as yet unclassified' stamp: 'kf 4/21/2009 21:42'!
maxValue
	self class maxValue.! !

!GdsDglType methodsFor: 'as yet unclassified' stamp: 'kf 4/21/2009 21:42'!
minValue
	self class minValue.! !

!GdsDglType methodsFor: 'as yet unclassified' stamp: 'kf 4/23/2009 23:38'!
storageCost
	^self class storageCost! !

!GdsDglType methodsFor: 'accessing' stamp: 'kf 4/24/2009 13:45'!
typeString
	^self class typeString.! !

GdsDglType subclass: #GdsNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

GdsNumber subclass: #GdsBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsBoolean commentStamp: 'kf 4/21/2009 23:08' prior: 0!
A GdsBoolean is Boolean value on GDSII.

storage cost: 1byte

1 -> TRUE
0 -> FLASE
TRUE -> TRUE
FALSE -> FALSE

Instance Variables
!

!GdsBoolean class methodsFor: 'accessing' stamp: 'kf 4/21/2009 22:12'!
acceptRegexPattern
	^'[01]|TRUE|FALSE'! !

!GdsBoolean class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 14:40'!
fromSmalltalk: aObject
	aObject = true ifTrue: [ ^self new stringValue: '1'].
	aObject = false ifTrue: [ ^self new stringValue: '0'].
	^self new stringValue: aObject asString.! !

!GdsBoolean class methodsFor: 'test' stamp: 'kf 5/23/2009 14:39'!
isAcceptableSmalltalkObject: anObject
	(anObject isKindOf: Boolean) ifTrue: [^true].
	^anObject isInteger and: [anObject  = 1 or: [anObject = 0]].! !

!GdsBoolean class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:43'!
maxValue
	^1! !

!GdsBoolean class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:43'!
minValue
	^0! !

!GdsBoolean class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:41'!
mode
	^1! !

!GdsBoolean class methodsFor: 'accessing' stamp: 'kf 4/27/2009 14:57'!
precisionRank
	^1! !

!GdsBoolean class methodsFor: 'accessing' stamp: 'kf 11/11/2008 17:28'!
storageCost
	^ 1! !

!GdsBoolean class methodsFor: 'accessing' stamp: 'kf 5/19/2009 14:24'!
typeString
	^'LOGICAL'! !

!GdsBoolean methodsFor: 'convert' stamp: 'kf 4/25/2009 14:56'!
asSmalltalkValue
	self stringValue = 'TRUE'
		ifTrue: [^1].
	self stringValue = 'FALSE'
		ifTrue: [^0].
	^super asSmalltalkValue 	
		! !

GdsNumber subclass: #GdsFloating
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsFloating commentStamp: 'kf 4/25/2009 15:28' prior: 0!
A GdsFloating is abstract class for Real number on GDSII.

0		represents: 0.
1.0		represents: 1.
0.1		represents: .1
1.0e-6	represents: 1.0E-6  disallow small capital 'e'

	


!

!GdsFloating class methodsFor: 'accessing' stamp: 'kf 4/27/2009 16:18'!
acceptRegexPattern
	"'(\+|-)?([0-9]+\.?[0-9]*|\.[0-9]+)([eE](\+|-)?[0-9]+)?'" "stnard"
	"GPL disallow lowercase e
	OK: 1E6
	OK  1E-6
	NG  1E+6  -> invalid token #('1E' '+' '6')
	"
	^'(-)?([0-9]+\.?[0-9]*|\.[0-9]+)([E](-)?[0-9]+)?'! !

!GdsFloating class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 15:29'!
fromSmalltalk: aObject
	^GdsReal new stringValue: aObject asString.! !

!GdsFloating class methodsFor: 'test' stamp: 'kf 5/23/2009 14:06'!
isAcceptableSmalltalkObject: anObject
	^anObject isNumber and: [anObject isKindOf: Float].! !

!GdsFloating class methodsFor: 'accessing' stamp: 'kf 4/26/2009 00:16'!
maxValue
	^7.24e75! !

!GdsFloating class methodsFor: 'accessing' stamp: 'kf 4/26/2009 00:16'!
minValue
	^-7.24e75! !

!GdsFloating class methodsFor: 'accessing' stamp: 'kf 4/24/2009 00:27'!
mode
	^3! !

!GdsFloating methodsFor: 'convert' stamp: 'kf 4/27/2009 16:03'!
asSmalltalkValue
	^self stringValue asLowercase asNumber asFloat.! !

!GdsFloating methodsFor: 'convert' stamp: 'kf 4/26/2009 12:16'!
gplString
	| expr |
	expr := super gplString.
	(expr endsWith: '.0')
		ifTrue: [^expr allButLast: 1].
	(expr startsWith: '-0.')
		ifTrue: [^'-.', (expr allButFirst: 3)].
	(expr startsWith: '0.')
		ifTrue: [^'.', (expr allButFirst: 2)].	
	^expr asUppercase! !

!GdsFloating methodsFor: 'convert' stamp: 'kf 5/20/2009 17:22'!
gplStringLeftWidth: aLeftWidth rightWidth: aRightWidth
	| gs items |
	gs := self gplString.
	items := { gs copyFrom: 1 to: (gs indexOf: $.) - 1 . gs copyFrom: (gs indexOf: $.) + 1 to: (gs size) }.
	^String streamContents: [:s |
		s nextPutAll: (items first padded: #left to: aLeftWidth with: Character space).
		s nextPut: $. .
		s nextPutAll: (items second padded: #right to: aRightWidth with: Character space)].	! !

GdsFloating subclass: #GdsReal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsReal commentStamp: 'kf 4/26/2009 16:25' prior: 0!
A GdsReal is Real number on GDSII.

storage cost: 8byte(4word) 16bit machine

8-byte real:
SEEEEEEE MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM

!

!GdsReal class methodsFor: 'accessing' stamp: 'kf 4/27/2009 14:58'!
precisionRank
	^3! !

!GdsReal class methodsFor: 'accessing' stamp: 'kf 4/26/2009 16:08'!
storageCost
	^ 8! !

!GdsReal class methodsFor: 'accessing' stamp: 'kf 4/24/2009 13:50'!
typeString
	^'REAL'! !

GdsFloating subclass: #GdsReal2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsReal2 commentStamp: 'kf 4/26/2009 16:24' prior: 0!
A GdsReal2 is Real number on GDSII.

storage cost: 4byte(2word) 16bit machine

4-byte real:
SEEEEEEE MMMMMMMM MMMMMMMM MMMMMMMM!

!GdsReal2 class methodsFor: 'testing' stamp: 'kf 4/22/2009 15:52'!
acceptableExpression: aString
	"TODO: implements minValue maxValue"
	|num|
	(aString matchesRegex: self acceptRegexPattern)
		ifFalse: [^false].
	num := aString asNumber.
	num ifNil: [^false].
	^true.! !

!GdsReal2 class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:43'!
mode
	^8! !

!GdsReal2 class methodsFor: 'accessing' stamp: 'kf 4/26/2009 16:09'!
storageCost
	^4! !

!GdsReal2 class methodsFor: 'accessing' stamp: 'kf 4/24/2009 13:50'!
typeString
	^'REAL2'! !

GdsNumber subclass: #GdsIntegral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

GdsIntegral subclass: #GdsInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsInteger commentStamp: 'kf 4/26/2009 16:26' prior: 0!
A GdsInteger is Integer number on GDSII.

storage cost: 2byte(1word) 16bit machine

2-byte integer:
SMMMMMMM MMMMMMM
!

!GdsInteger class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:41'!
maxValue
	"(2 raisedTo: (16 - 1)) - 1"
	^32767 ! !

!GdsInteger class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:41'!
minValue
	"(2 raisedTo: (16 - 1)) negated"
	^-32768 	! !

!GdsInteger class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:41'!
mode
	^2! !

!GdsInteger class methodsFor: 'accessing' stamp: 'kf 4/27/2009 14:58'!
precisionRank
	^2! !

!GdsInteger class methodsFor: 'accessing' stamp: 'kf 11/11/2008 17:28'!
storageCost
	^ 2! !

GdsIntegral subclass: #GdsInteger2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-DGL'!

!GdsInteger2 commentStamp: 'kf 4/26/2009 16:25' prior: 0!
A GdsInteger2 is Integer number on GDSII.

storage cost: 4byte(2word) 16bit machine

4-byte integer:
SMMMMMMM MMMMMMMM MMMMMMMM MMMMMMMM


!

!GdsInteger2 class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:40'!
maxValue
	"(2 raisedTo: (32 - 1)) - 1"
	^2147483647 ! !

!GdsInteger2 class methodsFor: 'accessing' stamp: 'kf 4/21/2009 21:40'!
minValue
	"(2 raisedTo: (32 - 1)) negated"
	^-2147483648	! !

!GdsInteger2 class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:43'!
mode
	^7! !

!GdsInteger2 class methodsFor: 'accessing' stamp: 'kf 11/11/2008 17:28'!
storageCost
	^ 4! !

!GdsIntegral class methodsFor: 'accessing' stamp: 'kf 5/23/2009 14:33'!
acceptRegexPattern
	^'[-]?[0-9]+'! !

!GdsIntegral class methodsFor: 'as yet unclassified' stamp: 'kf 5/23/2009 15:30'!
fromSmalltalk: aObject
	^GdsInteger new stringValue: aObject asString.! !

!GdsIntegral class methodsFor: 'as yet unclassified' stamp: 'kf 5/23/2009 14:08'!
isAcceptableSmalltalkObject: anObject
	^anObject isInteger.! !

!GdsNumber class methodsFor: 'as yet unclassified' stamp: 'kf 5/23/2009 15:22'!
fromSmalltalk: anObject
	| clazz |
	clazz := self allSubclasses detect: [:each  | each isAcceptableSmalltalkObject: anObject] ifNone: [^nil].
	clazz ifNil: [^self error: 'CANNT INSTANCE CREATION' ].
	^clazz fromSmalltalk: anObject.! !

!GdsNumber class methodsFor: 'as yet unclassified' stamp: 'kf 5/23/2009 13:58'!
isAcceptableSmalltalkObject: anObject
	^self allSubclasses anySatisfy: [:clazz | clazz isAcceptableSmalltalkObject: anObject].! !

!GdsScalar class methodsFor: 'as yet unclassified' stamp: 'kf 11/10/2008 16:04'!
rank
	^0! !

!GdsScalar class methodsFor: 'as yet unclassified' stamp: 'kf 5/19/2009 01:48'!
shape
	^GdsNull instance! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:24'!
abs
	^self newRealSelector: #abs! !

!GdsScalar methodsFor: 'private' stamp: 'kf 6/10/2009 16:36'!
applySmalltalkValueSymbol: aSymbol to: aObject 
	| leftValue |
	(aObject isScalar not) 
		ifTrue: [
			leftValue := self asVector: aObject size.
			(aObject isKindOf: GdsMatrix)
				ifTrue: [leftValue := 
					GdsMatrix 
						fromGdsVector: leftValue 
						row: aObject rowCount
						col: aObject columnCount].
			^ leftValue perform: aSymbol with: aObject].
	^ self asFloat perform: (aSymbol = #% ifTrue: [#/] ifFalse: [aSymbol])
		with: aObject asFloat! !

!GdsScalar methodsFor: 'private' stamp: 'kf 5/26/2009 15:00'!
applySymbol: aSymbol to: aObject 
	self applySymbolCheck: aSymbol to: aObject.
	^(self applySmalltalkValueSymbol: aSymbol  to:  aObject)
		asGdsValue! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:33'!
arcTan
	^self newRealBlock: [self asFloat arcTan radiansToDegrees].! !

!GdsScalar methodsFor: 'converting' stamp: 'kf 4/25/2009 14:57'!
asFloat
	^self asSmalltalkValue asFloat! !

!GdsScalar methodsFor: 'converting' stamp: 'kf 4/27/2009 17:10'!
asGdsFloating
	^ GdsReal fromLiteral: self asFloat. ! !

!GdsScalar methodsFor: 'converting' stamp: 'kf 5/26/2009 15:30'!
asVector
	^ self vectorClass withAll: (Array with: self)! !

!GdsScalar methodsFor: 'converting' stamp: 'kf 5/26/2009 15:31'!
asVector: aSize 
	^ self vectorClass withAll: (Array new: aSize withAll: self)! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 5/22/2009 23:30'!
at: aIndex
	^self error: 'ILIIGAL ACCESS FOR SCALAR []'.! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:38'!
atSubscript: aSubscript
	^self subscriptCheckForReturn: aSubscript
! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:38'!
atSubscript: aSubscript put: aGdsValue
	^self subscriptCheckForAssign: aSubscript
! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:24'!
ceiling
	^self newRealSelector: #ceiling! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:30'!
cos
	^self newRealBlock: [self asFloat degreesToRadians cos].! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 5/26/2009 11:23'!
elements
	^Array with: self.! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:30'!
exp
	^self newRealSelector: #exp! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:30'!
floor
	^self newRealSelector: #floor! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 5/19/2009 01:49'!
gplValueOfShape
	^GdsNull instance
! !

!GdsScalar methodsFor: 'testing' stamp: 'kf 5/26/2009 11:26'!
isScalar
	^true! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:25'!
ln
	^self newRealSelector: #ln! !

!GdsScalar methodsFor: 'converting' stamp: 'kf 4/27/2009 00:21'!
negated
	^self newRealSelector: #negated.
	! !

!GdsScalar methodsFor: 'testing' stamp: 'kf 4/26/2009 23:35'!
negative
	^self asFloat negative! !

!GdsScalar methodsFor: 'private' stamp: 'kf 4/27/2009 17:15'!
newIntegerBlock: aBlock
	^GdsInteger fromLiteral: (aBlock value asInteger).
	! !

!GdsScalar methodsFor: 'private' stamp: 'kf 4/27/2009 17:15'!
newIntegerSelector: aSelector
	^GdsInteger fromLiteral: (self asFloat perform: aSelector) asInteger.
	! !

!GdsScalar methodsFor: 'private' stamp: 'kf 4/27/2009 17:40'!
newRealBlock: aBlock
	^GdsReal new stringValue: (aBlock value asFloat).
	! !

!GdsScalar methodsFor: 'private' stamp: 'kf 4/27/2009 17:14'!
newRealSelector: aSelector
	^GdsReal fromLiteral: (self asFloat perform: aSelector) asFloat.
	! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:32'!
not
	^self newIntegerBlock: [self asFloat isZero ifTrue: [-1] ifFalse: [0]].! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:41'!
pi
	^self newRealBlock: [self asFloat * Float pi].! !

!GdsScalar methodsFor: 'printing' stamp: 'kf 4/24/2009 00:19'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream nextPutAll: self gplString.
	aStream nextPutAll: ')'.	! !

!GdsScalar methodsFor: 'converting' stamp: 'kf 4/27/2009 00:22'!
reciprocal
	^self newRealSelector: #reciprocal.
! !

!GdsScalar methodsFor: 'testing' stamp: 'kf 5/28/2009 15:52'!
sameAsInteger
	^self asSmalltalkValue asFloat fractionPart = 0.0! !

!GdsScalar methodsFor: 'converting' stamp: 'kf 5/26/2009 10:59'!
sign
	^self newRealSelector: #sign.
! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:31'!
sin
	^self newRealBlock: [self asFloat degreesToRadians sin]
! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 4/27/2009 21:36'!
size
	^1
	! !

!GdsScalar methodsFor: 'testing' stamp: 'kf 4/26/2009 23:35'!
strictlyPositive
	^self asFloat strictlyPositive! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 4/24/2009 18:01'!
stringValue
	^stringValue asString! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 4/21/2009 20:35'!
stringValue: aGplExpression
	stringValue := aGplExpression.
	! !

!GdsScalar methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:38'!
subscriptCheckFor: aGdsDataStructure
	^self runtimeError: 'CAN''T  SUBSCRIPTION ACCESS TO SCALAR VALUE '! !

!GdsScalar methodsFor: 'math function' stamp: 'kf 4/27/2009 00:31'!
tan
	^self newRealBlock: [self asFloat degreesToRadians tan].! !

GdsArray subclass: #GdsVector
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsVector commentStamp: 'kf 5/19/2009 14:34' prior: 0!
A GdsDataVector is GPLII's Vector.

Instance Variables
	values:		<Array<GdsDglType>>

values
	- xxxxx
!

GdsVector subclass: #GdsNull
	instanceVariableNames: ''
	classVariableNames: 'Singleton'
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsNull commentStamp: 'kf 4/28/2009 00:58' prior: 0!
A GdsNull is empty vector.

instance represents ""
but not a character vector.

like as lisp's empty list.

TYPEOF ""
=> NULL

RANK ""
=> 1  
is a vector. not sclar
!

!GdsNull class methodsFor: 'accessing' stamp: 'kf 4/28/2009 01:01'!
acceptRegexPattern
	^'""'! !

!GdsNull class methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:04'!
fromLiteral: aString
	(self acceptableExpression: (aString asString))
		ifFalse: [
	     self syntaxError: 'ILLIGAL LITERAL FORMAT'].
	^self instance.	! !

!GdsNull class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 14:30'!
fromSmalltalk: aObject
	^GdsNull instance.! !

!GdsNull class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:53'!
instance
	Singleton ifNil: [Singleton := GdsNull new.].
	^Singleton
	! !

!GdsNull class methodsFor: 'test' stamp: 'kf 5/23/2009 14:29'!
isAcceptableSmalltalkObject: anObject
	(anObject isKindOf: Collection) ifFalse: [^false].
	^anObject isEmpty
! !

!GdsNull class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:46'!
mode
	^5! !

!GdsNull class methodsFor: 'accessing' stamp: 'kf 5/19/2009 13:59'!
shape
	^#()
	! !

!GdsNull class methodsFor: 'accessing' stamp: 'kf 4/24/2009 13:48'!
typeString
	^'NULL'! !

!GdsNull methodsFor: 'accessing' stamp: 'kf 5/26/2009 14:48'!
applySymbol: aSymbol to: aObject 
	^self illigalDataMode.! !

!GdsNull methodsFor: 'convert' stamp: 'kf 5/19/2009 14:37'!
asSmalltalkValue
	^#() copy
	! !

!GdsNull methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:51'!
atSubscript: aGdsDataStructure
	^self runtimeError: 'ILLIGAL ACCESS FOR NULL VECTOR []'.! !

!GdsNull methodsFor: 'copying' stamp: 'kf 5/23/2009 23:28'!
copy
	^self.! !

!GdsNull methodsFor: 'convert' stamp: 'kf 5/20/2009 22:12'!
gplSourceString
	^'""'! !

!GdsNull methodsFor: 'convert' stamp: 'kf 4/26/2009 11:41'!
gplString
	^''! !

!GdsNull methodsFor: 'testing' stamp: 'kf 5/18/2009 13:37'!
isNullVector
	^true! !

!GdsNull methodsFor: 'printing' stamp: 'kf 4/26/2009 15:03'!
printOn: aStream
	aStream nextPutAll: 'a GdsNull'.
! !

!GdsNull methodsFor: 'testing' stamp: 'kf 5/28/2009 15:49'!
sameAsInteger
	^ false! !

!GdsNull methodsFor: 'accessing' stamp: 'kf 5/19/2009 13:59'!
shape
	^#() copy.! !

!GdsNull methodsFor: 'accessing' stamp: 'kf 4/27/2009 21:36'!
size
	^0! !

GdsVector subclass: #GdsString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsString commentStamp: 'kf 5/19/2009 14:34' prior: 0!
A GdsString is special case of DataVector.

CHARACTER VECTOR Data type on GDSII.

Inherited Instance Variables
	values:		<Array<GdsCharacter>>


!

!GdsString class methodsFor: 'test' stamp: 'kf 5/27/2009 17:07'!
acceptRegexPattern
	^'".*"'! !

!GdsString class methodsFor: 'instance creation' stamp: 'kf 5/27/2009 16:50'!
fromLiteral: aString
	| realContents |
	(aString isByteString) ifFalse: [^self syntaxError: 'STRING NOT OCTET VALUE.'].
	(aString size >= 2) ifFalse: [^self syntaxError: 'STRING NOT QUOTED.'].	
	(aString first = $" and: [aString last = $"])
		ifFalse: [^self syntaxError: 'STRING NOT QUOTED.'].
	aString = '""' ifTrue: [^GdsNull instance].
	realContents := 	aString copyFrom: 2 to: aString size - 1.
	^self fromSmalltalkString: realContents.	! !

!GdsString class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 15:10'!
fromSmalltalk: anObject
	^self fromSmalltalkString: anObject.	! !

!GdsString class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 15:09'!
fromSmalltalkString: aString
	| elements |
	elements := aString asByteArray asArray collect: [:asciiValue | 
		GdsCharacter fromAsciiValue: asciiValue ].
	^self withAll: elements.
	
	! !

!GdsString class methodsFor: 'test' stamp: 'kf 5/23/2009 14:24'!
isAcceptableSmalltalkObject: anObject
	(anObject isKindOf: Collection) ifFalse: [^false].
	anObject ifEmpty: [^false].
	^anObject allSatisfy: [:each | GdsCharacter isAcceptableSmalltalkObject: each ].! !

!GdsString methodsFor: 'convert' stamp: 'kf 5/26/2009 14:48'!
applySymbol: aSymbol to: aObject 
	^self illigalDataMode.! !

!GdsString methodsFor: 'convert' stamp: 'kf 5/20/2009 22:13'!
gplSourceString
	^'"',self gplString, '"'! !

!GdsString methodsFor: 'testing' stamp: 'kf 6/12/2009 08:48'!
isCharVector
	^true! !

!GdsString methodsFor: 'printing' stamp: 'kf 4/26/2009 15:57'!
printGplOn: aStream
	aStream nextPutAll: ((values collect: [:elm | elm gplString]) joinUsing: '').
! !

!GdsString methodsFor: 'testing' stamp: 'kf 5/28/2009 15:49'!
sameAsInteger
	^ false! !

!GdsVector class methodsFor: 'instance creation' stamp: 'kf 5/27/2009 16:20'!
fromLiteral: aGplExpr
	| exprs clazz gValues |
	exprs := aGplExpr findTokens: ' '.
	gValues := exprs collect: [:each | 
		clazz := GdsDglType bestClassOfStatement: each.
		clazz ifNil: [self syntaxError: 'ILLIGAL LITERAL: ', each].
		clazz fromLiteral: each].
	^self withAll: gValues.! !

!GdsVector class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 15:17'!
fromSmalltalk: anObject
	^self withAll: (anObject collect: [:each | each asGdsValue])! !

!GdsVector class methodsFor: 'printing' stamp: 'kf 5/19/2009 00:00'!
gplStringValues: aCollection
	^(aCollection collect: [:elm | elm gplString]) joinUsing: ' '.
	
	! !

!GdsVector class methodsFor: 'printing' stamp: 'kf 5/20/2009 17:01'!
gplStringValues: aCollection paddLeftWidth: aWidth
	^(aCollection collect: [:elm | elm gplString padded: #left to: aWidth with: Character space ]) joinUsing: ' '.
	
	! !

!GdsVector class methodsFor: 'printing' stamp: 'kf 5/20/2009 17:03'!
gplStringValues: aCollection paddLeftWidth: aLeftWidth rightWidth: aRightWidth
	^(aCollection collect: [:elm | 
		elm gplStringLeftWidth: aLeftWidth rightWidth: aRightWidth]) joinUsing: ' '.
	
	! !

!GdsVector class methodsFor: 'printing' stamp: 'kf 5/20/2009 15:25'!
gplStringValues: aCollection paddWidth: aWidth
	^(aCollection collect: [:elm | elm gplString padded: #left to: aWidth with: Character space ]) joinUsing: ' '.
	
	! !

!GdsVector class methodsFor: 'testing' stamp: 'kf 5/23/2009 14:00'!
isAcceptableSmalltalkObject: anObject
	(anObject isKindOf: Collection) ifFalse: [^false].
	anObject ifEmpty: [^false].
	^anObject allSatisfy: [:each |  GdsNumber isAcceptableSmalltalkObject: each ].	! !

!GdsVector class methodsFor: 'accessing' stamp: 'kf 4/26/2009 11:51'!
rank
	^1
	! !

!GdsVector class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 14:17'!
withAll: aGplValues
	| modes maxMode upperClazz vec |
	modes := aGplValues collect: [:gValue | gValue mode].
	(modes asSet size = 1)
		ifTrue: [
			vec := self new.
			aGplValues do: [: elm | vec add: elm].
			^vec]. 
	maxMode := modes max.
	upperClazz := GdsDglType instanciateClasses detect: [:clazz | clazz mode = maxMode ].
	vec := self new.
	aGplValues do: [: elm | 
		vec add: (upperClazz fromLiteral: (elm gplString))].
	^vec.! !

!GdsVector methodsFor: 'adding' stamp: 'kf 4/23/2009 23:49'!
add: aGdsDataStructure
	self assert: (aGdsDataStructure isKindOf: GdsDataStructure)
	     description: 'Only GdsDataStructure'.
	values ifNil: [values := OrderedCollection new.].
	values add: aGdsDataStructure.! !

!GdsVector methodsFor: 'convert' stamp: 'kf 5/22/2009 23:51'!
asSmalltalkValue
	^(self elements collect: [:each | each asSmalltalkValue copy]) asArray.! !

!GdsVector methodsFor: 'convert' stamp: 'kf 4/24/2009 17:51'!
asVector
	^self
	! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:32'!
at: aInteger
	^[values at: aInteger] on: Error do: [:ex |
		self runtimeError: 'SUBSCRIPTION OUT OF RANGE'].! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 5/21/2009 23:46'!
at: aInteger put: aGplValue
	values at: aInteger put: aGplValue.! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 5/22/2009 23:42'!
atSubscript: aGdsDataStructure
	| indexes vec |
	indexes := self indexesOfSubscript: aGdsDataStructure.
	vec := self class withAll: (self indexedValues: indexes).
	^vec size = 1 ifTrue: [vec at: 1] ifFalse: [vec].
	
! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 5/23/2009 19:51'!
atSubscript: aSubscript put: aGdsValue
	| subscripts |
	(aSubscript isMemberOf: GdsList) 
		ifTrue: [^ self notSupportMatrixSubscription].
	(aGdsValue isKindOf: GdsScalar) 
		ifFalse: [^ self error: 'CAN''T ASSIGN NON SCALAR VALUE.'].
	subscripts := aSubscript asVector.
	subscripts elements 
		do: [:each | self at: each asSmalltalkValue put: aGdsValue].
	^ aGdsValue! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 5/18/2009 22:59'!
copyFrom: from to: to
	^values copyFrom: from to: to.! !

!GdsVector methodsFor: 'copying' stamp: 'kf 5/23/2009 23:27'!
copyValues
	| newValues |
	newValues := values collect: [:each | each copy].
	values := OrderedCollection new.
	values addAll: newValues.
	
	! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 5/18/2009 23:02'!
elements
	^values asArray.! !

!GdsVector methodsFor: 'convert' stamp: 'kf 4/24/2009 00:34'!
gplString
	^String streamContents: [:s | self printGplOn: s]
	! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 4/26/2009 12:28'!
mode
	values ifNil: [^GdsNull mode].
	values ifEmpty: [^GdsNull mode].
	^values first mode! !

!GdsVector methodsFor: 'printing' stamp: 'kf 5/19/2009 00:00'!
printGplOn: aStream
	aStream nextPutAll: (self class gplStringValues: values).
	
	! !

!GdsVector methodsFor: 'printing' stamp: 'kf 5/18/2009 23:57'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	self printGplOn: aStream.
	aStream nextPutAll: ')'.
	
	! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 5/19/2009 01:50'!
shape
	^self size.! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 4/24/2009 14:45'!
size
	values ifNil: [^0].
	^values size.! !

!GdsVector methodsFor: 'accessing' stamp: 'kf 4/24/2009 13:48'!
typeString
	values ifNil: [^GdsNull typeString].
	values ifEmpty: [^GdsNull typeString].	
	^values first typeString! !

!GdsDataStructure class methodsFor: 'accessing' stamp: 'kf 4/27/2009 15:32'!
acceptRegexPattern
	self subclassResponsibility.
! !

!GdsDataStructure class methodsFor: 'test' stamp: 'kf 4/27/2009 15:34'!
acceptableExpression: aString
	^(aString matchesRegex: self acceptRegexPattern)! !

!GdsDataStructure class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 17:03'!
cantConvertSmalltalkObject: anObject
	^self error: 'CAN''T CREATE FROM Smalltalk Object: ', anObject printString.
	! !

!GdsDataStructure class methodsFor: 'instance creation' stamp: 'kf 5/27/2009 16:03'!
fromLiteral: aString
	(self acceptableExpression: (aString asString))
		ifFalse: [
	     self syntaxError: 'ILLIGAL LITERAL FORMAT'].
	^self new stringValue: aString.	! !

!GdsDataStructure class methodsFor: 'instance creation' stamp: 'kf 4/26/2009 11:53'!
fromSmalltalk: aObject
	^self subclassResponsibility.
	! !

!GdsDataStructure class methodsFor: 'instance creation' stamp: 'kf 5/23/2009 17:03'!
fromSmalltalkObject: anObject
	(self isAcceptableSmalltalkObject: anObject)
		ifFalse: [^self cantConvertSmalltalkObject: anObject].
	^self fromSmalltalk: anObject.
	! !

!GdsDataStructure class methodsFor: 'test' stamp: 'kf 5/23/2009 13:55'!
isAcceptableSmalltalkObject: anObject
	^self subclassResponsibility ! !

!GdsDataStructure class methodsFor: 'accessing' stamp: 'kf 4/26/2009 11:52'!
mode
	^self subclassResponsibility! !

!GdsDataStructure class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:04'!
rank
	^self  subclassResponsibility.! !

!GdsDataStructure class methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:10'!
shape
	self subclassResponsibility.! !

!GdsDataStructure methodsFor: 'arithmetic' stamp: 'kf 4/25/2009 00:07'!
% aObject
	^self applySymbol: #% to: aObject! !

!GdsDataStructure methodsFor: 'arithmetic' stamp: 'kf 4/24/2009 22:17'!
* aObject
	^self applySymbol: #* to: aObject! !

!GdsDataStructure methodsFor: 'arithmetic' stamp: 'kf 4/24/2009 22:17'!
+ aObject
	| v |
	"self halt."
	v := self applySymbol: #+ to: aObject.
	^v.! !

!GdsDataStructure methodsFor: 'arithmetic' stamp: 'kf 4/24/2009 22:17'!
- aObject
	^self applySymbol: #- to: aObject! !

!GdsDataStructure methodsFor: 'arithmetic' stamp: 'kf 5/20/2009 00:48'!
= aObject
	(aObject isKindOf: GdsDataStructure ) ifFalse: [^false].
	(self size = aObject size) ifFalse: [^false].
	(self mode = aObject mode) ifFalse: [^false].
	^self asSmalltalkValue = aObject asSmalltalkValue.! !

!GdsDataStructure methodsFor: 'arithmetic' stamp: 'kf 5/26/2009 14:47'!
applySymbol: aSymbol to: aObject 
	^self illigalDataMode.! !

!GdsDataStructure methodsFor: 'private' stamp: 'kf 6/12/2009 09:10'!
applySymbolCheck: aSymbol to: aObject 
	(#(+ - * %) includes: aSymbol) ifFalse: [self error: 'ILLIGAL ARITHMETIC OPERATOR'].
	self isCharVector ifTrue: [^self illigalDataMode].
	(self isKindOf: GdsNull) ifTrue: [^self illigalDataMode].
	aObject isCharVector ifTrue: [^self illigalDataMode].
	(aObject isKindOf: GdsNull) ifTrue: [^self illigalDataMode].
	! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 5/23/2009 23:30'!
asGdsFloating
	^self subclassResponsibility! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 5/26/2009 12:00'!
asGdsValue
	^self! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 4/24/2009 16:48'!
asGplValue
	^self! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 6/12/2009 09:07'!
asScalar
	self isScalar ifTrue: [^self].
	self size = 1
		ifFalse: [^self error: 'CANT CONVERT TO SCALAR'].
	^self at: 1.! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 4/25/2009 14:56'!
asSmalltalkValue
	^self subclassResponsibility.! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 5/26/2009 15:32'!
asVector
	^ self vectorClass withAll: self elements! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 5/26/2009 15:33'!
asVector: aSize 
	^ self vectorClass withAll: self elements ! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/22/2009 23:27'!
at: aIndex
	^self error: 'ILIIGAL ACCESS FOR SCALAR []'.! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/23/2009 23:01'!
atSubscript: aGdsDataStructure.
	^self subclassResponsibility.! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/23/2009 19:37'!
atSubscript: aGdsDataStructure put: aGdsValue
	^self subclassResponsibility! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/26/2009 10:12'!
atSubscriptWithCheck: aGdsDataStructure 
	| subscript |
	subscript := self subscriptCheckForReturn: aGdsDataStructure.
	^self atSubscript: subscript! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/26/2009 10:10'!
atSubscriptWithCheck: aGdsDataStructure put: aGdsValue
	| subscript |
	subscript := self subscriptCheckForAssign: aGdsDataStructure.
	^self atSubscript: subscript put: aGdsValue.! !

!GdsDataStructure methodsFor: 'copying' stamp: 'kf 5/23/2009 23:26'!
copy
	^super copy copyValues.! !

!GdsDataStructure methodsFor: 'copying' stamp: 'kf 5/23/2009 23:50'!
copyValues
! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/26/2009 11:22'!
elements
	^self subclassResponsibility.! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 5/20/2009 22:11'!
gplSourceString
	^self gplString.! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 4/25/2009 15:20'!
gplString
	^self asSmalltalkValue asString.! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 5/20/2009 22:56'!
gplValueOfLength
	^GdsInteger fromLiteral: self length.
! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 4/27/2009 21:36'!
gplValueOfRank
	^GdsInteger fromLiteral: self rank.
! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 4/27/2009 21:35'!
gplValueOfShape
	^GdsInteger fromLiteral: self shape.
! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 4/27/2009 21:33'!
gplValueOfSize
	^GdsInteger fromLiteral: self size.
	! !

!GdsDataStructure methodsFor: 'convert' stamp: 'kf 5/22/2009 13:13'!
gplValueOfTypeof
	^GdsString fromLiteral: ('"', self typeString , '"')! !

!GdsDataStructure methodsFor: 'utility for subclass' stamp: 'kf 5/27/2009 16:33'!
illigalDataMode
	^self runtimeError: 'ILLIGAL DATA MODE'.! !

!GdsDataStructure methodsFor: 'utility for subclass' stamp: 'kf 5/22/2009 23:27'!
indexedValues: aIndexArray
	^(aIndexArray collect: [:each | self at: each]) asArray! !

!GdsDataStructure methodsFor: 'utility for subclass' stamp: 'kf 5/22/2009 23:40'!
indexesOfSubscript: aGdsDataStructure
	^aGdsDataStructure asVector elements collect: [:each | each asSmalltalkValue].
! !

!GdsDataStructure methodsFor: 'testing' stamp: 'kf 6/12/2009 08:48'!
isCharVector
	^false! !

!GdsDataStructure methodsFor: 'testing' stamp: 'kf 6/11/2009 17:48'!
isList
	^false! !

!GdsDataStructure methodsFor: 'testing' stamp: 'kf 5/18/2009 13:36'!
isNullVector
	^false! !

!GdsDataStructure methodsFor: 'testing' stamp: 'kf 5/26/2009 11:26'!
isScalar
	^false! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/19/2009 14:46'!
length
	^1.! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:34'!
mode
	^self class mode.! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:32'!
nonIntegralValue
	^self runtimeError: 'ILLIGAL SUBSCRIPT ACCESS. NON INTEGRAL VALUE'.
! !

!GdsDataStructure methodsFor: 'private' stamp: 'kf 5/22/2009 23:19'!
notSupportMatrixSubscription
	^self error: 'Sorry: current implement not support Matrix subscription'.
! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:04'!
rank
	^self class rank.
	! !

!GdsDataStructure methodsFor: 'testing' stamp: 'kf 5/28/2009 15:49'!
sameAsInteger
	^ false! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:10'!
shape
	^self class shape.! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 4/27/2009 21:34'!
size
	self subclassresponsibility! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 6/12/2009 09:09'!
subscriptCheckFor: aSubscript 
	(self isMemberOf: GdsMatrix)
		ifFalse: [
			(aSubscript = GdsNull instance)
				ifTrue: [^self nonIntegralValue]].
	aSubscript isCharVector
		ifTrue: [^self nonIntegralValue].
	(aSubscript isMemberOf: GdsMatrix)
		ifTrue: [^self nonIntegralValue].
	((aSubscript isMemberOf: GdsVector) or: [aSubscript isKindOf: GdsScalar]) 
		ifTrue: [
			(aSubscript sameAsInteger)
				ifFalse: [^self nonIntegralValue]].
	^ aSubscript! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/25/2009 22:58'!
subscriptCheckForAssign: aSubscript 
	^ self subscriptCheckFor: aSubscript! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/25/2009 22:57'!
subscriptCheckForReturn: aSubscript 
	^ self subscriptCheckFor: aSubscript! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 4/24/2009 13:43'!
typeString
	^self subclassResponsibility.! !

!GdsDataStructure methodsFor: 'accessing' stamp: 'kf 5/23/2009 22:50'!
vectorClass
	^self typeString = 'CHAR' ifTrue: [GdsString] ifFalse: [GdsVector].! !

GdsDataStructure subclass: #GdsList
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Data'!

!GdsList commentStamp: 'kf 5/25/2009 20:19' prior: 0!
A GdsList is GDSII's LIST data structure.

Instance Variables
	elements:		<GdsDataStructure>

elements
	- xxxxx
!

!GdsList class methodsFor: 'accessing' stamp: 'kf 11/10/2008 16:10'!
mode
	^6! !

!GdsList class methodsFor: 'instance creation' stamp: 'kf 5/22/2009 23:33'!
withAll: aGplValues
	| newInstance |
	newInstance := self new.
	aGplValues do: [:each | newInstance add: each copy].
	^newInstance! !

!GdsList methodsFor: 'initialize-release' stamp: 'kf 5/23/2009 19:31'!
add: aGdsDataStructure 
	self assert: (aGdsDataStructure isKindOf: GdsDataStructure).
	(aGdsDataStructure isMemberOf: GdsList) 
		ifTrue: [aGdsDataStructure elements do: [:each | elements add: each]]
		ifFalse: [elements add: aGdsDataStructure]! !

!GdsList methodsFor: 'convert' stamp: 'kf 5/27/2009 16:31'!
asVector
	^self runtimeError: 'ILLIGAL DATA MODE'.! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/27/2009 17:04'!
at: anIndex
	((1 to: self elements size) includes: anIndex)
		ifFalse: [^self runtimeError: 'SUBSCRIPT OUT OF BOUNDS'].
	^self elements at: anIndex.! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/25/2009 15:03'!
atPutUsage
	^'Only: [{Integer}] := {Array}'.
	
	
	
	! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/27/2009 17:02'!
atSubscript: aGdsDataStructure
	| indexes list |
	(aGdsDataStructure asVector size = 1)
		ifFalse: [^self runtimeError: 'ILLIGAL DATA RANK. List subscription only scalar value'].
	indexes := self indexesOfSubscript: aGdsDataStructure.
	list := self class withAll: (self indexedValues: indexes).
	^list length = 1 ifTrue: [list at: 1] ifFalse: [list].! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/25/2009 23:07'!
atSubscript: aSubscript put: aGdsValue
	| index |
	"subscipt := self subscriptArgumentCheck:  aSubscript."
	(aGdsValue isKindOf: GdsList)
		ifTrue: [^self error: self atPutUsage ].
	index := aSubscript asSmalltalkValue.
	((1 to: elements size) includes: index) 
		ifFalse: [^self error: 'SUBSCRIPT OUT OF RANGE'].
	elements at: index put: aGdsValue.
	
	
	
	
	! !

!GdsList methodsFor: 'convert' stamp: 'kf 5/21/2009 00:29'!
displayUnit
	^4.
	
! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/20/2009 21:53'!
elements
	^elements asArray.! !

!GdsList methodsFor: 'convert' stamp: 'kf 5/21/2009 00:32'!
gplString
	| numRepeat rem allUnits |
	allUnits := OrderedCollection new.
	numRepeat := self elements size quo: (self displayUnit).
	(0 to: (numRepeat - 1)) do: [:index |
		| start |
		start := (index * (self displayUnit)) + 1.
		allUnits add: (self elements copyFrom: start to:  (start + (self displayUnit) - 1))].
	rem := self elements size rem: (self displayUnit).
	(rem > 0) ifTrue: [allUnits add: (self elements  last: rem)].
	^(allUnits collect: [:each | self gplStringUnit: each]) joinUsing: (String cr, String cr). 
! !

!GdsList methodsFor: 'convert' stamp: 'kf 5/22/2009 17:41'!
gplStringUnit: aCollection
	| nRow nCol colWidth mat colStart cols spaceSize |
	spaceSize := 2.
	nRow := (aCollection collect: [:each | each gplString lines size]) max.
	colWidth := aCollection collect: [:each | 
		each gplString isEmpty
			ifTrue: [0]
			ifFalse: [
				(each gplString lines 
					collect: [:each2 | each2 size]) max]].
	nCol := colWidth sum + ((aCollection size * spaceSize) - 1).
	mat := Matrix rows: nRow columns: nCol element: Character space.
	colStart := 1.
	aCollection doWithIndex: [:each :index| 
		| lines iCol  |
		lines := each gplString lines.
		lines doWithIndex: [:each2 :index2 |
			iCol := colStart.
	  		each2 asArray do: [:ch |
				mat at: index2 at: iCol put: ch.
				iCol := iCol + 1.].].
		colStart := colStart + (colWidth at: index) + spaceSize.].
	cols := OrderedCollection new.
	(1 to: mat rowCount)  do: [:index | cols add: (String withAll: (mat atRow: index)) ].
	^cols joinUsing: String cr.! !

!GdsList methodsFor: 'initialize-release' stamp: 'kf 5/20/2009 21:32'!
initialize
	elements := OrderedCollection new.
	! !

!GdsList methodsFor: 'testing' stamp: 'kf 6/11/2009 17:49'!
isList
	^true! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/20/2009 22:14'!
length
	^self elements size.! !

!GdsList methodsFor: 'printing' stamp: 'kf 5/20/2009 22:13'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	self elements do: [:each | 
		aStream nextPutAll: each gplSourceString.
		aStream nextPut: $;.].
	aStream skip: -1.
	aStream nextPutAll: ')'.
	! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/27/2009 17:02'!
rank
	^self runtimeError: 'ILLIGAL DATA MODE'.! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:12'!
shape
	^self runtimeError: 'ILLIGAL DATA MODE'.! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/27/2009 16:12'!
size
	^self runtimeError: 'ILLIGAL DATA MODE'.! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/25/2009 23:36'!
subscriptCheckForAssign:  aSubscript
	| subscipt |
	subscipt := aSubscript.
	(aSubscript isMemberOf: GdsVector)
		ifTrue: [aSubscript size = 1
			ifTrue: [subscipt := aSubscript at: 1]
			ifFalse: [^self error: self atPutUsage ]].
	(aSubscript isKindOf: GdsScalar)
		ifFalse: [^self error: self atPutUsage ].
	(subscipt isKindOf: GdsIntegral)
		ifFalse: [^self error: self atPutUsage ].
	^self subscriptCheckFor: subscipt
	
	
	! !

!GdsList methodsFor: 'accessing' stamp: 'kf 5/25/2009 20:53'!
typeString
	^'LIST'! !

GdsDataStructure subclass: #GplVariable
	instanceVariableNames: 'varName gplValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

!GplVariable commentStamp: 'kf 4/21/2009 23:50' prior: 0!
A GplVariable is assigneable Variable in GDSII.

Instance Variables
	varName:		<String>

varName
	- unique name in GPL evaluter memory space.
	- regex: '^[A-Z$][A-Z0-9$_]*$' max 32byte
!

!GplVariable class methodsFor: 'as yet unclassified' stamp: 'kf 4/26/2009 12:49'!
named: aVariableName
	^self new name: aVariableName.! !

!GplVariable methodsFor: 'accessing' stamp: 'kf 4/25/2009 23:47'!
asGplValue
	^gplValue! !

!GplVariable methodsFor: 'convert' stamp: 'kf 4/25/2009 22:14'!
asSmalltalkValue
	^gplValue asSmalltalkValue.! !

!GplVariable methodsFor: 'error handling' stamp: 'kf 4/25/2009 22:13'!
doesNotUnderstand: aMessage
	gplValue perform: aMessage selector withArguments: aMessage arguments.! !

!GplVariable methodsFor: 'accessing' stamp: 'kf 4/25/2009 21:37'!
gplValue: aGdsDataStructure
	gplValue := aGdsDataStructure.! !

!GplVariable methodsFor: 'testing' stamp: 'kf 4/25/2009 22:16'!
isVariableAllowed
	^true! !

!GplVariable methodsFor: 'accessing' stamp: 'kf 4/25/2009 23:24'!
name
	^varName
	! !

!GplVariable methodsFor: 'accessing' stamp: 'kf 4/21/2009 23:44'!
name: aVariableName
	varName := aVariableName.! !

!GplVariable methodsFor: 'printing' stamp: 'kf 4/25/2009 23:02'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream nextPutAll: varName.
	aStream nextPutAll: ','.
	aStream nextPutAll: gplValue gplString.	
	aStream nextPutAll: ')'.
	! !

!GplVariable methodsFor: 'accessing' stamp: 'kf 4/25/2009 22:56'!
rank
	^gplValue rank! !

!GdsObject class methodsFor: 'error handling' stamp: 'kf 5/27/2009 15:59'!
error: aString
	^GdsError new signal:  aString! !

!GdsObject class methodsFor: 'error handling' stamp: 'kf 5/27/2009 16:10'!
runtimeError: aString
	^GplRuntimeError new signal:  aString! !

!GdsObject class methodsFor: 'error handling' stamp: 'kf 5/27/2009 15:54'!
syntaxError: aString
	^GplSyntaxError new signal:  aString! !

!GdsObject methodsFor: 'as yet unclassified' stamp: 'kf 5/27/2009 16:00'!
error: aString
	^self class error: aString! !

!GdsObject methodsFor: 'as yet unclassified' stamp: 'kf 5/27/2009 16:11'!
runtimeError: aString
	^self class runtimeError: aString.! !

!GdsObject methodsFor: 'as yet unclassified' stamp: 'kf 5/27/2009 16:00'!
syntaxError: aString
	^self class syntaxError: aString! !

GdsObject subclass: #GplHandler
	instanceVariableNames: 'evaluter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 13:47'!
commandNames
	^(GplMultiHandler commandNames, GplSingleHandler commandNames)! !

!GplHandler class methodsFor: 'instance creation' stamp: 'kf 5/16/2009 22:17'!
fromCommand: aCommandName evaluter: aGplEvaluter
	| clazz |
	clazz := self lookupHandlerClass: aCommandName.
	clazz ifNil: [^nil].
	^clazz new evaluter: aGplEvaluter.
	! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 5/17/2009 14:25'!
hasCommandName: aCommandName
	^(self lookupHandlerClass: aCommandName) isNil not. ! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:44'!
isFunctionAllowed
	^false.! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:52'!
isFunctionAllowed: aCommandName
	^self valueTestFor:  aCommandName selector: #isFunctionAllowed
! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:45'!
isNiladicAllowed
	^false.! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:52'!
isNiladicAllowed: aCommandName
	^self valueTestFor:  aCommandName selector: #isNiladicAllowed
	! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 6/5/2009 09:44'!
isVoid: aCommandName
	(GplToken isBuiltinMethod: aCommandName)
		ifTrue: [^false].
	^(self isFunctionAllowed: aCommandName) not.
! !

!GplHandler class methodsFor: 'private' stamp: 'kf 5/28/2009 13:20'!
lookupHandlerClass: aCommandName
	{ GplMultiHandler . GplSingleHandler }
		do: [:clazz | 
			| handlerClass |
			handlerClass := clazz lookupHandlerClass: aCommandName.
			handlerClass ifNotNil: [^handlerClass]].
	^nil.
	! !

!GplHandler class methodsFor: 'accessing' stamp: 'kf 5/16/2009 22:10'!
methodName
	^''.
	! !

!GplHandler class methodsFor: 'accessing' stamp: 'kf 6/8/2009 14:20'!
methodNames
	^(GplMultiHandler methodNames, GplSingleHandler methodNames)! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:54'!
noArgReturnValueEnabled: aCommandName
	^self isFunctionAllowed and: [self isNiladicAllowed].
! !

!GplHandler class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:51'!
valueTestFor: aCommandName selector: aSelector
	| clazz |
	clazz := self lookupHandlerClass: aCommandName.
	^(clazz ifNil: [self] ifNotNil:[clazz]) perform: aSelector.
! !

!GplHandler class methodsFor: 'accessing' stamp: 'kf 5/29/2009 17:00'!
voidCommandNames
	^self commandNames select: [:each | self isVoid: each]! !

!GplHandler methodsFor: 'utility' stamp: 'kf 6/10/2009 11:35'!
call: aGplStatement
	^evaluter evaluteLine: aGplStatement.! !

!GplHandler methodsFor: 'private' stamp: 'kf 6/8/2009 17:14'!
checkStationInstances: aGdsStationUIs
	aGdsStationUIs isEmpty 
		ifTrue: [^self error: 'STATION DOWN'].
	aGdsStationUIs size >= 2
		ifTrue: [^self error: 'DUPLICATE STATION ENVIRONMENT ERROR'].
	aGdsStationUIs first model
		ifNil: [^self error: 'STATION DOWN'].
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/17/2009 13:35'!
currentItem
	| station |
	station := self station.
	station library ifNil: [^self error: 'NO LIBRARY OPEN'].
	station structure ifNil: [^self error: 'NO STRUCTURE OPEN'].		
	^station structure currentItem.
! !

!GplHandler methodsFor: 'handler' stamp: 'kf 5/16/2009 22:27'!
evaluteToken: aToken
! !

!GplHandler methodsFor: 'initialize-release' stamp: 'kf 5/16/2009 22:08'!
evaluter: aGplEvaluter
	evaluter := aGplEvaluter.
	! !

!GplHandler methodsFor: 'utility' stamp: 'kf 6/8/2009 16:39'!
findElementByKeyNumber: aKeyNumber
	^self structure liveElements 
			detect: [:el | el keyNumber = aKeyNumber]
			ifNone: [^self error: ('ELEMENT KEY NOT FOUND: ', aKeyNumber asString)].
! !

!GplHandler methodsFor: 'utility' stamp: 'kf 5/16/2009 23:29'!
floatVector: aFloatCollection	
	^(aFloatCollection collect: [:each | GdsFloating fromLiteral: (each asString)]) asArray.
! !

!GplHandler methodsFor: 'utility' stamp: 'kf 6/9/2009 14:13'!
fullRedraw
	self structureMorph invalidRect: self structureMorph bounds.
! !

!GplHandler methodsFor: 'checker' stamp: 'kf 5/28/2009 17:26'!
illigalCoordinate
	^self error: 'ILLIGAL COORDINATE VALUE'.
! !

!GplHandler methodsFor: 'utility' stamp: 'kf 5/30/2009 21:23'!
illigalKeyNumbers: errorKeys
	errorKeys
		ifNotEmpty: [
			^self error: 'ILLIGAL KEYNUMBERS: ', 
			 ((errorKeys collect:[:each | each asString]) joinUsing: ' ')].
! !

!GplHandler methodsFor: 'utility' stamp: 'kf 5/16/2009 23:27'!
integerVector: aIntegerCollection	
	^(aIntegerCollection collect: [:each | GdsInteger fromLiteral: (each asString)]) asArray.
! !

!GplHandler methodsFor: 'testing' stamp: 'kf 5/21/2009 22:44'!
isFunctionAllowed
	^self class isFunctionAllowed.! !

!GplHandler methodsFor: 'testing' stamp: 'kf 5/21/2009 22:44'!
isNiladicAllowed
	^self class isNiladicAllowed.! !

!GplHandler methodsFor: 'utility' stamp: 'kf 5/30/2009 21:21'!
keyNumbers: keyNumbers doWithElement: aKeyAndElementBlock
	| element |
	keyNumbers do: [ :each |	
		element := [self findElementByKeyNumber: each] 
			on: Error
			do: [:ex | nil].
		aKeyAndElementBlock value: each value: element].
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/17/2009 17:39'!
library
	| station library |
	station := self station.
	library := station library.
	library ifNil: [^self error: 'NO LIBRARY OPEN'].
	^library.
! !

!GplHandler methodsFor: 'marking' stamp: 'kf 5/30/2009 21:24'!
markByKeys: keyNumbers
	| points errorKeys  |
	points := OrderedCollection new.
	errorKeys := OrderedCollection new.
	self 
		keyNumbers: keyNumbers 
		doWithElement: [:key :element| 
			element
				ifNil: [errorKeys add: key]
				ifNotNil: [points add: element xy]].
	self illigalKeyNumbers: errorKeys.
	self markPoints: points asArray.
! !

!GplHandler methodsFor: 'marking' stamp: 'kf 5/30/2009 20:46'!
markPoints: aPoints
	aPoints ifEmpty: [^self].
	self structureMorph setVisible: true forKey:  #mark.
	aPoints do: [:each |
		self structureMorph mark: each.].
	self structureMorph invalidRect: self structureMorph bounds.
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/16/2009 23:04'!
methodName
	^self class methodName.! !

!GplHandler methodsFor: 'checker' stamp: 'kf 5/28/2009 17:29'!
mustBeCoordinatable: aGdsArray
	(#('CHAR' 'LIST' 'NULL') includes: aGdsArray typeString)
		 ifTrue: [^self illigalCoordinate].
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/28/2009 14:44'!
mustStructureOpen
	^self currentItem.
! !

!GplHandler methodsFor: 'checker' stamp: 'kf 6/12/2009 09:11'!
mustbeString: aGplValue
	aGplValue isCharVector
		ifFalse: [^self error: 'ONLY SPECIFIED CHARACTER VECTOR'].
	! !

!GplHandler methodsFor: 'utility' stamp: 'kf 5/17/2009 18:03'!
nullVector
	^GdsNull instance.
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/17/2009 14:08'!
station
	| instances |
	instances := self stationUIInstances.
	self checkStationInstances: instances.
	^instances first model.
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/17/2009 14:07'!
stationUIClass
	Smalltalk garbageCollect.
	^Smalltalk at: #GdsStationUI ifAbsent: [nil].
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/28/2009 13:09'!
stationUIInstances
	| clazz |
	clazz := self stationUIClass.
	clazz ifNil: [^self error: 'GDSFEEL PACKAGE NOT INSTALLED'].
	^clazz noGarbageTargetInstances.
! !

!GplHandler methodsFor: 'utility' stamp: 'kf 5/17/2009 00:27'!
stringVector: aByteString
	^GdsString fromLiteral: ('"', aByteString,'"')! !

!GplHandler methodsFor: 'utility' stamp: 'kf 5/17/2009 17:47'!
strings: aByteStringCollection
	^self stringVector: (aByteStringCollection joinUsing: String cr).! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/18/2009 22:09'!
structure
	^self station structure.
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/28/2009 14:41'!
structureMorph
	| instances |
	instances := self stationUIInstances.
	instances ifEmpty: [^self error: 'STATION DOWN'].
	self checkStationInstances: instances.
	^instances first findA: GdsStructureMorph.
! !

!GplHandler methodsFor: 'accessing' stamp: 'kf 5/28/2009 14:24'!
viewport
	^self structureMorph viewport.! !

GplHandler subclass: #GplMultiHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

GplMultiHandler subclass: #GplCurrentItemNoArgHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplCurrentItemNoArgHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 14:39'!
associateArray
	^{'UNGET' -> #unget . 'PUT' -> #put}! !

!GplCurrentItemNoArgHandler class methodsFor: 'testing' stamp: 'kf 5/29/2009 10:03'!
isFunctionAllowed: aCommandName
	^false! !

!GplCurrentItemNoArgHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 15:28'!
evaluteToken: aToken
	| selector |
	selector := self class selectorForMethodName: aToken fragment.
	self currentItem perform: selector.
	^self nullVector.! !

GplMultiHandler subclass: #GplDateTimeHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplDateTimeHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 16:02'!
associateArray
	^{'TOD' -> #tod: . 'DAY' -> #day: }! !

!GplDateTimeHandler class methodsFor: 'testing' stamp: 'kf 5/28/2009 13:41'!
isFunctionAllowed
	^true! !

!GplDateTimeHandler class methodsFor: 'testing' stamp: 'kf 5/29/2009 10:03'!
isFunctionAllowed: aCommandName
	^true! !

!GplDateTimeHandler class methodsFor: 'testing' stamp: 'kf 5/28/2009 13:41'!
isNiladicAllowed
	^true! !

!GplDateTimeHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 16:02'!
day: aToken
	| date |
	date := Date today.
	^ GdsVector 
		withAll: (self integerVector: { 
						(date monthIndex).
						(date dayOfMonth).
						(date year asString)})! !

!GplDateTimeHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 16:02'!
tod: aToken
	| time |
	time := Time now.
	^ GdsVector 
		withAll: (self integerVector: { 
						(time hour).
						(time minute).
						(time second)})! !

GplMultiHandler subclass: #GplFunctions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplFunctions class methodsFor: 'accessing' stamp: 'kf 5/30/2009 20:24'!
associateArray
	^{
	'IDKEYS' -> #idKeys: .
	'KEYCE' -> #keyCe: .
	'CEKEY' -> #ceKey: }! !

!GplFunctions class methodsFor: 'testing' stamp: 'kf 5/30/2009 17:44'!
isFunctionAllowed
	^true! !

!GplFunctions class methodsFor: 'testing' stamp: 'kf 5/30/2009 17:28'!
isFunctionAllowed: aCommandName
	^true! !

!GplFunctions methodsFor: 'handler' stamp: 'kf 5/30/2009 17:50'!
ceKey: aToken
	| gv1 smVec element smPoint |
	self mustStructureOpen.
	gv1 := evaluter popArg asGplValue asVector.
	smVec := gv1 asSmalltalkValue.
	smVec size = 2 ifFalse: [^self illigalCoordinate].
	smPoint := smVec first@smVec second.
	element := self structure findNearestElementByPoint: smPoint.
	^element
		ifNil: [self nullVector]
		ifNotNil: [element keyNumber asGdsValue ]
	! !

!GplFunctions methodsFor: 'handler' stamp: 'kf 5/30/2009 20:24'!
idKeys: aToken
	self mustStructureOpen.
	^(self structure idSelection keyNumbers) asArray asGdsValue. 
! !

!GplFunctions methodsFor: 'handler' stamp: 'kf 5/30/2009 17:40'!
keyCe: aToken
	| gv1 smVec element smPoint |
	self mustStructureOpen.
	gv1 := evaluter popArg asGplValue asVector.
	smVec := gv1 asSmalltalkValue.
	smVec size = 1 ifFalse: [^self error: 'ARGUMENT MUST KEYNUMBER ONLY'].
	element := self findElementByKeyNumber: smVec first.
	smPoint := element xy.
	^{smPoint x . smPoint y } asGdsValue.! !

GplMultiHandler subclass: #GplMarkHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplMarkHandler class methodsFor: 'accessing' stamp: 'kf 5/30/2009 20:47'!
associateArray
	^{
	'KEYMARK' -> #keyMark: . 
	'MARK' -> #mark: . 
	'REMOVE' -> #remove: . 
	'MARKELKEYS'-> #markElementKeys:}! !

!GplMarkHandler class methodsFor: 'testing' stamp: 'kf 5/29/2009 10:03'!
isFunctionAllowed: aCommandName
	^false! !

!GplMarkHandler methodsFor: 'handler' stamp: 'kf 5/30/2009 20:51'!
keyMark: aToken
	| arg1 keyNumbers |
	self mustStructureOpen.
	arg1 := evaluter popArg asGplValue.
	keyNumbers := arg1 asVector asSmalltalkValue .
	self markByKeys: keyNumbers.
	^self nullVector. 	! !

!GplMarkHandler methodsFor: 'handler' stamp: 'kf 5/30/2009 20:33'!
mark: aToken
	| arg1 gv1 numRow mat points |
	self mustStructureOpen.
	arg1 := evaluter popArg asGplValue.
	gv1 := arg1 asVector.
	self mustBeCoordinatable: gv1.
	gv1 size \\ 2 = 0 ifFalse: [^self illigalCoordinate].
	numRow := gv1 size // 2.
	mat := Matrix  rows: numRow columns: 2 contents: gv1 asSmalltalkValue.
	self structureMorph setVisible: true forKey:  #mark.
	points := OrderedCollection new.
	1 to: mat rowCount do: [:rowIndex |
		points add: ((mat at: rowIndex at: 1) @ (mat at: rowIndex at: 2))].
	self markPoints: points.
	 ^self nullVector. 	! !

!GplMarkHandler methodsFor: 'handler' stamp: 'kf 5/30/2009 14:37'!
markElementKeys: aToken
	self mustStructureOpen.
	self structureMorph setVisible: true forKey:  #mark.
	self structureMorph showsElementKey: true.
	self structureMorph invalidRect: self structureMorph bounds.
	 ^self nullVector. 	! !

!GplMarkHandler methodsFor: 'handler' stamp: 'kf 5/30/2009 14:43'!
remove: aToken
	self mustStructureOpen.
	self structureMorph clearMarker.
	 ^self nullVector. 	! !

!GplMultiHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 13:33'!
associateArray
	^self subclassResponsibility .
	! !

!GplMultiHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 13:47'!
commandNames
	| names |
	names := OrderedCollection new.
	self allSubclasses do: [:clazz |
		 clazz methodNames do: [:mname |
			names add: mname asUppercase]].
	^names asArray.! !

!GplMultiHandler class methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:09'!
functionNames
	"self functionNames"
	| colNames |
	colNames := OrderedCollection new.
	self allSubclasses do: [:clazz | 
		clazz methodNames do: [:each | 
			(clazz isFunctionAllowed: each)
				ifTrue: [colNames add: each] ]].
	^colNames asArray.! !

!GplMultiHandler class methodsFor: 'testing' stamp: 'kf 5/29/2009 10:02'!
isFunctionAllowed: aCommandName
	self subclassResponsibility ! !

!GplMultiHandler class methodsFor: 'private' stamp: 'kf 5/28/2009 13:14'!
lookupHandlerClass: aCommandName
	^self allSubclasses
		detect: [:clazz | 
			clazz methodNames
				anySatisfy: [:each | each sameAs: aCommandName]] ifNone: [nil]
	! !

!GplMultiHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 13:39'!
methodNames
	^self associateArray collect: [:each | each key ]! !

!GplMultiHandler class methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:10'!
procedureNames
	"self procedureNames"
	| colNames |
	colNames := OrderedCollection new.
	self allSubclasses do: [:clazz | 
		clazz methodNames do: [:each | 
			(clazz isFunctionAllowed: each)
				ifFalse: [colNames add: each] ]].
	^colNames asArray.! !

!GplMultiHandler class methodsFor: 'private' stamp: 'kf 5/28/2009 17:36'!
selectorForMethodName: aCommandName
	^(self selectorMap at: aCommandName asUppercase)! !

!GplMultiHandler class methodsFor: 'private' stamp: 'kf 5/28/2009 13:33'!
selectorMap
	^Dictionary newFrom: self associateArray .
	! !

!GplMultiHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 13:36'!
evaluteToken: aToken
	| selector |
	selector := self class selectorForMethodName: aToken fragment.
	^self perform: selector with: aToken! !

GplMultiHandler subclass: #GplViewingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplViewingHandler class methodsFor: 'accessing' stamp: 'kf 5/30/2009 15:26'!
associateArray
	^{'PAN' -> #pan:  . 'ZOOM' -> #zoom:  . 'FIT' -> #fit: }! !

!GplViewingHandler class methodsFor: 'testing' stamp: 'kf 5/29/2009 10:04'!
isFunctionAllowed: aCommandName
	^false! !

!GplViewingHandler methodsFor: 'handler' stamp: 'kf 5/30/2009 15:26'!
fit: aToken
	self mustStructureOpen.
	self viewport viewFit.
	 ^self nullVector. ! !

!GplViewingHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 17:29'!
pan: aToken
	| arg1 gv1 sv1 |
	self mustStructureOpen.
	arg1 := evaluter popArg asGplValue.
	gv1 := arg1 asVector.
	self mustBeCoordinatable: gv1.
	gv1 size = 2 ifFalse: [^self illigalCoordinate].
	sv1 := gv1 asSmalltalkValue.
	self viewport viewCenter: (sv1 first @ sv1 second).
	 ^self nullVector. ! !

!GplViewingHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 17:59'!
zoom: aToken
	| arg1 gv1 sv1 |
	self mustStructureOpen.
	arg1 := evaluter popArg asGplValue.
	gv1 := arg1 asVector.
	self mustBeCoordinatable: gv1.
	gv1 size = 1 ifFalse: [^self error: 'RELATIVE MAGINIFY MUST SCALAR'].
	sv1 := gv1 asSmalltalkValue first.
	(sv1 = 0.0 or: [sv1 negative])
		 ifTrue: [^self error: 'POSITIVE VALUE BUT: ', sv1 asString].
	self viewport zoom: sv1.
	 ^self nullVector. ! !

GplHandler subclass: #GplSingleHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

GplSingleHandler subclass: #GplBiContextHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplBiContextHandler class methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:13'!
functionNames
	^self methodNames! !

!GplBiContextHandler class methodsFor: 'testing' stamp: 'kf 5/29/2009 16:58'!
isFunctionAllowed
	^true.! !

!GplBiContextHandler class methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:14'!
procedureNames
	^self methodNames! !

!GplBiContextHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 18:16'!
evaluteToken: aToken 
	^(self isFunctionCall: aToken)
		ifTrue: [self functionCall: aToken]
		ifFalse: [self procedureCall: aToken]
	! !

!GplBiContextHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 18:15'!
functionCall: aToken
	self subclassResponsibility! !

!GplBiContextHandler methodsFor: 'testing' stamp: 'kf 5/28/2009 18:14'!
isFunctionCall: aToken 
	^aToken leftTokens isEmpty not! !

!GplBiContextHandler methodsFor: 'handler' stamp: 'kf 5/28/2009 18:15'!
procedureCall: aToken
	self subclassResponsibility! !

GplBiContextHandler subclass: #GplGridMultiply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplGridMultiply class methodsFor: 'as yet unclassified' stamp: 'kf 6/10/2009 10:35'!
methodName
	^'GRID'! !

!GplGridMultiply methodsFor: 'as yet unclassified' stamp: 'kf 6/10/2009 10:36'!
functionCall: aToken
	^self viewport grid displayMultiply asInteger asGdsValue! !

!GplGridMultiply methodsFor: 'as yet unclassified' stamp: 'kf 6/10/2009 13:42'!
procedureCall: aToken
	| gv1 vec smVec value |
	self viewport grid.
	(evaluter numArgs: aToken) = 0
		ifTrue: [
			value := self call: 'GRID (EXPINPUT "Enter Grid Multiplier Count: ")'.]
		ifFalse: [
			gv1 := evaluter popArg asGplValue.
			vec := gv1 asVector.
			smVec := vec asSmalltalkValue.
			(smVec size = 1)
				ifFalse: [^self error: 'ILLIGAL ARGUMENT '].
			value := smVec first.].
	value fractionPart = 0.0
		ifFalse: [^self error: 'SCALE MUST BE INTEGER VALUE'].
	self viewport grid displayMultiply:  value.		
	self fullRedraw.
	^self nullVector! !

GplBiContextHandler subclass: #GplGridScale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplGridScale class methodsFor: 'as yet unclassified' stamp: 'kf 6/9/2009 10:37'!
methodName
	^'GSCALE'! !

!GplGridScale methodsFor: 'as yet unclassified' stamp: 'kf 6/9/2009 13:58'!
functionCall: aToken
	^self viewport grid asArray asGdsValue
! !

!GplGridScale methodsFor: 'as yet unclassified' stamp: 'kf 6/10/2009 13:27'!
procedureCall: aToken
	| gv1 vec smVec |
	self viewport grid.
	gv1 := evaluter popArg asGplValue.
	vec := gv1 asVector.
	smVec := vec asSmalltalkValue.
	(#(1 2 4) includes: (smVec size))
		ifFalse: [^self error: 'ILLIGAL ARGUMENT '].
	smVec size = 1
		ifTrue: [
			 self viewport grid scale: smVec first asPoint].
	smVec size = 2
		ifTrue: [
			 self viewport grid scale: (smVec first@smVec second)].
	smVec size = 4
		ifTrue: [
			 self viewport
				grid 
					offset: (smVec first@smVec second);
					scale: (smVec third@smVec fourth).].		
	self fullRedraw.
	^self nullVector! !

GplBiContextHandler subclass: #GplInitLib
	instanceVariableNames: 'libname dbu unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplInitLib class methodsFor: 'as yet unclassified' stamp: 'kf 6/11/2009 14:18'!
methodName
	^'INITLIB'! !

!GplInitLib methodsFor: 'as yet unclassified' stamp: 'kf 6/12/2009 11:21'!
extractArguments
	| arg1 gv1 |
	arg1 := evaluter popArg.
	gv1 := arg1 asGplValue.
	gv1 isList 
		ifFalse: [^self error: self usageString].
	gv1 length = 6
		ifFalse: [^self error: self usageString].
	libname := gv1 at: 1.
	dbu := gv1 at: 4.
	unit := gv1 at: 5.
	self extractLibName.
	self extractDatabaseUnits.	
	self extractUnitString.! !

!GplInitLib methodsFor: 'as yet unclassified' stamp: 'kf 6/12/2009 15:59'!
extractDatabaseUnits
	dbu := [dbu asScalar] 
		on: Error 
		do: [:ex | 
			dbu := nil.
			^self error: 'DBU MUST BE SCALAR VALUE']. 
	dbu := dbu asSmalltalkValue.
	GdsLibrary checkDatabaseUnit: dbu.
! !

!GplInitLib methodsFor: 'as yet unclassified' stamp: 'kf 6/12/2009 15:58'!
extractLibName
	libname isCharVector
		 ifFalse: [
			libname := nil.
			^self error: 'LIBRARY NAME MUST BE STRING'].
	libname := 	libname gplString.
	GdsLibrary checkLibName: libname.
! !

!GplInitLib methodsFor: 'as yet unclassified' stamp: 'kf 6/12/2009 16:04'!
extractUnitString
	unit isCharVector
		 ifFalse: [
			unit := nil.
			^self error: 'UNIT  MUST BE STRING'].
	unit := unit gplString.
	GdsLibrary checkUnitString: unit.
! !

!GplInitLib methodsFor: 'as yet unclassified' stamp: 'kf 6/11/2009 14:19'!
functionCall: aToken! !

!GplInitLib methodsFor: 'as yet unclassified' stamp: 'kf 6/15/2009 21:07'!
procedureCall: aToken 
	| lib |
	(evaluter numArgs: aToken) < 1 ifTrue: [ ^ self error: 'MISSING ARGUMENT' ].
	self extractArguments.
	lib := GdsLibrary 
		initializeName: libname
		databaseUnits: dbu
		unitString: unit.
	^ self nullVector! !

!GplInitLib methodsFor: 'as yet unclassified' stamp: 'kf 6/11/2009 17:54'!
usageString
	^ 'INITLIB {filename};"";"";{dbu};{unit};""'.
! !

GplBiContextHandler subclass: #GplSetView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplSetView class methodsFor: 'accessing' stamp: 'kf 5/28/2009 18:31'!
methodName
	^'SETVIEW'! !

!GplSetView methodsFor: 'handler' stamp: 'kf 5/30/2009 10:00'!
functionCall: aToken
	^GdsMatrix 
		fromOrigin:  self viewport  worldViewOrigin
		corner: self viewport  worldViewCorner! !

!GplSetView methodsFor: 'handler' stamp: 'kf 5/28/2009 20:31'!
procedureCall: aToken
	| gv1 vec smVec worldBounds |
	gv1 := evaluter popArg asGplValue.
	vec := gv1 asVector.
	vec size = 4 ifFalse: [^self illigalCoordinate ].
	smVec := vec asSmalltalkValue.
	worldBounds := 
		GeometryUtils lookupDataBounds: {(smVec first @smVec second) . (smVec third @smVec fourth)}.
	worldBounds extent isZero ifTrue: [^self illigalCoordinate ].
	self viewport viewBounds: worldBounds.
	^self nullVector! !

GplSingleHandler subclass: #GplCloseBetaLib
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplCloseBetaLib class methodsFor: 'accessing' stamp: 'kf 6/18/2009 16:22'!
methodName
	"@deprecated "
	^''! !

!GplCloseBetaLib methodsFor: 'handler' stamp: 'kf 6/3/2009 08:45'!
evaluteToken: aToken
	| clazz instances|
	self station structure
		ifNotNil: [self call: 'TSTRUCT'].
	clazz := self stationUIClass.
	clazz 
		ifNotNil: [
			instances := clazz noGarbageTargetInstances. 
			instances do: [:each | each delete.].
			Smalltalk garbageCollect ].
	^self nullVector.! !

GplSingleHandler subclass: #GplCloseLib
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplCloseLib class methodsFor: 'as yet unclassified' stamp: 'kf 6/18/2009 16:22'!
methodName
	^'CLOSELIB'! !

!GplCloseLib methodsFor: 'as yet unclassified' stamp: 'kf 6/18/2009 16:07'!
evaluteToken: aToken
	| clazz instances|
	self station structure
		ifNotNil: [self call: 'TSTRUCT'].
	clazz := self stationUIClass.
	clazz 
		ifNotNil: [
			instances := clazz noGarbageTargetInstances. 
			instances do: [:each | each delete.].
			Smalltalk garbageCollect ].
	^self nullVector.! !

GplSingleHandler subclass: #GplCommands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplCommands class methodsFor: 'accessing' stamp: 'kf 5/17/2009 00:19'!
methodName
	^'COMMANDS'! !

!GplCommands methodsFor: 'handler' stamp: 'kf 5/17/2009 17:55'!
evaluteToken: aToken
	^self strings: (GplHandler commandNames sort)! !

GplSingleHandler subclass: #GplCoords
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplCoords class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:45'!
isFunctionAllowed
	^true.
	! !

!GplCoords class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:45'!
isNiladicAllowed
	^true.
	! !

!GplCoords class methodsFor: 'accessing' stamp: 'kf 5/16/2009 22:09'!
methodName
	^'COORDS'! !

!GplCoords methodsFor: 'handler' stamp: 'kf 5/23/2009 19:31'!
evaluteToken: aToken 
	| values |
	values := OrderedCollection new.
	self currentItem vertices do: 
			[:pt | 
			values add: pt x.
			values add: pt y].
	values ifEmpty: [^ self nullVector].
	^ GdsMatrix 
		fromGdsVector: (GdsVector withAll: (self floatVector: values))
		row: self currentItem vertices size
		col: 2! !

GplSingleHandler subclass: #GplDataExtent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplDataExtent class methodsFor: 'testing' stamp: 'kf 5/30/2009 09:49'!
isFunctionAllowed
	^true.! !

!GplDataExtent class methodsFor: 'testing' stamp: 'kf 5/30/2009 09:50'!
isNiladicAllowed
	^true.
	! !

!GplDataExtent class methodsFor: 'accessing' stamp: 'kf 5/30/2009 09:49'!
methodName
	^'DATAEXTENT'! !

!GplDataExtent methodsFor: 'handler' stamp: 'kf 5/30/2009 21:37'!
evaluteToken: aToken 
	| numArgs |
	self mustStructureOpen.
	numArgs := evaluter numArgs: aToken.
	numArgs = 0
		ifTrue: [
			^self fullExtent].
	^self keysExtent.
	
	! !

!GplDataExtent methodsFor: 'handler' stamp: 'kf 5/30/2009 21:32'!
fullExtent
	self structure liveElements
		ifEmpty: [^self nullVector].
	^GdsMatrix fromRectangle:  self structure dataExtentForElements.
	! !

!GplDataExtent methodsFor: 'handler' stamp: 'kf 5/30/2009 21:41'!
keysExtent
	| gv1 smVec elements errorKeys smBounds |
	gv1 := evaluter popArg asGplValue.
	smVec := gv1 asVector asSmalltalkValue.
	elements := OrderedCollection new.
	errorKeys := OrderedCollection new.
	self 
		keyNumbers: smVec 
		doWithElement: [:key :element| 
			element
				ifNil: [errorKeys add: key]
				ifNotNil: [elements add: element]].
	self illigalKeyNumbers: errorKeys.
	elements ifEmpty: [^self nullVector].
	smBounds := self structure 
		lookupDataExtentForElementsChooserBlock: [:element |
			elements includes: element].
	^GdsMatrix fromRectangle: smBounds. 
	! !

GplSingleHandler subclass: #GplGet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplGet class methodsFor: 'accessing' stamp: 'kf 5/30/2009 14:45'!
methodName
	^'GET'
	! !

!GplGet methodsFor: 'handler' stamp: 'kf 5/30/2009 17:37'!
evaluteToken: aToken
	| gv1 vec smVec element |
	self mustStructureOpen. 
	self currentItem getEnabled
		ifFalse: [^self error: 'ITEM NOT EMPTY'].	
	gv1 := evaluter popArg asGplValue.
	vec := gv1 asVector.
	(#(1 2) includes: (vec size)) ifFalse: [^self error: self usage ].
	smVec := vec asSmalltalkValue.
	(smVec size = 2)
		ifTrue: [
			element := self structure 
				findNearestElementByPoint: (smVec first@smVec second).
			element
				ifNil: [
					^self error: ('CANNT GET ELEMENT AT: <1s> <2s>' 
						expandMacrosWith:  smVec first  with: smVec second asString)]
				ifNotNil: [self currentItem get: element]].
	(smVec size = 1)
		ifTrue: [
			element := self findElementByKeyNumber: smVec first.
			self currentItem get: element].
			
	^self nullVector
! !

!GplGet methodsFor: 'as yet unclassified' stamp: 'kf 5/30/2009 15:00'!
usage
	^'usage:
 GET {X} {Y}
  or
 GET {KEY}'! !

GplSingleHandler subclass: #GplIota
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplIota class methodsFor: 'testing' stamp: 'kf 5/21/2009 22:46'!
isFunctionAllowed
	^true.
	! !

!GplIota class methodsFor: 'accessing' stamp: 'kf 5/16/2009 23:39'!
methodName
	^'IOTA'
	! !

!GplIota methodsFor: 'handler' stamp: 'kf 5/27/2009 16:17'!
evaluteToken: aToken 
	| v step start end values |
	(evaluter numArgs: aToken) < 1 
		ifTrue: [^ self runtimeError: 'MISSING ARGUMENT for IOTA'].
	v := evaluter popArg asGplValue asVector.
	(v size > 3 or: [v size < 1]) 
		ifTrue: 
			[^ self runtimeError: 'ILLIGAL ARGUMENT SIZE: {m} or {n} {m} or {n} {step} {m}'].
	(#('BOOLEAN' 'INTEGER' ) includes: v typeString) 
		ifFalse: [^ self runtimeError: 'ILLIGAL NUMERIC INPUT'].
	step := 1.
	start := 1.
	end := 1.
	v size = 1 ifTrue: [end := (v at: 1) asSmalltalkValue].
	v size = 2 
		ifTrue: 
			[start := (v at: 1) asSmalltalkValue.
			end := (v at: 2) asSmalltalkValue].
	v size = 3 
		ifTrue: 
			[start := (v at: 1) asSmalltalkValue.
			step := (v at: 2) asSmalltalkValue.
			end := (v at: 3) asSmalltalkValue].
	values := (start to: end by: step) collect: [:v1 | v1].
	^ GdsVector 
		withAll: (values collect: [:v2 | GdsInteger fromLiteral: v2 asString])! !

GplSingleHandler subclass: #GplListLib
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplListLib class methodsFor: 'accessing' stamp: 'kf 5/17/2009 17:34'!
methodName
	^'LISTLIB'! !

!GplListLib methodsFor: 'handler' stamp: 'kf 5/20/2009 16:37'!
evaluteToken: aToken
	| arg1 gdsPattern sqPattern names |
	names := self library structureNames.
	((evaluter numArgs: aToken) > 0)
		ifTrue: [
			arg1 := evaluter popArg asGplValue.
			self mustbeString: arg1.
			gdsPattern := arg1 gplString.
			"TODO: real implements"
			sqPattern := gdsPattern copyReplaceAll: '-' with: '*'.
			names := names select: [: each | sqPattern match: each ].].		
	^self strings: names.
	! !

GplSingleHandler subclass: #GplOpenBetaLib
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplOpenBetaLib class methodsFor: 'accessing' stamp: 'kf 6/18/2009 16:19'!
methodName
	"@deprecated"
	^''! !

!GplOpenBetaLib methodsFor: 'handler' stamp: 'kf 6/9/2009 10:13'!
evaluteToken: aToken
	| clazz |
	clazz := self stationUIClass.
	clazz 
		ifNotNil: [
			Semaphore forMutualExclusion 
				critical: [
					clazz openWithInform: false]].
	^self nullVector.! !

GplSingleHandler subclass: #GplOpenLib
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplOpenLib class methodsFor: 'as yet unclassified' stamp: 'kf 6/18/2009 16:06'!
methodName
	^'OPENLIB'! !

!GplOpenLib methodsFor: 'as yet unclassified' stamp: 'kf 6/18/2009 16:30'!
evaluteToken: aToken
	| clazz arg1 libName |
	(evaluter numArgs: aToken) < 1 
		ifTrue: [^ self runtimeError: 'MISSING LIBRARY NAME'].
	arg1 := evaluter popArg asGplValue.
	self mustbeString: arg1.
	libName := arg1 gplString.
	(GdsLibrary exists: libName)
		ifFalse: [^self error: 'LIBRARY NOT FOUND: ', libName].
	clazz := self stationUIClass.
	clazz 
		ifNotNil: [
			"Semaphore forMutualExclusion 
				critical: ["
					clazz openWithInform: false.
					self station openLibraryNamed:  libName"]"].
	^self nullVector.! !

GplSingleHandler subclass: #GplOpenStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplOpenStructure class methodsFor: 'accessing' stamp: 'kf 5/17/2009 18:20'!
methodName
	^'OSTRUCT'! !

!GplOpenStructure methodsFor: 'handler' stamp: 'kf 6/9/2009 14:00'!
evaluteToken: aToken
	| arg1 struct structureName |
	Smalltalk garbageCollect.
	(evaluter numArgs: aToken)  = 0
		ifTrue: [^self error: 'STRUCTURE NAME NOT SPECIFIED'].
	self station structure
		ifNotNil: [^self error: 'STRUCTURE ALREADY OPEND: ', self station structure name].
	arg1 := evaluter popArg asGplValue.
	self mustbeString: arg1.
	structureName := arg1 gplString.
	struct :=  self station library structureNamed: structureName.
	struct ifNil: [^self error: 'STRUCTURE NOT FOUND: ', structureName].
	Semaphore forMutualExclusion 
		critical: [self station ostructNames: [: names | structureName]].
	^self nullVector.
	! !

!GplSingleHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 13:44'!
commandNames
	^((self allSubclasses collect: [:clazz | clazz methodName asUppercase])
		reject: [:each | each isEmpty]) asArray! !

!GplSingleHandler class methodsFor: 'accessing' stamp: 'kf 5/29/2009 09:59'!
functionNames
	"self functionNames"
	^((self allSubclasses select: [:clazz | 
			clazz isFunctionAllowed ])
		collect: [:each | each methodName]) asArray! !

!GplSingleHandler class methodsFor: 'accessing' stamp: 'kf 5/28/2009 13:17'!
lookupHandlerClass: aCommandName
	^self allSubclasses detect: [:clazz | clazz methodName sameAs: aCommandName] ifNone: [nil]
	! !

!GplSingleHandler class methodsFor: 'accessing' stamp: 'kf 6/8/2009 14:20'!
methodNames
	^((self allSubclasses collect: [:clazz | clazz methodName asUppercase])
		reject: [:each | each isEmpty]) asArray! !

!GplSingleHandler class methodsFor: 'accessing' stamp: 'kf 5/29/2009 09:57'!
procedureNames
	"self procedureNames"
	^((self allSubclasses select: [:clazz | 
			clazz isFunctionAllowed not])
		collect: [:each | each methodName]) asArray! !

GplSingleHandler subclass: #GplTerminateStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplTerminateStructure class methodsFor: 'accessing' stamp: 'kf 5/18/2009 21:37'!
methodName
	^'TSTRUCT'! !

!GplTerminateStructure methodsFor: 'handler' stamp: 'kf 5/18/2009 22:22'!
evaluteToken: aToken
	self station structure ifNil: [^self error: 'NO STRUCTURE OPEN.'].
	self currentItem putEnabled
		ifTrue: [^self error: 'ITEM NOT EMPTY. TO USE [PUT] or [PUTALL] or [UNGET]']. 
	self  structure idSelection isEmpty
		ifFalse: [^self error: 'ELEMENTS STILL IN ID SPACE . TO USE [UNID] or [IDCLEAR]'].
	self station tstruct.	
	^self nullVector.
	! !

GplSingleHandler subclass: #GplTextInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

GplTextInput subclass: #GplExpInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Commands'!

!GplExpInput class methodsFor: 'as yet unclassified' stamp: 'kf 6/10/2009 13:01'!
methodName
	^'EXPINPUT'! !

!GplExpInput methodsFor: 'as yet unclassified' stamp: 'kf 6/10/2009 16:12'!
signalResult
	| textResult vec |
	textResult := super signalResult.
	textResult = GdsNull instance ifTrue: [^GdsNull instance].
	vec := GdsVector fromLiteral: (textResult gplString).
	vec size = 1 ifTrue: [^vec elements first].
	^vec! !

!GplTextInput class methodsFor: 'as yet unclassified' stamp: 'kf 6/5/2009 15:45'!
isFunctionAllowed
	^true.
	! !

!GplTextInput class methodsFor: 'as yet unclassified' stamp: 'kf 6/5/2009 15:46'!
methodName
	^'TEXTINPUT'! !

!GplTextInput methodsFor: 'handler' stamp: 'kf 6/10/2009 13:08'!
evaluteToken: aToken 
	evaluter hasSuspendContext
		ifFalse: [
			^self signalPrompt: thisContext].
	^self signalResult.! !

!GplTextInput methodsFor: 'handler' stamp: 'kf 6/12/2009 09:12'!
signalPrompt: aContext
	| arg1 gv1 |
	arg1 := evaluter popArg.
	gv1 := arg1 asGplValue.
	gv1 isCharVector
		ifFalse: [^self error: 'PROMPT MUST BE STRING'].
	evaluter pushSuspendContext: aContext.	
	^GplPromptException new signal: 	gv1 gplString
! !

!GplTextInput methodsFor: 'handler' stamp: 'kf 6/10/2009 11:51'!
signalResult
	| smPrompt |
	smPrompt := evaluter popResult.
	self assert: smPrompt isNil not.
	"lastContext explore."
	^smPrompt asGdsValue.
! !

GdsObject subclass: #GplParserBase
	instanceVariableNames: 'input words'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

!GplParserBase commentStamp: 'kf 4/19/2009 21:28' prior: 0!
A GplParser is GPL Parser.

- scanToken: aString
 phase1 parsing.
 no type tag spliter.
 all element class is String. but lineEnding only #cr (Symbol)

TODO: 
build parse tree.

Instance Variables
	colWords:		<Collection<String|Symbol>>
	currentWords:		<Collection<String|Symbol>>
	input:		<ReadStream>
	stack:		<Collection<Collection>>

colWords
	- xxxxx

currentWords
	- current level word collection

input
	- GPL II statement input stream.

stack
	- using pushLevel: popLevel: 
!

GplParserBase subclass: #GplParser
	instanceVariableNames: 'source ranges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

!GplParser commentStamp: 'kf 4/22/2009 21:59' prior: 0!
A GplParser is GPL Parser.

- scanToken: aString
 phase1 parsing.
 no type tag spliter.
 all element class is String. but lineEnding only #cr (Symbol)

TODO: 
build parse tree.

Instance Variables
	colWords:		<Collection<String|Symbol>>
	currentWords:		<Collection<String|Symbol>>
	input:		<ReadStream>
	stack:		<Collection<Collection>>

colWords
	- xxxxx

currentWords
	- current level word collection

input
	- GPL II statement input stream.

stack
	- using pushLevel: popLevel: 
!

!GplParser class methodsFor: 'private' stamp: 'kf 4/24/2009 11:45'!
assertGplTokens: aCollection
	self assert: [aCollection allSatisfy: [:each | each isMemberOf: GplToken]].
	! !

!GplParser class methodsFor: 'testing' stamp: 'kf 5/23/2009 11:58'!
isNumberFragment: aString	
	^(GdsDglType bestClassOfStatement: aString) isNil not.! !

!GplParser class methodsFor: 'testing' stamp: 'kf 5/23/2009 11:55'!
isOperatorFragment: aString	
	self operatorSpec do: [:specRecord |
		(specRecord value includes: aString)
			ifTrue: [^true]].
	aString size = 1
		ifTrue: [
			^'+-*%;,[]' includes: aString first].	
	^false.! !

!GplParser class methodsFor: 'specification' stamp: 'kf 4/27/2009 17:51'!
operatorSpec
	^{
	377 -> #('[]').
	20 -> #('ABS' 'ARCTAN' 'CEILING' 'COS' 'FLOOR' 'GRADEDOWN' 'GRADEUP'
	        'LN' 'NOT' 'PI' 'SIN' 'SORT' 'SORTDOWN' 'TAN' 
	        '+ (monadic)' '- (monadic)' '* (monadic)' '% (monadic)').
	17 -> #('LOGBASE' 'POWER').
	16 -> #('MAX' 'MIN' 'MOD' '* (dyadic)' '% (dyadic)').
	15 -> #('+ (dyadic)' '- (dyadic)').
	13 -> #('EQ' 'GEQ' 'GT' 'IN' 'LEQ' 'NEQ'
	        '=' '<' '>' '<=' '>=' '<>').
	12 -> #('OR' 'XOR' 'NOR').
	11 -> #('AND' 'NAND').
	10 -> #('IOTA' 'SHAPE' 'LENGTH' 'SIZE' 'TYPEOF'
		      'RANK' ', (monadic)').
	7 -> #('INDEXOF' 'RESHAPE').
	6 -> #(', (dyadic)').
	5 -> #(';').
	0 -> #(':=')
	}! !

!GplParser class methodsFor: 'evaluter' stamp: 'kf 4/22/2009 18:21'!
tokensFrom: aString
	| parser |
	parser := self new source: aString.
	parser splitRanges.
	^parser tokens.! !

!GplParser methodsFor: 'private' stamp: 'kf 4/24/2009 11:45'!
assertGplTokens: aCollection
	self class assertGplTokens: aCollection
	! !

!GplParser methodsFor: 'accessing' stamp: 'kf 4/22/2009 17:30'!
decodeSource
	| prevRange |
	^self tokens do: [:r |
		self fragmentOfRange: r.
		prevRange := r.]! !

!GplParser methodsFor: 'accessing' stamp: 'kf 4/20/2009 15:58'!
fragmentOfRange: aGplRange
	| s |
	s := self source copyFrom: aGplRange start to: aGplRange end.
	(s anySatisfy: [:each | {Character cr . Character lf} includes: each])
	ifTrue: [^#cr].
	
	^s.! !

!GplParser methodsFor: 'private' stamp: 'kf 4/20/2009 15:37'!
handleBlanks
	self scanBlanks.! !

!GplParser methodsFor: 'initialization' stamp: 'kf 4/20/2009 13:03'!
initialize
	super initialize.
	ranges := OrderedCollection new.
	! !

!GplParser methodsFor: 'private' stamp: 'kf 4/20/2009 10:54'!
pushNotEmpty: aWriteStream start: aInteger
	aWriteStream contents ifEmpty: [^self].
	self start: aInteger length: aWriteStream contents size.
	
	! !

!GplParser methodsFor: 'range recording' stamp: 'kf 4/22/2009 17:26'!
rangeType: aSymbol start: s end: e 
	^ranges add: (GplToken start: s end: e type: aSymbol parser: self)! !

!GplParser methodsFor: 'scanning' stamp: 'kf 4/26/2009 19:22'!
scanLineEnd: aCharacter
	| start length |
	start := input position + 1.
	length := 0.
	(aCharacter = Character cr)
		ifTrue: [
			length := 1.
			self pushWord: #cr.
			(input peek = Character lf)
				ifTrue: [
					length := length + 1].
			input skip: length.
			self rangeType: #cr start: start end: start + length - 1.
			^self].
	(aCharacter = Character lf)
		ifTrue: [
			length := 1.
			input skip: 1.
			self rangeType: #cr start: start end: start + length - 1.
			^self pushWord: #cr.].
	! !

!GplParser methodsFor: 'accessing' stamp: 'kf 4/20/2009 10:29'!
source
	^source! !

!GplParser methodsFor: 'accessing' stamp: 'kf 4/20/2009 10:28'!
source: aString
	source := aString! !

!GplParser methodsFor: 'private' stamp: 'kf 4/20/2009 15:51'!
splitRanges
	super splitTokens: source.
	! !

!GplParser methodsFor: 'parse' stamp: 'kf 4/22/2009 17:34'!
splitTokens: aString
	^self splitTokens: aString withSpace: false.! !

!GplParser methodsFor: 'private' stamp: 'kf 4/22/2009 18:34'!
splitTokens: aString withSpace: aBoolean
	| result |
	self source: aString.
	self splitRanges.
	result := self tokens collect: [:r | r fragment].
	aBoolean ifFalse: [
		result := (self tokens reject: [:r | r type = #space]) collect: [:r | r fragment]].
	^result.! !

!GplParser methodsFor: 'accessing' stamp: 'kf 4/22/2009 17:30'!
splitedWords
	^self tokens collect: [:r | r fragment]! !

!GplParser methodsFor: 'range recording' stamp: 'kf 4/22/2009 18:39'!
start: s end: e 
	^self rangeType: #unresolved start: s end: e.
	! !

!GplParser methodsFor: 'range recording' stamp: 'kf 4/20/2009 13:23'!
start: s length: l 
	^self start: s end: s + l - 1.
	! !

!GplParser methodsFor: 'accessing' stamp: 'kf 4/22/2009 18:35'!
tokens
	^self tokensIgnoreSpace: true.! !

!GplParser methodsFor: 'accessing' stamp: 'kf 4/22/2009 18:36'!
tokensIgnoreSpace: aBoolean
	aBoolean
		ifTrue: [
			^(ranges reject: [:r | r fragment trimBlanks isEmpty]) asArray].
	^ranges asArray! !

!GplParser methodsFor: 'analysis' stamp: 'kf 4/24/2009 15:19'!
vectorAnalysisFromTokens: aGplTokens
	| stream vectorTokens token newOutput|
	self assertGplTokens: aGplTokens.
	stream := ReadStream on: aGplTokens.
	newOutput := OrderedCollection new.
	vectorTokens := OrderedCollection new.
	[stream atEnd] 
		whileFalse: [
			token := stream next.
			token type = #number 
				ifTrue: [.
					vectorTokens add: token]
				ifFalse: [
					vectorTokens
						ifNotEmpty: [
							| newToken |
							newToken := GplToken newFromTokens: vectorTokens.
							newOutput add: newToken.
							vectorTokens := OrderedCollection new.].
					newOutput add: token]].
		vectorTokens
			ifNotEmpty: [
				| newToken |
				newToken := GplToken newFromTokens: vectorTokens.
				newOutput add: newToken.
				vectorTokens := OrderedCollection new.].
	^newOutput asArray.! !

!GplParserBase class methodsFor: 'testing' stamp: 'kf 4/25/2009 20:44'!
isLineEndFirst: aCharacter
	^(aCharacter = Character cr) or: [aCharacter = Character lf]
! !

!GplParserBase class methodsFor: 'testing' stamp: 'kf 4/25/2009 20:44'!
isNameAfterSecond: aCharacter
	(aCharacter isLetter or: [aCharacter isDigit]) ifTrue: [^true].
	^'$_' includes: aCharacter
	
		
	
	
	! !

!GplParserBase class methodsFor: 'testing' stamp: 'kf 4/25/2009 20:44'!
isNameFirst: aCharacter
	aCharacter = $$ ifTrue: [^true].
	^aCharacter isLetter
	
		
	
	
	! !

!GplParserBase class methodsFor: 'testing' stamp: 'kf 4/25/2009 20:44'!
isNumberAllowed: aCharacter
	^aCharacter isDigit or:['-.E' includes: aCharacter]
	
		
	
	
	! !

!GplParserBase class methodsFor: 'testing' stamp: 'kf 4/25/2009 20:44'!
isNumberFirst: aCharacter
	^aCharacter isDigit or:['-.' includes: aCharacter]
	
		
	
	
	! !

!GplParserBase class methodsFor: 'testing' stamp: 'kf 4/25/2009 20:44'!
isTabOrSpace: aCharacter
	^aCharacter asciiValue == 32 or: [aCharacter asciiValue == 9]
	
		
	
	
	! !

!GplParserBase class methodsFor: 'parse' stamp: 'kf 11/11/2008 14:06'!
splitTokens: aString
	^self new splitTokens: aString.! !

!GplParserBase class methodsFor: 'parse' stamp: 'kf 4/19/2009 20:55'!
textTookenStream: aString
	^ReadStream on: (self splitTokens: aString).! !

!GplParserBase class methodsFor: 'parse' stamp: 'kf 4/19/2009 20:52'!
tokenStream: aString
	^ReadStream on: (self splitTokens: aString).! !

!GplParserBase methodsFor: 'accessing' stamp: 'kf 11/11/2008 10:00'!
char2Words
	^{ ':=' . '<>' . '<=' . '>=' }! !

!GplParserBase methodsFor: 'private' stamp: 'kf 4/20/2009 15:36'!
handleBlanks
	self skipBlanks.	
	
	
	! !

!GplParserBase methodsFor: 'initialize-release' stamp: 'kf 4/20/2009 10:27'!
initialize
	super initialize.
	words := OrderedCollection new.! !

!GplParserBase methodsFor: 'private' stamp: 'kf 4/27/2009 10:29'!
peek2
	| nextObject |
	nextObject := nil.
	2 timesRepeat: [
		input atEnd ifTrue: [^nil].
		nextObject := input next].
	input position: input position - 2.
	^nextObject! !

!GplParserBase methodsFor: 'private' stamp: 'kf 4/20/2009 10:56'!
pushNotEmpty: aWriteStream
	self pushNotEmpty: aWriteStream start: -1. "ignore -1"
	
	! !

!GplParserBase methodsFor: 'private' stamp: 'kf 4/20/2009 10:56'!
pushNotEmpty: aWriteStream start: aInteger
	aWriteStream contents ifNotEmpty: [self pushWord: aWriteStream contents].
	
	! !

!GplParserBase methodsFor: 'private' stamp: 'kf 4/19/2009 21:30'!
pushWord: aWord
	words add: aWord.
	
	
	! !

!GplParserBase methodsFor: 'private' stamp: 'kf 4/25/2009 20:46'!
scanBlanks
	| noSpace start s |
	start := input position + 1.
	input atEnd ifTrue: [^self].
	noSpace := false.
	s := self writeStream.
	[input atEnd or: [noSpace]]
		whileFalse: [
			| c |
			c := input next.
			noSpace := (self class isTabOrSpace:  c ) not.
			noSpace ifFalse: [s nextPut: c].].
	input atEnd
		ifTrue: [noSpace ifTrue: [input skip: -1]]
		ifFalse: [input skip: -1].
	self pushNotEmpty: s start: start.		
	
	
	! !

!GplParserBase methodsFor: 'scanning-deprecated' stamp: 'kf 4/20/2009 13:55'!
scanDigitOnly
	| digit s start |
	digit := true.
	s := self writeStream.
	start := input position + 1.
	[input atEnd not and: [digit]]
		whileTrue: [
			| c |
			c := input next.
			digit := c isDigit.
			digit ifTrue: [s nextPut: c]].
	self pushNotEmpty: s start: start.
	
	! !

!GplParserBase methodsFor: 'scanning' stamp: 'kf 4/26/2009 15:09'!
scanInlineComment
	| c endOfLine s start |
	endOfLine := false.
	s := self writeStream.
	start := input position + 1.
	[input atEnd or: [endOfLine]]
		whileFalse: [
			c := input next.
			(self class isLineEndFirst: c)
				ifTrue: [
					endOfLine := true.
					input skip: -1.]
				ifFalse: [s nextPut: c].].
	self pushNotEmpty: s start: start.
	! !

!GplParserBase methodsFor: 'scanning' stamp: 'kf 4/26/2009 14:00'!
scanLineEnd: aCharacter
	| length |
	length := 0.
	(aCharacter = Character cr)
		ifTrue: [
			self pushWord: #cr.
			length := length + 1.
			(self peek2 = Character lf)
				ifTrue: [
					length := length + 1].
			input skip: length.
			^self].
	(aCharacter = Character lf)
		ifTrue: [
			length := length + 1.
			input skip: length.						
			^self pushWord: #cr.].! !

!GplParserBase methodsFor: 'scanning' stamp: 'kf 4/20/2009 13:14'!
scanNoSpace
	| space s start |
	space := false.
	s := self writeStream.
	start := input position + 1.
	[input atEnd  or: [space]]
		whileFalse: [
			| c |
			c := input next.
			space := self isTabOrSpace: c.
			space ifFalse: [space := '()' includes: c].
			space ifFalse: [s nextPut: c]].
	self pushNotEmpty: s start: start.
	
	! !

!GplParserBase methodsFor: 'scanning' stamp: 'kf 4/25/2009 20:46'!
scanNumber
	"TODO: implements floating point expression. ex. 1E-5"
	| accept s start exponensialCount minusCount |
	accept := true.
	s := self writeStream.
	start := input position + 1.
	exponensialCount := 0.
	minusCount := 0.	
	[input atEnd not and: [accept]]
		whileTrue: [
			| c |
			c := input next.
			(c = $E)
				ifTrue: [
					(exponensialCount >= 1) ifTrue: [self error: 'Illigal Number format'].					
					exponensialCount := exponensialCount + 1].
			(c = $-)
				ifTrue: [.
					s contents 
						ifNotEmpty: [
							(s contents last isDigit)
								ifTrue:[accept := false]].					
					minusCount := minusCount + 1].
			accept ifTrue: [
				accept := self class isNumberAllowed: c.
				accept ifTrue: [s nextPut: c]]].		
	input atEnd
		ifTrue: [accept ifFalse: [input skip: -1]]
		ifFalse: [input skip: -1].
	self pushNotEmpty: s start: start.
	
! !

!GplParserBase methodsFor: 'scanning' stamp: 'kf 4/20/2009 14:43'!
scanRangeComment
	| c endOfComment s start |
	endOfComment := false.
	s := self writeStream.
	start := input position + 1.
	[input atEnd or: [endOfComment]]
		whileFalse: [
			c := input next.
			(c = $')
				ifTrue: [endOfComment := true].
			s nextPut: c.].
	self pushNotEmpty: s start: start.
	! !

!GplParserBase methodsFor: 'scanning' stamp: 'kf 5/21/2009 18:31'!
scanString
	| count s end start |
	count := 0.
	end := false.
	s := self writeStream.
	start := input position + 1.
	[input atEnd  or: [end ]]
		whileFalse: [
			| c |
			c := input next.
			c = $" ifTrue: [count := count + 1].
			c = $" ifFalse:[ end := count \\ 2 = 0].
			end ifFalse: [s nextPut: c]].
	input atEnd
		ifTrue: [end ifTrue: [input skip: -1]]
		 ifFalse: [input skip: -1].	
	(s contents  = '"')
		ifTrue: [^self error: 'MISSING ". STRING NOT TERMINATED.'].
	(s contents last = $")
		ifFalse: [^self error: 'MISSING ". STRING NOT TERMINATED.'].
	self pushNotEmpty: s start: start.
	
	! !

!GplParserBase methodsFor: 'accessing' stamp: 'kf 5/2/2009 17:13'!
scanToken
	| c c2 start |
	input atEnd ifTrue: [^self].	
	c := input peek.
	c ifNil: [^self].
	(self class isTabOrSpace: c) ifTrue: [^self handleBlanks.].
	(self class isNameFirst: c) ifTrue: [^self scanWord].
	(self class isNumberFirst: c) ifTrue: [^self scanNumber].
	c = $" ifTrue: [^self scanString].
	c = $| ifTrue: [^self scanInlineComment].
	c = $` ifTrue: [^self scanRangeComment.].
	c = $^ ifTrue: [2 timesRepeat: [c := input next].^self].
	"c := input next."
	start := input position + 1.
	self char2Words
		do: [:each |
			(c = each first) 
				ifTrue: [
					c2 := self peek2.
					(c2 = each second)
						ifTrue: [ 
							input skip: 2.					
							^self pushNotEmpty: (each readStream) start: start]]].
	('()[]:;' includes: c)
		ifTrue: [
			input skip: 1.
			^self pushNotEmpty: (c asString readStream) start: start].
	c isSpecial ifTrue: [
		input skip: 1.
		^self pushNotEmpty: (c asString readStream) start: start].
	(self class isLineEndFirst: c)
		ifTrue: [
			^self scanLineEnd: c].
	self error: 'USE ILLIGAL CHARACTER: ', (c asString printString) .! !

!GplParserBase methodsFor: 'scanning' stamp: 'kf 4/25/2009 21:01'!
scanWord
	| accept s  start |
	start := input position.
	accept := true.
	s := self writeStream.
	start := input position + 1.
	[input atEnd not and: [accept]]
		whileTrue: [
			| c |
			c := input next.
			accept := self class isNameAfterSecond: c .
			accept ifTrue: [s nextPut: c]].
			s contents size > 32 ifTrue: [self error: 'VARIABLE NAME LIMIT 32'].
	input atEnd
		ifTrue: [accept ifFalse: [input skip: -1]]
		 ifFalse: [input skip: -1].

	self pushNotEmpty: s start: start.
	! !

!GplParserBase methodsFor: 'private' stamp: 'kf 4/26/2009 21:29'!
skipBlanks
	| noSpace |
	input atEnd ifTrue: [^self].
	noSpace := false.
	[input atEnd or: [noSpace]]
		whileFalse: [
			| c |
			c := input next.
			noSpace := (self class isTabOrSpace:  c ) not.].
	input atEnd
		ifTrue: [noSpace ifTrue: [input skip: -1]]
		ifFalse: [input skip: -1].	
		
	
	
	! !

!GplParserBase methodsFor: 'parse' stamp: 'kf 5/2/2009 17:14'!
splitTokens: aString 
	self splitTokensFrom: aString readStream.
	^ words asArray! !

!GplParserBase methodsFor: 'private-scanning' stamp: 'kf 4/20/2009 17:36'!
splitTokensFrom: aStream 
	| count infinit lastPos |
	input := aStream.
	infinit := false.
	count := 0.
	lastPos := 0.
	[input atEnd or: [infinit]] 
		whileFalse: [ 
			self scanToken.
			(lastPos = input position)
				ifTrue: [
					count := count + 1.
					count > 1000 ifTrue: [infinit := true]].
			infinit ifTrue: [
				Transcript cr; show: '*** WARNING *** infinit loop in parser'.
			lastPos := input position]].
! !

!GplParserBase methodsFor: 'private' stamp: 'kf 11/11/2008 08:13'!
writeStream
	^WriteStream on: (String new: 1000).
	! !

GdsObject subclass: #GplToken
	instanceVariableNames: 'start end type parser subtokens argumentType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

!GplToken class methodsFor: 'specs' stamp: 'kf 4/20/2009 20:43'!
builtinMethods
	^
	#('TYPEOF' 'SHAPE' 'RANK' 'LENGTH' 'SIZE' 'IOTA' 'INDEXOF' 'GRADEUP' 'GRADEDOWN' 'SORT' 'SORTDOWN' 'ABS' 'FLOOR' 'CEILING' 'EXP' 'LN' 'PI' 
	'SIN' 'COS' 'TAN' 'ARCTAN' 'NOT'),
	#('RESHAPE' 'IN' 'INDEXOF' 'INDECES_OF' 'MOD' 'MIN' 'MAX' 'MIN_MAX' 'POWER'
	'LOGBASE' 'EQ' 'LT' 'GT' 'LEQ' 'GEQ' 'NEQ' 'AND' 'OR' 'NAND' 'NOR' 'XOR'
	'BITAND' 'BITOR' 'BITXOR' )! !

!GplToken class methodsFor: 'specs' stamp: 'kf 4/25/2009 17:29'!
flowControlKeywords
	^#(
	'IF' 'THEN' 'ELSE' 'ELIF' 'ENDIF'
	'FOR' 'WHILE' 'DO' 'ENDDO' 'UNTIL'
	'GOTO'
	'SWITCH' 'OF' 'CASE' 'OUT' 'ENDSWITCH'
	)! !

!GplToken class methodsFor: 'specs' stamp: 'kf 4/20/2009 20:42'!
gdsiiMethods
	^
	#('BLUE' 'CYAN' 'GREEN' 'MAGENTA' 'RED' 'WHITE' 'YELLOW'),
	#('ABSANGLE' 'ABSMAG' 'ABSTATION' 'ABSWIDTH' 'ADDPLEX' 'ADDRT' 'ANGLE' 'ARC' 'AREF' 'AREFMARK' 'ASCALE' 'ASHAPE' 'AUTOHOLD' 'AND' 'ANDNOT' 'BACKUP' 'BINDATTR' 'BINDFONTS' 'BOUNDARY' 'BOUNDARYMARK' 'BOX' 'BOXTYPE' 'BROKEN' 'BSCALE' 'BSTRUCT' 'BUTTON' 'BUTTONMODE' 'BITAND' 'BITOR' 'BITXOR' 'BOUNDARYAREA' 'CE' 'CH' 'CHECKEXTERIOR1' 'CHECKEXTERIOR2' 'CHECKINTERIOR' 'CIRCLE' 'CIRCLESIZE' 'CLEAR' 'CLOSE' 'CLOSELIB' 'CLOSEREF1' 'CLOSEREF2' 'CLRPROP' 'COLORBY'
'COMMANDS' 'CONTEXT' 'COORDS' 'CRACL' 'CSTRUCT' 'CUTPATHIN' 'CUTPATHOUT' 'CARTESIAN' 'CEKEY' 'CFORMAT' 'CHECKAREA' 'CLOSESTTO' 'CRTTYPE' 'DACL' 'DASHED' 'DATACOPY' 'DATADELETE' 'DATADRAW' 'DATAMAGNIFY' 'DATAMOVE' 'DATAOVERSIZE' 'DATAPAN' 'DATAREDRAW' 'DATAREFLECT' 'DATAROTATE' 'DATASETVIEW' 'DATATYPE' 'DATAVIEWMOVE' 'DATAZOOM' 'DB' 'DE' 'DEFATTR' 'DEFMODE' 'DFUNCTION' 'DIGMODE' 'DIRECTORY' 'DISK' 'DISPLAYSTAT' 'DLN' 'DOTTED' 'DS' 'DSTRUCT' 'DVERT' 'DATAEXTENT' 'DATAVIEW' 'DAY' 'DIGIN' 'DROUND' 'DSELECT' 'EDATA' 'EDGE' 'ENAME' 'ENDLOG' 'ENTERTEXT' 'EREF' 'ESTAT' 'ESTRUCT' 'EXPLODE' 'EXPUNGE' 'EXECUTE' 'EXPINPUT' 'FCCONT' 'FCHATR' 'FCOPY' 'FDELETE' 'FILLA' 'FILLBY' 'FILLC' 'FILLD' 'FILLET' 'FILLSET' 'FINDDATA' 'FINIT' 'FLAYER' 'FLAYEROFF' 'FLAYERON' 'FLINK' 'FLIST' 'FONT' 'FONTINFO' 'FPRINT' 'FRELEASE' 'FRENAME' 'FUNCTIONS' 'FUNLINK' 'FETCH' 'FILEINFO' 'FILLB' 'FORMAT' 'GEDMODE' 'GET' 'GETITEM' 'GETP' 'GPL' 'GRID' 'GSCALE' 'GEDCOORDS' 'GEDELEMENT' 'GETEL' 'GLOBALTOLOCAL' 'GTIME' 'HARDCOPY' 'HARDLOCKS' 'HELP' 'HORIZFIRST' 'IB' 'ICOPY' 'ID' 'IDADD' 'IDCANGLE' 'IDCBOXTYPE' 'IDCDATATYPE' 'IDCFONT' 'IDCLAYER' 'IDCLEAR' 'IDCMAG' 'IDCNODETYPE' 'IDCOPY' 'IDCPATHTYPE' 'IDCTEXTTYPE' 'IDCWIDTH' 'IDDELETE' 'IDEXPLODE' 'IDMARK' 'IDMOVE' 'IDOVERSIZE' 'IDPATHEXP' 'IDREFLECT' 'IDROTATE' 'IDSTRUCT' 'IDSUMMARY' 'IDTEXTEXP' 'IDWINDOW' 'IDWINSTRUCT' 'IE' 'IFILE' 'IITEM' 'IMOVE' 'INACL' 'INFORM' 'INITDISPLAY' 'INITLIB' 'INTCHECKMODE' 'INTRT' 'ISTAT' 'ITEM' 'ITEMCOPY' 'ITEMMARK' 'ITEMREFLECT' 'ITEMREVERSE' 'ITEMROTATE' 'IDKEYS' 'INDICESOF' 'INPUTMASK' 'INSIDEBOUNDARY' 'INTERSECT' 'JOBABORT' 'JOBCREATE' 'JOBINFO' 'JOBLOG' 'JOBPRIORITY' 'JOBSTART' 'JOBSUSPEND' 'JOIN' 'JOBID' 'KEYSTRUCT' 'KEYCE' 'KEYMARK' 'LACL' 'LASTCOORD' 'LAYER' 'LAYERTYPE' 'LEVEL' 'LISTATTR' 'LISTDISPLAY' 'LISTGEN' 'LISTLIB' 'LISTREF1' 'LISTREF2' 'LOAD' 'LOCALTOGLOBAL' 'LOG' 'LOWERCASE' 'LSTAT' 'LAYERSIN' 'LINEINTERSECT' 'MAG' 'MARK' 'MARKSIZE' 'MASKFREE' 'MASKS' 'MASKSAVE' 'MEMORY' 'MENU' 'MENUMOVE' 'MERGELIB' 'MOVE' 'MOVEPOINT' 'MASKRESTORE' 'MEMBER' 'MINMAX' 'MSELECT' 'NAMES' 'NEWANGLE' 'NEWBOXTYPE' 'NEWDATATYPE' 'NEWFONT' 'NEWLAYER' 'NEWMAG' 'NEWNODETYPE' 'NEWPATHTYPE' 'NEWTEXTTYPE' 'NEWUNITS' 'NEWWIDTH' 'NODE' 'NODETYPE' 'NAMESBOUND' 'NAMESOPEN' 'NSELECT' 'OCTAGONAL' 'ODATA' 'ONAME' 'OPENDISPLAY' 'OPENLIB' 'OPENREF1' 'OPENREF2' 'OPTIONS' 'OREF' 'ORTHINT' 'OSTRUCT' 'OUTFORM' 'OUTFORM3' 'OUTPUTCHANGE' 'OUTPUTMASK' 'OUTPUTPATH' 'OUTPUTVIEW' 'OR' 'PAN' 'PATH' 'PATHEDGE' 'PATHMARK' 'PATHTYPE' 'PAUSE' 'PLEXMODE' 'PLOTSTAT' 'PROPVALUE' 'PUT' 'PUTALL' 'PATHBOUNDARY' 'PLEX' 'POLAR' 'PUTEL' 'QUIT' 'R3' 'RACL' 'RCSTRUCT' 'RECOVERLIB' 'REDO' 'REDRAW' 'REFL' 'REMOVE' 'REVERT' 'RJOB' 'RMENU' 'RS' 'RSCALE' 'RSCREEN' 'RSTRUCT' 'RT' 'RTDIGMODE' 'RULER' 'ROUND' 'ROUNDMASK' 'SAVE' 'SAVEDISPLAY' 'SB' 'SBTYPE' 'SBTYPEOFF' 'SBTYPEON' 'SCELL' 'SDTYPE' 'SDTYPEOFF' 'SDTYPEON' 'SEGS' 'SETCOLORS' 'SETDIG' 'SETLEVEL' 'SETTAB' 'SETVIEW' 'SHOWDEFAULTS' 'SHOWREFS' 'SHOWSNAPS' 'SKIND' 'SKINDOFF' 'SKINDON' 'SLAYER' 'SLAYEROFF' 'SLAYERON' 'SLIMSIZE' 'SNAME' 'SNAP' 'SNAPCE' 'SNAPSIZE' 'SNTYPE' 'SNTYPEOFF' 'SNTYPEON' 'SOLID' 'SPLIT' 'SPOOLQ' 'SREF' 'SREFMARK' 'SSTAT' 'SSTRUCT' 'STADPY' 'START' 'STRAIGHT' 'STREAMOUT' 'STRETCH' 'STRETCHCELL' 'STTYPE' 'STTYPEOFF' 'STTYPEON' 'STYLEBY' 'SUBRT' 'SUBS' 'SUMMARY' 'SYSDPY' 'SYSTAT' 'SLEEP' 'STADPYINFO' 'STANUM' 'STRUCINFO' 'STRUCLIST' 'STRUCOPEN' 'STRUCREFS' 'SUBSET' 'SYSN' 'TABMODE' 'TEMPLATE' 'TEMPLATEMARK' 'TEMPREF1' 'TEMPREF2' 'TEXT' 'TEXTFONT' 'TEXTMARK' 'TEXTTYPE' 'TIME' 'TJUST' 'TREE' 'TSTRUCT' 'TABTYPE' 'TEXTINPUT' 'TOD' 'UNDO' 'UNGET' 'UNID' 'UNIDWINDOW' 'UNMARK' 'UPDISPLAY' 'UPLIB' 'UPLOWCASE' 'UPPERCASE' 'USER' 'USERPROP' 'USTRUCT' 'UNDERSIZE' 'UNION' 'USELECT' 'VBTYPE' 'VBTYPEOFF' 'VBTYPEON' 'VDTYPE' 'VDTYPEOFF' 'VDTYPEON' 'VECTORCOUNT' 'VERTFIRST' 'VIEWEXTENT' 'VIEWMOVE' 'VKIND' 'VKINDOFF' 'VKINDON' 'VLAYER' 'VLAYEROFF' 'VLAYERON' 'VLEVELS' 'VLT' 'VMODE' 'VNTYPE' 'VNTYPEOFF' 'VNTYPEON' 'VSTRUCT' 'VTTYPE' 'VTTYPEOFF' 'VTTYPEON' 'VARS' 'VIEWWINDOW' 'WIDTH' 'WINCOPY' 'WINDELETE' 'WINFENCE' 'WINMOVE' 'WINOPTIONS' 'WINSTRETCH' 'WINSTRUCT' 'WIPE' 'WIPEALL' 'WITEM' 'WSCALE' 'WSCREEN' 'WASTAT' 'XSCALE' 'XOR' 'YSCALE' 'ZOOM' 'ZSCALE')! !

!GplToken class methodsFor: 'testing' stamp: 'kf 6/8/2009 14:33'!
implementedDyadicMethods
	^#(RESHAPE)
! !

!GplToken class methodsFor: 'testing' stamp: 'kf 6/8/2009 14:33'!
implementedMonadicMethods
	^#(ABS FLOOR CEILING EXP LN PI SIN COS TAN ARCTAN NOT)
! !

!GplToken class methodsFor: 'testing' stamp: 'kf 4/19/2009 22:07'!
isBuiltinMethod: aString
	^self builtinMethods includes: aString asUppercase.! !

!GplToken class methodsFor: 'testing' stamp: 'kf 4/20/2009 20:43'!
isGdsiiMethod: aString
	^self gdsiiMethods includes: aString asUppercase.! !

!GplToken class methodsFor: 'testing' stamp: 'kf 4/25/2009 17:43'!
isProgramOnlyKeyword: aString
	^self programOnlyKeywords includes: aString asUppercase.! !

!GplToken class methodsFor: 'testing' stamp: 'kf 4/19/2009 21:54'!
isReservedKeyword: aString
	^self reservedKeywords includes: aString asUppercase.! !

!GplToken class methodsFor: 'specs' stamp: 'kf 4/25/2009 17:23'!
methodTypeKeywords
	^#('NILADIC' 'MONADIC' 'DYADIC')
! !

!GplToken class methodsFor: 'specs' stamp: 'kf 4/25/2009 17:25'!
methodUnitKeywords
	^#('PROCEDURE' 'FUNCTION' 'ENDSUB')! !

!GplToken class methodsFor: 'instance creation' stamp: 'kf 4/26/2009 12:54'!
newFromTokens: aGplTokens
	|newToken|
	GplParser assertGplTokens: aGplTokens.
	self assert: [aGplTokens isEmpty not].
	(aGplTokens size = 1) ifTrue: [^aGplTokens first]. "is a scalar"
	newToken := self new.
	aGplTokens do: [:each | newToken addSubToken: each].
	^newToken! !

!GplToken class methodsFor: 'specs' stamp: 'kf 4/25/2009 17:40'!
programOnlyKeywords
	^((self reservedKeywords,
	#('RANGE')) reject: [:word |
		#('LOCAL' 'GLOBAL') includes: word
		]) asArray.! !

!GplToken class methodsFor: 'specs' stamp: 'kf 4/25/2009 17:41'!
reservedKeywords
	^self methodUnitKeywords,
	self methodTypeKeywords,
	self flowControlKeywords,
	self storageScopeKeywords.! !

!GplToken class methodsFor: 'instance creation' stamp: 'kf 4/22/2009 17:24'!
start: s end: e type: aSymbol parser: aGplParser2
	
	^self new
		start: s end: e type: aSymbol;
		parser: aGplParser2;
		yourself! !

!GplToken class methodsFor: 'specs' stamp: 'kf 4/20/2009 12:03'!
storageScopeKeywords
	^#('EXTERNAL' 'LOCAL' 'GLOBAL')! !

!GplToken methodsFor: 'testing' stamp: 'kf 5/29/2009 21:22'!
= aGplToken
	^(self start = aGplToken start)
	and: [self end = aGplToken end]
	and: [self parser source = aGplToken parser  source]
	! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/24/2009 11:38'!
addSubToken: aGplToken
	subtokens ifNil: [subtokens := OrderedCollection new].
	subtokens add: aGplToken.
	parser ifNil: [parser := aGplToken parser].
	type ifNil: [self type: #vector].	! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/21/2009 21:09'!
argumentType: aSymbol
	self assert: (#(monadic niladic dyadic) includes: aSymbol).
	argumentType := aSymbol.
	! !

!GplToken methodsFor: 'conversion' stamp: 'kf 5/23/2009 19:31'!
asGplValue
	| clazz |
	self isNull ifTrue: [^ GdsNull instance].
	self isString ifTrue: [^ GdsString fromLiteral: self fragment].
	self isOperator ifTrue: [^ self fragment asLowercase asSymbol].
	clazz := GdsDglType bestClassOfStatement: self fragment.
	clazz ifNotNil: [^ clazz fromLiteral: self fragment].
	self type = #vector 
		ifTrue: [^ GdsVector withAll: (subtokens collect: [:t | t asGplValue])].
	^ self! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:50'!
depth
	^self depthOfParlen + self depthOfSubscript.! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 21:21'!
depthOfOpen: openFragment close: closeFragment
	| allTokens level |
	allTokens := self parser tokens.
	level := 0.
	allTokens do: [:each |
		each fragment = openFragment
			ifTrue: [
				level := level + 1.
				each = self ifTrue: [^level]].
		each fragment = closeFragment
			ifTrue: [
				each = self ifTrue: [^level].
				level := level - 1].
		each = self ifTrue: [^level].].
	^0.! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:35'!
depthOfParlen
	^self depthOfOpen: '(' close: ')'. 
! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:35'!
depthOfSubscript
	^self depthOfOpen: '[' close: ']'. 
! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:04'!
end
	self hasSubTokens
		ifTrue: [^(subtokens collect: [:token | token end]) max].
	^end.
	! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:04'!
end: anInteger
	end := anInteger! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/22/2009 17:22'!
fragment
	^parser fragmentOfRange: self.! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/22/2009 01:31'!
fragmentForInspect
	| base |
	base := self fragment.
	(base = ':=')
		ifTrue: [
			| leftTokens subScriptClose|
			leftTokens := self leftTokens.
			subScriptClose := leftTokens detect: [:each | each fragment = ']'] ifNone:[nil].
			subScriptClose ifNotNil: [base := '[]:='].
			].
	argumentType ifNotNil: [
		base := base, ' (', argumentType asString, ')'].
	^base.! !

!GplToken methodsFor: 'testing' stamp: 'kf 6/8/2009 17:07'!
hasSubTokens
	subtokens ifNil: [^false].
	^subtokens isEmpty not.! !

!GplToken methodsFor: 'initialization' stamp: 'kf 4/22/2009 18:33'!
initialize
	super initialize.
	! !

!GplToken methodsFor: 'testing' stamp: 'kf 5/26/2009 17:09'!
isArithmeticOperator
	^ self fragment size = 1 and: ['+-*%' includes: self fragment first]! !

!GplToken methodsFor: 'testing' stamp: 'kf 6/8/2009 14:34'!
isBuiltinDyadic
	^(self type = #operator or: [self type = #builtinMethod])
		and: [
			self class implementedDyadicMethods 
				includes: (self fragment asSymbol)]
! !

!GplToken methodsFor: 'testing' stamp: 'kf 6/8/2009 14:35'!
isBuiltinMonadic
	^(self type = #operator or: [self type = #builtinMethod])
		and: [
			self class implementedMonadicMethods 
				includes: (self fragment asSymbol)]
! !

!GplToken methodsFor: 'testing' stamp: 'kf 4/23/2009 17:14'!
isComment
	^self type = #comment.! !

!GplToken methodsFor: 'testing' stamp: 'kf 5/30/2009 10:09'!
isFunctionCall
	^self isProcedureCall not! !

!GplToken methodsFor: 'testing' stamp: 'kf 5/20/2009 22:54'!
isInspectMonadic
	^(self type = #operator or: [self type = #builtinMethod])
		and: [
			(#(TYPEOF SHAPE RANK SIZE LENGTH)
				includes: (self fragment asSymbol))]
! !

!GplToken methodsFor: 'testing' stamp: 'kf 4/26/2009 14:51'!
isNull
	^self isString and: [self fragment = '""'].! !

!GplToken methodsFor: 'testing' stamp: 'kf 4/24/2009 10:06'!
isNumber
	^self type = #number.! !

!GplToken methodsFor: 'testing' stamp: 'kf 4/23/2009 17:36'!
isOperator
	^self type = #operator.! !

!GplToken methodsFor: 'testing' stamp: 'kf 5/30/2009 10:09'!
isProcedureCall
	^self leftTokens isEmpty! !

!GplToken methodsFor: 'testing' stamp: 'kf 4/26/2009 14:57'!
isString
	^self type = #string.! !

!GplToken methodsFor: 'testing' stamp: 'kf 4/25/2009 22:07'!
isVariableAllowed
	^self type = #unresolved or: [self type = #variable].! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/24/2009 23:34'!
leftFragment
	self start = 1
		ifTrue: [^''].
	^parser source copyFrom: 1 to: self start - 1.! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/24/2009 23:55'!
leftTokens
	^GplParser tokensFrom: self leftFragment! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 16:34'!
leftTokensOfDepth: aDepth
	^self leftTokens select: [:each | each depth = aDepth]! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 11:00'!
leftTokensOfSameDepth
	^self leftTokensOfDepth: self depth! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:05'!
length
	^end - start + 1! !

!GplToken methodsFor: 'private' stamp: 'kf 5/23/2009 11:58'!
lookupType
	| fragment |
	fragment := self fragment. 
	(GplParser isNumberFragment: fragment)
		ifTrue: [^#number].
	(GplParser isOperatorFragment: fragment)
		ifTrue: [^#operator].
	('()' includes: fragment first)
		ifTrue: [^#paren].
	('[]' includes: fragment first)
		ifTrue: [^#bracket].
	(self class isReservedKeyword: fragment)
		ifTrue: [^#reserved.].
	(self class isBuiltinMethod: fragment)
		ifTrue: [^#builtinMethod.].
	(self class isGdsiiMethod: fragment)
		ifTrue: [^#gdsiiMethod].
	(self fragment startsWith: '|')
		ifTrue: [^#comment.].		
	((self fragment startsWith: '`') and: [self fragment endsWith: ''''])
		ifTrue: [^#comment.].		
	(self fragment allSatisfy: [: each |  { Character space . Character tab } includes: each ])
		ifTrue: [^#space].		
	(self fragment startsWith: '"')
		ifTrue: [^#string.].
	^#unresolved.		
		
	! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/24/2009 11:34'!
parser
	^parser! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/24/2009 10:01'!
parser: aGplParser2
	parser := aGplParser2.
! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/21/2009 21:37'!
postfixExpr
	(self fragment = '[')
		ifTrue: [^'[]'].
	^self fragmentForInspect.! !

!GplToken methodsFor: 'printing' stamp: 'kf 5/21/2009 21:09'!
printOn: aStream
	"fragment = #cr ifTrue: [^aStream nextPutAll: 'CR']".
	aStream nextPutAll: '['.	
	aStream nextPutAll: self start printString.
	aStream nextPutAll: ','.	
	aStream nextPutAll: self end printString.	
	aStream nextPutAll: ']'.
	aStream nextPutAll: '('.
	aStream nextPutAll: self type printString.
	aStream nextPutAll: ','.
	aStream nextPutAll: self fragmentForInspect printString.
	aStream nextPutAll: ')'.	
	! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/24/2009 23:37'!
rightFragment
	self end = parser source size
		ifTrue: [^''].
	^parser source copyFrom: self end + 1 to: parser source size.! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 21:26'!
rightTokens
	| newTokens |
	newTokens := GplParser tokensFrom: self rightFragment.
	newTokens do: [:each |
		each parser: self parser.
		each start: self end + each start.
		each end: self end + each end].
	^newTokens.! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 16:34'!
rightTokensOfDepth: aDepth
	^self rightTokens select: [:each | each depth = aDepth]! !

!GplToken methodsFor: 'accessing' stamp: 'kf 5/29/2009 10:59'!
rightTokensOfSameDepth
	^self rightTokensOfDepth: self depth! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:21'!
start
	self hasSubTokens
		ifTrue: [^(subtokens collect: [:token | token start]) min].
	^start.! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:04'!
start: anInteger
	start := anInteger! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:03'!
start: startInteger end: endInteger type: typeSymbol
	start := startInteger.
	end := endInteger.
	type := typeSymbol! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:08'!
type
	(type = #unresolved)
		ifTrue: [self type: self lookupType].
	^type.	
		
	! !

!GplToken methodsFor: 'accessing' stamp: 'kf 4/30/2009 17:03'!
type: aSymbol
	type := aSymbol! !

GdsObject subclass: #GplTokenHandler
	instanceVariableNames: 'stack showsLog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

GplTokenHandler subclass: #GplEvaluter
	instanceVariableNames: 'history argStack varMap postfixTokens suspendContext resultMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

!GplEvaluter commentStamp: 'kf 4/25/2009 16:08' prior: 0!
A GplEvaluter is GPLII Expression evaluter.

Instance Variables
	argStack:		<OrderedCollection>
	history:		<OrderedCollection>
	outTokens:		<OrderedCollection>
	stack:		<OrderedCollection>

argStack
	- postfix notation argument or result value stack

history
	- expression input history

outTokens
	- infix to postfix transform work area

stack
	- infix to postfix transform analysis stack
!

!GplEvaluter class methodsFor: 'as yet unclassified' stamp: 'kf 5/26/2009 17:05'!
arithmeticSelector: aGplToken 
	| sel |
	sel := aGplToken fragment asSymbol.
	^ sel = #% ifTrue: [#/] ifFalse: [sel]! !

!GplEvaluter class methodsFor: 'as yet unclassified' stamp: 'kf 4/26/2009 12:50'!
debugEvalute: aGplExpression
	|result|
	Transcript cr; show: '? ', aGplExpression.
	[result := self new evaluteConsoleLine: aGplExpression.
	Transcript cr; show: result]
	on: Error do: [:ex | Transcript cr; show: ex messageText]! !

!GplEvaluter methodsFor: 'private' stamp: 'kf 4/24/2009 11:01'!
assertGplTokens: aCollection
	self assert: [aCollection allSatisfy: [:each | each isMemberOf: GplToken]].
	! !

!GplEvaluter methodsFor: 'private' stamp: 'kf 4/24/2009 11:03'!
assertGplValues: aCollection
	self assert: [aCollection allSatisfy: [:each | each isKindOf: GdsDglType]].
	! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/26/2009 17:08'!
evaluteArithmetic: aGplToken 
	(aGplToken fragmentForInspect endsWith: '(dyadic)') 
		ifTrue: [^ self evaluteDyadicArithmetic: aGplToken].
	(aGplToken fragmentForInspect endsWith: '(monadic)') 
		ifTrue: [^ self evaluteMonadicArithmetic: aGplToken].
	^ self error: 'ILLIGAL ARGUMENT SIZE'! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/7/2009 18:12'!
evaluteAsString: aBlock
	| result reply |
	result := nil.
	reply := ''.
	[result := aBlock value] 
		on: Error 
		do: [:ex | 
			(ex isKindOf: GplPromptException)
				ifTrue: [ex pass].
			^ex messageText].
	result ifNotNil: [reply := result gplString].
	^reply.! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/19/2009 23:38'!
evaluteAsVector: aGplToken
	| arg1 |
	arg1 := self popArg.
	^arg1 asGplValue asVector.! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/22/2009 10:51'!
evaluteAssign: aGplToken
	|  gv1 variableObject valueArg variableArg |
	self assert: [aGplToken fragment = ':='].
	valueArg := self popArg.
	variableArg := self popArg.
	gv1 := valueArg asGplValue copy.
	variableObject := self getVariable: variableArg wantsStrictDeclare: false.
	variableObject gplValue: gv1.
	(variableArg isMemberOf: GplToken)
		ifTrue: [
			variableArg type: #variable].
	(aGplToken == postfixTokens last)
		ifTrue: [^self voidReturn].
	^variableObject.! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/19/2009 01:29'!
evaluteBuiltinDyadic: aGplToken
	^self evaluteReshape: aGplToken		
	! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 4/27/2009 17:56'!
evaluteBuiltinMonadic: aGplToken
	| sel  arg1  gv1|
	sel := aGplToken fragment asLowercase asSymbol.
	sel := (sel = #arctan) ifTrue: [#arcTan] ifFalse: [sel]. "special case"
	arg1 := self popArg.
	gv1 := arg1 asGplValue.
	^gv1 perform: sel				
	! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/7/2009 14:10'!
evaluteConsoleLine: aString
	| tokens reply result |
	reply := aString.
	result := nil.
	aString
		ifNotEmpty: [
			(aString first = $\)
				ifTrue: [
					^self 
						handleForKey: (aString allButFirst)
						line: self lastEvalutedLine.]].	
	history add: aString.
	tokens := self tokensFrom: aString.
	[self syntaxCheck: tokens] on: Error do: [:ex | ^ex messageText].
	^self evaluteAsString: [self evaluteLine: aString].! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 6/5/2009 17:42'!
evaluteDyadicArithmetic: aGplToken 
	| arg1 arg2 real1 real2 result gv1 gv2 |
	arg2 := self popArg.
	arg1 := self popArg.
	gv1 := arg1 asGplValue.
	gv2 := arg2 asGplValue.
	self debugLog: {  gv1. gv2}.
	(gv1 rank = 0 and: [gv2 rank = 0]) 
		ifTrue: 
			[real1 := gv1 asSmalltalkValue asFloat.
			real2 := gv2 asSmalltalkValue asFloat.
			result := (real1 perform: (self class arithmeticSelector: aGplToken)
						with: real2) asFloat.
			^ GdsReal fromLiteral: result asString]
		ifFalse: 
			[result := gv1 perform: aGplToken fragment asSymbol with: gv2.
			^ result]! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 4/27/2009 21:48'!
evaluteInspectMonadic: aGplToken
	| sel  arg1  gv1|
	sel := aGplToken fragment asLowercase capitalized.
	sel := ('gplValueOf', sel) asSymbol.
	arg1 := self popArg.
	gv1 := arg1 asGplValue.
	^gv1 perform: sel				
	! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/27/2009 16:19'!
evaluteJoinVector: aGplToken 
	| rightArg leftArg leftArray rightArray leftType rightType |
	rightArg := self popArg.
	leftArg := self popArg.
	leftArray := leftArg asGplValue.
	rightArray := rightArg asGplValue.
	leftType := leftArray typeString.
	rightType := rightArray typeString.
	(leftType = 'CHAR' and: [rightType = 'CHAR']) 
		ifTrue: 
			[^ GdsString 
				withAll: leftArray asVector elements , rightArray asVector elements].
	(leftType ~= 'CHAR' and: [rightType ~= 'CHAR']) 
		ifTrue: 
			[^ GdsVector 
				withAll: leftArray asVector elements , rightArray asVector elements].
	^ self runtimeError: 'ILLIGAL TYPE CPNVERSION'! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/5/2009 15:07'!
evaluteLine: aString
	| tokens |
	aString ifEmpty:  [^GdsNull instance].
	argStack := nil.
	tokens := self tokensFrom: aString.
	tokens := self vectorAnalysisFromTokens: tokens.
	^self evaluteTokens: tokens.! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/23/2009 19:31'!
evaluteList: aGplToken 
	| rightArg leftArg result leftValue rightValue |
	self fillListRightArgument: aGplToken.
	rightArg := self popArg.
	self fillListLeftArgument: aGplToken.
	leftArg := self popArg.
	result := GdsList new.
	leftValue := leftArg asGplValue.
	rightValue := rightArg asGplValue.
	result add: leftValue.
	result add: rightValue.
	^ result! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 6/7/2009 17:57'!
evaluteMonadicArithmetic: aGplToken 
	| arg1 gv1 |
	arg1 := self popArg.
	gv1 := arg1 asGplValue.
	aGplToken fragment = '+' ifTrue: [^ gv1 asGdsFloating].
	aGplToken fragment = '-' ifTrue: [^ gv1 negated].
	aGplToken fragment = '*' ifTrue: [^ gv1 sign].
	aGplToken fragment = '%' ifTrue: [^ gv1 reciprocal]! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/7/2009 11:19'!
evalutePostfixStream: aPostfixStream
	| token result |
	argStack ifNil: [argStack := OrderedCollection new].
	[aPostfixStream atEnd]
		whileFalse: [
			token := aPostfixStream next.
			self handleToken: token.].
	result := self popArg asGplValue.
	argStack ifNotEmpty: [self error: 'EXPRESSION PARSED INCORRECTLY'].
	^result.! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/7/2009 11:19'!
evalutePostfixTokens: aGplTokens
	^self evalutePostfixStream:  (ReadStream on: aGplTokens).
! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/27/2009 16:30'!
evaluteReshape: aGplToken 
	| argRight argLeft gvRight gvLeft columnCount rowCount mustIntegerBlock |
	argRight := self popArg.
	argLeft := self popArg.
	gvLeft := argLeft asGplValue.
	gvRight := argRight asGplValue.
	gvLeft := gvLeft asVector.
	gvRight := gvRight asVector.
	mustIntegerBlock := [:v | v isInteger ifFalse: [self runtimeError: 'SUBSCRIPT VALUE MUST BE INTEGLAL']].
	gvLeft size = 1 
		ifTrue: [
			columnCount := (gvLeft at: 1) asSmalltalkValue.
			mustIntegerBlock value: columnCount.
			^ GdsMatrix fromGdsVector: gvRight col: columnCount].
	gvLeft size = 2 
		ifTrue: [
			rowCount := (gvLeft at: 1) asSmalltalkValue.
			columnCount := (gvLeft at: 2) asSmalltalkValue.			
			mustIntegerBlock value: rowCount.
			mustIntegerBlock value: columnCount.
			^ GdsMatrix  fromGdsVector: gvRight  row: rowCount col: columnCount].
	^ self runtimeError: 'INVALID SHAPE FORMAT'! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 6/5/2009 17:43'!
evaluteSubscript: aGplToken 
	(self hasMoreAssign: aGplToken)
		ifTrue: [
			self debugLog: '*** skip subscription return'.
			^self popArg.].
	^self evaluteSubscriptReturn: aGplToken.! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/25/2009 23:01'!
evaluteSubscriptAssign: aGplToken 
	| assignValue valueArg variableArg subscriptArg subscriptValue target returnValue |
	self assert: [aGplToken fragment = ':='].
	valueArg := self popArg.
	subscriptArg := self popArg.
	variableArg := self popArg.
	assignValue := valueArg asGplValue copy.
	subscriptValue := subscriptArg asGplValue.
	returnValue := assignValue.
	target := (self getVariable: variableArg wantsStrictDeclare: true) 
				asGplValue.
	returnValue :=  target atSubscriptWithCheck: subscriptValue put: assignValue.
	aGplToken == postfixTokens last ifTrue: [^ self voidReturn].
	^ returnValue! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/25/2009 23:00'!
evaluteSubscriptReturn: aGplToken 
	| arg1 arg2 target subscript |
	arg2 := self popArg.
	arg1 := self popArg.
	target := arg1 asGplValue.
	subscript := arg2 asGplValue.
	^target atSubscriptWithCheck: subscript.! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/5/2009 17:44'!
evaluteTokens: aGplTokens
	| postfixGenerator |
	postfixGenerator := GplPostfix new.
	postfixGenerator showsLog: self showsLog.
	postfixTokens := postfixGenerator translateToPostfixFromTokens: aGplTokens.
	self debugLog: postfixTokens printString.
	^self evalutePostfixTokens: postfixTokens.
! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/21/2009 22:12'!
evaluteVector: aGplToken 
	(aGplToken fragmentForInspect endsWith: '(dyadic)')
		ifTrue: [^ self evaluteJoinVector: aGplToken].
	(aGplToken fragmentForInspect endsWith: '(monadic)')
		ifTrue: [^ self evaluteAsVector: aGplToken].
	^self error: 'ILLIGAL ARGUMENT SIZE'.
! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/23/2009 17:26'!
fillListLeftArgument: aGplToken 
	| leftTokens missingLeft |	
	leftTokens := aGplToken leftTokens.
	missingLeft := leftTokens 
		ifEmpty: [true]
		ifNotEmpty: [
				('([' includes: leftTokens last fragment first) ].
	missingLeft ifTrue: [self pushArg: GdsNull instance].
! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/23/2009 17:26'!
fillListRightArgument: aGplToken 
	| rightTokens missingRight |	
	rightTokens := aGplToken rightTokens.
	missingRight := rightTokens 
		ifEmpty: [true]
		ifNotEmpty: [
				('])' includes: rightTokens first fragment first) ].
	missingRight ifTrue: [self pushArg: GdsNull instance].
! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 11:05'!
flushContextStacks
	resultMap := nil.
	suspendContext  := nil.
	! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/22/2009 09:51'!
getVariable: variableArg wantsStrictDeclare: aBoolean
	|  variableObject  varName |		
	varName := (variableArg isKindOf: GplToken)
		ifTrue: [variableArg fragment]
		ifFalse: [variableArg name].
	aBoolean
		ifTrue: [
			(self hasVariableName: varName)
				ifFalse: [^self error: 'VARIABLE NOT DECLEARED']].
	variableArg isVariableAllowed ifFalse: [^self error: 'CAN''T ASSIGN TO:',  varName].
	variableObject := self variableNamed: varName.
	^variableObject! !

!GplEvaluter methodsFor: 'analysis' stamp: 'kf 5/23/2009 19:31'!
gplValueFromGplValues: aGplValues 
	aGplValues size = 1 ifTrue: [^ aGplValues first].
	^ GdsVector withAll: aGplValues asArray! !

!GplEvaluter methodsFor: 'analysis' stamp: 'kf 4/23/2009 12:02'!
handleForKey: aKey line: aString
	| sel |
	sel := aKey,':'.
	sel := sel asSymbol.
	(self class selectors includes: sel )
		ifTrue: [^self perform: sel with: aString].
	^'Not found: ', aKey! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/5/2009 17:43'!
handleToken: aToken 
	| handler |
	self showsLog 
		ifTrue: [self printArgStack: aToken].
	handler := GplHandler fromCommand: aToken fragment evaluter: self.
	handler ifNotNil: [^ self pushArg: (handler evaluteToken: aToken)].
	(self isOperandToken: aToken) ifTrue: [^ self pushArg: aToken].
	aToken isArithmeticOperator 
		ifTrue: [^ self pushArg: (self evaluteArithmetic: aToken)].
	self isInteractive 
		ifTrue: [aToken isVariableAllowed ifTrue: [^ self pushArg: aToken]].
	aToken fragment = '[' 
		ifTrue: [^ self pushArg: (self evaluteSubscript: aToken)].
	aToken fragmentForInspect = '[]:=' 
		ifTrue: [^ self pushArg: (self evaluteSubscriptAssign: aToken)].
	aToken fragment = ':=' 
		ifTrue: [^ self pushArg: (self evaluteAssign: aToken)].
	aToken fragment = ',' 
		ifTrue: [^ self pushArg: (self evaluteVector: aToken)].
	aToken fragment = ';' ifTrue: [^ self pushArg: (self evaluteList: aToken)].
	aToken isBuiltinMonadic 
		ifTrue: [^ self pushArg: (self evaluteBuiltinMonadic: aToken)].
	aToken isBuiltinDyadic 
		ifTrue: [^ self pushArg: (self evaluteBuiltinDyadic: aToken)].
	aToken isInspectMonadic 
		ifTrue: [^ self pushArg: (self evaluteInspectMonadic: aToken)].
	aToken fragment = #cr ifTrue: [^ self pushArg: self voidReturn].
	^ self error: (self notImplementedToken: aToken)! !

!GplEvaluter methodsFor: 'evaluter-inside' stamp: 'kf 5/28/2009 21:23'!
hasMoreAssign: aGplToken 
	"^((outTokens last fragment = ':=') and: [aGplToken start < outTokens last start  ])"
	| tokens closeToken level |
	tokens := aGplToken rightTokens.
	tokens ifEmpty: [^false].
	closeToken := nil.
	level := 1.
	tokens do: [:each |
		each fragment = '[' ifTrue: [level := level + 1].
		each fragment = ']' 
			ifTrue: [
				level := level - 1.
				(level = 0 and: [closeToken isNil])
				 	ifTrue: [closeToken := each]]].
	closeToken 
		ifNotNil: [
			tokens := tokens := closeToken rightTokens].
	^(tokens detect: [:each | each fragment = ':='] ifNone: [nil]) isNil not.! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 09:47'!
hasSuspendContext
	suspendContext ifNil: [suspendContext := OrderedCollection new].
	^suspendContext isEmpty not.
	! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 4/25/2009 22:41'!
hasVariableName: aVariableName
	varMap ifNil: [^false].
	^varMap includesKey: aVariableName.! !

!GplEvaluter methodsFor: 'command' stamp: 'kf 4/23/2009 14:13'!
history: aInputString	
	| digitLength num |
	digitLength := history size asString.
	num := 0.	
	^(history collect: [:line | 
		num := num + 1.
		' ', num asString,' ', line]) asArray
		joinUsing: String cr
	! !

!GplEvaluter methodsFor: 'private' stamp: 'kf 4/24/2009 10:46'!
indexes: aGplTokens ofType: aSymbol
	| colIndex |
	colIndex := OrderedCollection new.
	aGplTokens
		doWithIndex: [:token :index |
			token type = aSymbol ifTrue: [colIndex add: index].].
	^colIndex asArray.! !

!GplEvaluter methodsFor: 'initialization' stamp: 'kf 5/21/2009 18:14'!
initialize
	super initialize.
	history := OrderedCollection new.
	showsLog := false.
	! !

!GplEvaluter methodsFor: 'command' stamp: 'kf 4/24/2009 13:57'!
inspect: aInputString	
	^((self evaluteLine: aInputString)) printString.
	! !

!GplEvaluter methodsFor: 'analysis' stamp: 'kf 4/22/2009 21:57'!
inspectConsoleLine: aString
	| tokens parser |
	parser := GplParser new. 
	parser source: aString.
	tokens :=  parser tokens .
	^tokens printString.! !

!GplEvaluter methodsFor: 'command' stamp: 'kf 5/23/2009 01:11'!
inspectPostfix: aInputString	
	^(self translateToPostfix: aInputString)printString
	! !

!GplEvaluter methodsFor: 'command' stamp: 'kf 4/23/2009 14:22'!
inspectToken: aInputString	
	^(GplParser splitTokens: aInputString) printString.
	! !

!GplEvaluter methodsFor: 'command' stamp: 'kf 4/26/2009 10:38'!
inspectTokens: aInputString	
	^(self tokensFrom: aInputString) printString.
	! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 5/18/2009 13:25'!
isDefined: aWord
	aWord = #cr ifTrue: [^true].
	aWord trimBlanks ifEmpty: [^true].
	(self hasVariableName: aWord) ifTrue: [^true]. 
	^self isOperator: aWord.
! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 5/22/2009 13:54'!
isDyadic: aGplTokenOrString
	| fragment |
	(self isOperator: aGplTokenOrString) ifFalse: [^false].
	fragment := (aGplTokenOrString isKindOf: GplToken)
		ifTrue: [aGplTokenOrString fragmentForInspect]
		ifFalse: [aGplTokenOrString].	
	(fragment endsWith: '(dyadic)')
		ifTrue: [^true].
	^#(RESHAPE ':=') includes: fragment.	
! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 4/25/2009 17:15'!
isInteractive
	^true! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 5/23/2009 11:58'!
isNumber: aString	
	^GplParser isNumberFragment: aString	.
! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 4/26/2009 11:32'!
isOperandToken: aGplToken
	^#(number string vector unresolved) includes: aGplToken type
	! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 5/23/2009 11:46'!
isOperator: aGplTokenOrString
	^(GplPostfix isOperator: aGplTokenOrString).
! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 4/26/2009 10:21'!
isScalarToken: aGplToken
	(self isVariableRegistered: aGplToken fragment)
		ifTrue: [
			^(self variableNamed: aGplToken fragment) rank = 0].
	^aGplToken type = #number
	! !

!GplEvaluter methodsFor: 'testing' stamp: 'kf 4/25/2009 15:42'!
isVariableRegistered: aWord
	^false
	

! !

!GplEvaluter methodsFor: 'analysis' stamp: 'kf 4/23/2009 14:02'!
lastEvalutedLine
	(history isEmpty)
		ifTrue: [^''] ifFalse: [^history last].
! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/10/2009 16:43'!
notConsumedTokens: aGplToken 
	| restSize ownPos depth |
	depth := aGplToken depth.
	ownPos := self postfixIndexOf: aGplToken.
	restSize := postfixTokens size - ownPos.
	(restSize = 0)
		ifTrue: [^#() copy].
	^(postfixTokens allButFirst: ownPos) select: [:each |
			         each depth = depth 
			and: [self isDyadic: each] ].
! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/10/2009 16:07'!
numArgs: aGplToken
	^ (self numPushed + (self numReturn: aGplToken)) 
	-  (self notConsumedTokens: aGplToken) size
	
! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 5/20/2009 16:05'!
numPushed
	argStack ifNil: [argStack := OrderedCollection new].
	^argStack size
	
! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 6/10/2009 16:02'!
numReturn: aGplToken
	(GplHandler isVoid: aGplToken fragment)
		ifTrue: [^0].
	^aGplToken leftTokens isEmpty
		ifTrue: [0]
		ifFalse: [1].
	
! !

!GplEvaluter methodsFor: 'private' stamp: 'kf 4/24/2009 10:20'!
numberTokens: aGplTokens
	^aGplTokens select: [:token | token isNumber].
! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 10:08'!
peekSuspendContext
	suspendContext ifNil: [suspendContext := OrderedCollection new].
	^suspendContext last.
	! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 5/27/2009 16:17'!
popArg
	| result |
	argStack
		ifEmpty: [self runtimeError: 'Missing argument'].
	result := argStack last.
	((result isKindOf: GplToken)
			and: [result isVariableAllowed
					and: [self hasVariableName: result fragment]])
		ifTrue: [result := self variableNamed: result fragment].
	argStack := argStack allButLast.
	^ result! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 14:42'!
popResult
	| lastContext result |
	self hasSuspendContext 
		ifFalse: [^nil].
		
	lastContext := self popSuspendContext.
	result := self resultAt: lastContext.
	resultMap removeKey: lastContext.
	^result.
	! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 10:09'!
popSuspendContext
	| result |
	suspendContext ifNil: [suspendContext := OrderedCollection new].
	result := suspendContext last.
	suspendContext := suspendContext allButLast.
	^result.
	! !

!GplEvaluter methodsFor: 'command' stamp: 'kf 5/23/2009 01:10'!
postfix: aInputString	
	^((self translateToPostfix: aInputString) collect: [:token | token postfixExpr ]) printString
	! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 5/20/2009 16:23'!
postfixIndexOf: aGplToken 
	^postfixTokens indexOf: aGplToken.! !

!GplEvaluter methodsFor: 'debug' stamp: 'kf 5/22/2009 13:41'!
printArgStack: aToken
	argStack ifNil: [^self].
	Transcript cr; show: (aToken -> argStack).! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 5/21/2009 18:41'!
pushArg: aToken
	self assert: (aToken isMemberOf: GplEvaluter) not.
	argStack ifNil: [argStack := OrderedCollection new].
	argStack add: aToken.
	
! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 11:10'!
pushResult: aObject
	self assert: aObject isNil not.
	self hasSuspendContext 
		ifTrue: [
			| lastContext |
			lastContext := self peekSuspendContext.
			self registerResult:  aObject at:  lastContext].! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 09:30'!
pushSuspendContext: aContext
	suspendContext ifNil: [suspendContext := OrderedCollection new].
	suspendContext add: aContext.
! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 11:09'!
registerResult: aResultValue at: aContext
	self assert: (aContext isMemberOf: MethodContext).
	resultMap ifNil: [resultMap := Dictionary new ].
	resultMap at: aContext put: aResultValue.! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 4/26/2009 10:33'!
resolveVariableNameFromTokens: aGplTokens
	GplParser assertGplTokens: aGplTokens.
	^aGplTokens! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/6/2009 11:09'!
resultAt: aContext
	self assert: (aContext isMemberOf: MethodContext).
	resultMap ifNil: [resultMap := Dictionary new ].
	^resultMap at: aContext ! !

!GplEvaluter methodsFor: 'context stack' stamp: 'kf 6/7/2009 14:11'!
resume
	| context suspendedToken suspendPc skippedStream |
	self hasSuspendContext ifFalse: [^self].
	context := self peekSuspendContext.
	suspendedToken := context tempAt: 1.
	suspendPc := self postfixIndexOf: suspendedToken.
	skippedStream := ReadStream on: postfixTokens.
	skippedStream skip: suspendPc - 1.
	^self evalutePostfixStream: skippedStream.
	! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 5/29/2009 18:24'!
syntaxCheck: aGplTokens
	| checker |
	checker := GplSyntax new.
	checker model: self.
	checker checkFromTokens: aGplTokens.
! !

!GplEvaluter methodsFor: 'command' stamp: 'kf 4/23/2009 17:45'!
tokens: aInputString	
	^((GplParser tokensFrom: aInputString) collect: [:token | token fragment]) asArray printString.
	! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 5/17/2009 14:36'!
tokensFrom: aString
	| tokens |
	tokens := GplParser tokensFrom: aString.
	(tokens select: [:each | each type = #unresolved])
		do: [:each |
			 (GplHandler hasCommandName: each fragment asUppercase)
				ifTrue: [each type: #method]].
	tokens := self resolveVariableNameFromTokens: tokens.
	^tokens! !

!GplEvaluter methodsFor: 'analysis-postfix' stamp: 'kf 5/23/2009 11:46'!
translateToPostfix: aSourceCode
	^GplPostfix new translateToPostfixFromTokens: (self tokensFrom: aSourceCode) ! !

!GplEvaluter methodsFor: 'evaluter' stamp: 'kf 4/25/2009 21:40'!
variableNamed: aVariableName
	varMap ifNil: [varMap := Dictionary new.].
	^varMap at: aVariableName ifAbsentPut: [GplVariable named: aVariableName].! !

!GplEvaluter methodsFor: 'analysis' stamp: 'kf 4/26/2009 10:22'!
vectorAnalysisFromTokens: aGplTokens
	| stream vectorTokens token newOutput|
	self assertGplTokens: aGplTokens.
	stream := ReadStream on: aGplTokens.
	newOutput := OrderedCollection new.
	vectorTokens := OrderedCollection new.
	[stream atEnd] 
		whileFalse: [
			token := stream next.
			(self isScalarToken: token) 
				ifTrue: [.
					vectorTokens add: token]
				ifFalse: [
					vectorTokens
						ifNotEmpty: [
							| newToken |
							newToken := GplToken newFromTokens: vectorTokens.
							newOutput add: newToken.
							vectorTokens := OrderedCollection new.].
					newOutput add: token]].
		vectorTokens
			ifNotEmpty: [
				| newToken |
				newToken := GplToken newFromTokens: vectorTokens.
				newOutput add: newToken.
				vectorTokens := OrderedCollection new.].
	^newOutput asArray.! !

!GplEvaluter methodsFor: 'private' stamp: 'kf 5/22/2009 10:00'!
voidReturn
	^GdsNull instance.! !

GplTokenHandler subclass: #GplPostfix
	instanceVariableNames: 'outTokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

!GplPostfix class methodsFor: 'as yet unclassified' stamp: 'kf 5/23/2009 11:56'!
isOperator: aGplTokenOrString
	| fragment |
	fragment := (aGplTokenOrString isKindOf: GplToken)
		ifTrue: [aGplTokenOrString fragment]
		ifFalse: [aGplTokenOrString].	
	(GplHandler hasCommandName: (fragment asUppercase)) ifTrue: [^true].
	^(GplParser isOperatorFragment: fragment).! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 5/29/2009 23:46'!
gotOperator: aToken
	| done |
	self precedenceOf: aToken.
	done := false.
	[stack isEmpty or: [done]]
		whileFalse: [
			| topToken |
			topToken := self pop.
			(topToken fragment = '(' or: [topToken fragment = '['])
				ifTrue: [self push: topToken. done := true]
				ifFalse: [
					((self precedenceOf: topToken) < (self precedenceOf: aToken))
						ifTrue: [self push: topToken. done := true]
						ifFalse: [outTokens add: topToken]]].
	self push: aToken.! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 5/22/2009 22:52'!
gotParen: aToken
	| done |
	done := false.
	[stack isEmpty or: [done]]
		whileFalse: [
			| topToken |
			topToken := self pop.
			topToken fragment = '('
				ifTrue: [done := true.]
				ifFalse: [outTokens add: topToken]]! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 6/8/2009 16:55'!
gotSlice: aToken
	| done |
	done := false.
	[stack isEmpty or: [done]]
		whileFalse: [
			| topToken |
			topToken := self pop.
			outTokens add: topToken.
			topToken fragment = '['
				ifTrue: [
					done := true.]]! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 5/22/2009 22:52'!
guessAgumentType: aToken monadicBlock: aMonadicBlock dyadicBlock: aDyadicBlock
	| leftTokens |
	leftTokens := aToken leftTokens.
	"leftTokens explore."
	leftTokens ifNotEmpty: [
		(self returnValueEnabled: leftTokens last)
			ifTrue: [
				aToken  argumentType:  #dyadic.
				^aDyadicBlock value]].
	aToken  argumentType: #monadic.
	^aMonadicBlock value.	
! !

!GplPostfix methodsFor: 'initialize-release' stamp: 'kf 5/29/2009 11:15'!
initialize
	super initialize.
! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 5/29/2009 22:46'!
operatorSwitch: aGplToken
	(aGplToken fragment = ':=')
		ifTrue: [self push: aGplToken. ^self].
	(aGplToken fragment = '(')
		ifTrue: [self push: aGplToken. ^self].
	(aGplToken fragment = '[')
		ifTrue: [self push: aGplToken. ^self].
	(aGplToken fragment = ')')
		ifTrue: [self gotParen: aGplToken. ^self].
	(aGplToken fragment = ']')
		ifTrue: [self gotSlice: aGplToken. ^self].
	(self class isOperator: aGplToken fragment)
		ifTrue: [self gotOperator: aGplToken. ^self].
	outTokens add: aGplToken.
	^self.	! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 5/30/2009 10:12'!
precedenceOf: aToken
	GplParser operatorSpec do: [:assoc |
		(assoc value includes: aToken fragment)
			ifTrue: [^assoc key]].
	aToken fragment size = 1
		ifTrue: [
			('[]' includes: aToken fragment first)
				ifTrue: [^377].
			('*%' includes: aToken fragment first)
				ifTrue: [
					^self 
						guessAgumentType: aToken 
						monadicBlock: [20] 
						dyadicBlock: [16]].
			('+-' includes: aToken fragment first)
				ifTrue: [
					^self 
						guessAgumentType: aToken 
						monadicBlock: [20] 
						dyadicBlock: [15]].
			(',' includes: aToken fragment first)
				ifTrue: [
					^self 
						guessAgumentType: aToken 
						monadicBlock: [10] 
						dyadicBlock: [6]]].
	(GplBiContextHandler hasCommandName: aToken fragment)
		ifTrue: [aToken isProcedureCall ifTrue: [^-1]].
	(GplHandler isVoid: aToken fragment)
		ifTrue: [^-1].
	^555
! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 5/22/2009 22:52'!
returnValueEnabled: aToken
	('([' includes: aToken fragment first)
		ifTrue: [^false].
	(')]' includes: aToken fragment first)
		ifTrue: [^true].
	(GplHandler noArgReturnValueEnabled: aToken fragment)
		ifTrue: [^true].
	^aToken isOperator not! !

!GplPostfix methodsFor: 'analysis-postfix' stamp: 'kf 5/29/2009 11:23'!
translateToPostfixFromTokens: aGplTokens
	self beforeEvaluteTokens: aGplTokens.
	outTokens := OrderedCollection new.
	aGplTokens do: [:token |
		self operatorSwitch: token].
	[stack isEmpty]
		whileFalse: [outTokens add: self pop].
	^outTokens asArray.! !

GplTokenHandler subclass: #GplSyntax
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Kernel'!

!GplSyntax commentStamp: 'kf 5/29/2009 12:01' prior: 0!
A GplSyntax is GPLII syntax checker.

Instance Variables
!

!GplSyntax class methodsFor: 'as yet unclassified' stamp: 'kf 5/29/2009 15:54'!
check: aString
	| tokens |
	tokens := GplParser tokensFrom: aString.
	self new checkFromTokens: tokens.
	! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 18:44'!
assignCheck: aGplTokens
	| assignToken leftTokens keywordToken |
	assignToken := aGplTokens detect: [:each | each fragment = ':='] ifNone: [nil].
	assignToken ifNil: [^self].

	leftTokens := self leftCheckFor: assignToken.
	self rightCheckFor: assignToken.

	keywordToken := leftTokens detect: [:each | 
		GplHandler hasCommandName: each fragment] ifNone: [nil].
	keywordToken 
		ifNotNil: [
			^self
				syntaxError: 'VARIABLE CAN''T ASSIGND TO PROCEDURE OR FUNCTION'
				token: keywordToken]! !

!GplSyntax methodsFor: 'private' stamp: 'kf 5/29/2009 18:43'!
betweenCheck: aGplTokens openFragment: aOpenFragment closeFragment: aCloseFragment
	| openParlens closeParlens |
	openParlens := aGplTokens select: [:each | each fragment = aOpenFragment].
	closeParlens := aGplTokens select: [:each | each fragment = aCloseFragment].
	(openParlens size + closeParlens size) = 0 ifTrue: [^self.].
	(openParlens size > closeParlens size)
		ifTrue: [^self syntaxError: ('EXTRA ') token: openParlens first].
	(openParlens size < closeParlens size)
		ifTrue: [^self syntaxError: ('EXTRA ') token: closeParlens last.]
		! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 17:27'!
cantUseCheck: aGplTokens 
	self isInteractive ifFalse: [^self].	
	aGplTokens do: [:each |
		(GplToken isProgramOnlyKeyword: each fragment )
				ifTrue: [^self syntaxError: 'KEYWORD NOT LEAGAL IN THIS CONTEXT' token: each]].
! !

!GplSyntax methodsFor: 'check' stamp: 'kf 5/29/2009 17:59'!
checkFromTokens: aGplTokens 
	self beforeEvaluteTokens: aGplTokens.
	self depthCheck: aGplTokens.
	self numberLiteralCheck: aGplTokens.
	self declareCheck: aGplTokens.
	self assignCheck: aGplTokens.
	self cantUseCheck: aGplTokens.	
! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 11:45'!
declareCheck: aGplTokens
	self methodDeclareCheck: aGplTokens.
	self variableDeclareCheck: aGplTokens.		! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 16:21'!
depthCheck: aGplTokens 
	self parlenDepthCheck: aGplTokens.
	self subscriptDepthCheck: aGplTokens.
	self 
		missMatchCheck: aGplTokens 
		openFragments: { '(' . '[' } closeFragments: { ')' . ']' }! !

!GplSyntax methodsFor: 'testing' stamp: 'kf 5/29/2009 20:36'!
hasVariableName: aWord
	model ifNil: [^false].
	^model hasVariableName: aWord! !

!GplSyntax methodsFor: 'private' stamp: 'kf 5/29/2009 16:05'!
insideEmptyCheck: aGplTokens openFragment: aOpenFragment closeFragment: aCloseFragment
	| openParlens |
	openParlens := aGplTokens select: [:each | each fragment = aOpenFragment].
	openParlens do: [:each |
		|rightTokens |
		rightTokens := each rightTokens.
		rightTokens
			ifNotEmpty: [
				(rightTokens first fragment = aCloseFragment)
					ifTrue: [^each]]].
	^nil.! !

!GplSyntax methodsFor: 'testing' stamp: 'kf 5/29/2009 17:36'!
isDefined: aWord
	model ifNil: [^false].
	^model isDefined: aWord! !

!GplSyntax methodsFor: 'testing' stamp: 'kf 5/29/2009 17:21'!
isInteractive
	model ifNil: [^true].
	^model isInteractive! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 20:31'!
leftCheckFor: anAssignToken
	| leftTokens expressionToken |
	leftTokens := anAssignToken leftTokens
		select: [:each | each depthOfSubscript = anAssignToken depthOfSubscript].
	expressionToken := leftTokens
		 detect: [:each | each fragment =')'] ifNone: [nil].
	expressionToken
		ifNotNil: [^self syntaxError: 'ILLIGAL STORE OPERATION'].
		
	leftTokens := anAssignToken leftTokensOfSameDepth .
	leftTokens
		ifEmpty: [^self syntaxError: 'MISSING LEFT VARIABLE FOR' token: anAssignToken].
	^leftTokens! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 20:41'!
methodDeclareCheck: aGplTokens
	| voidToken voidTokens |
	voidTokens := aGplTokens
		select: [:each | 
			each fragment first isLetter 
			and: [ (self hasVariableName:  each fragment) not]
			and: [ GplHandler isVoid: each fragment]].
	voidTokens ifEmpty: [^self].
	voidToken := voidTokens first.
	voidToken leftTokens isEmpty 
		ifFalse: [
			^self 
				syntaxError: 'NOT A VALUEABLE PROCEDURE CALL'  token: voidToken].
	! !

!GplSyntax methodsFor: 'private' stamp: 'kf 6/8/2009 16:39'!
missMatchCheck: aGplTokens openFragments: aOpenFragments closeFragments: aCloseFragments
	| topToken |
	self resetStack.
	aGplTokens
		do: [:each |
			each fragment = aOpenFragments first
				ifTrue: [self push: each].
			each fragment = aOpenFragments second
				ifTrue: [self push: each].	
			each fragment = aCloseFragments first
				ifTrue: [
					topToken := self pop.
					topToken fragment = aOpenFragments first
						ifFalse: [
							^self 
								syntaxError: 'MISS MATCH MUST: ', aCloseFragments second, ' BUT'
								token: each].].
			each fragment = aCloseFragments second
				ifTrue: [
					topToken := self pop.
					topToken fragment = aOpenFragments second
						ifFalse: [
							^self
								syntaxError: ('MISS MATCH MUST: ', aCloseFragments first, ' BUT')
								token: each].].]
				! !

!GplSyntax methodsFor: 'accessing' stamp: 'kf 5/29/2009 18:09'!
model: aModel
	model := aModel! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 18:00'!
numberLiteralCheck: aGplTokens
	| unresolvedTokens |
	unresolvedTokens := aGplTokens select: [:each | 
			each type =  #unresolved 
		and: [(GplParserBase isNameFirst: each fragment first) not]
		and: [GplParser isNumberFragment: each fragment]].
	unresolvedTokens ifEmpty: [^self].
		
	^self 
		syntaxError: 'INVALID NUMERIC FORMAT'
		token: unresolvedTokens first.! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 16:04'!
parlenDepthCheck: aGplTokens 
	| emptyToken |
	self betweenCheck:  aGplTokens openFragment:  '(' closeFragment:  ')' .
	emptyToken := self insideEmptyCheck: aGplTokens openFragment:  '('  closeFragment:  ')'.
	emptyToken
		ifNotNil: [^self syntaxError: 'EMPTY EXPRESSION ()'].! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 6/5/2009 11:08'!
rightCheckFor: anAssignToken
	| rightTokens voidToken |		
	rightTokens := anAssignToken rightTokens.
	rightTokens
		ifEmpty: [^self syntaxError: 'MISSING RIGHT EXPRESSION FOR' token: anAssignToken].
	voidToken := anAssignToken 
		rightTokens
			detect: [:each | 
				each type ~= #number
				and: [each fragment first isLetter ]
				and: [ (self hasVariableName:  each fragment) not]
				and: [GplHandler isVoid: each fragment]] 
			ifNone: [nil].
	voidToken
		ifNotNil: [
			^self 
				syntaxError: 'NOT A VALUEABLE PROCEDURE CALL' 
				token: voidToken ].! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 16:05'!
subscriptDepthCheck: aGplTokens 
	| emptyToken |
	self betweenCheck:  aGplTokens openFragment:  '[' closeFragment:  ']'.
	emptyToken := self insideEmptyCheck: aGplTokens openFragment:  '['  closeFragment:  ']'.
	emptyToken
		ifNotNil: [^self syntaxError: 'EMPTY SUBSCRIPT EXPRESSION []'].	 			! !

!GplSyntax methodsFor: 'private' stamp: 'kf 5/29/2009 17:18'!
syntaxError: aMessage token: aGplToken
	^self syntaxError: (self syntaxMessage: aMessage token: aGplToken)! !

!GplSyntax methodsFor: 'private check' stamp: 'kf 5/29/2009 17:46'!
variableDeclareCheck: aGplTokens
	"allow undefined "
	"left operand and isInteractive"
	| unresolvedTokens |
	unresolvedTokens := aGplTokens select: [:each | 
		each type =  #unresolved and: [(self isDefined: each fragment) not]].
	unresolvedTokens ifEmpty: [^self].
	self isInteractive
		ifFalse: [
			^self 
				syntaxError: 'VARIABLE NOT DEFINED'
				token: unresolvedTokens first].
	
	unresolvedTokens do: [:each |
		(each rightTokens isEmpty not 
				and: [each rightTokens first fragment = ':='])
			ifFalse: [
				^self 
					syntaxError: 'VARIABLE NOT DEFINED'
					token: each]].! !

!GplTokenHandler methodsFor: 'analysis-postfix' stamp: 'kf 5/29/2009 11:22'!
beforeEvaluteTokens: aGplTokens
	GplParser assertGplTokens: aGplTokens.
	self resetStack.
! !

!GplTokenHandler methodsFor: 'private' stamp: 'kf 5/30/2009 09:28'!
clientPrompt
	^'? '! !

!GplTokenHandler methodsFor: 'accessing' stamp: 'kf 6/5/2009 17:37'!
debugLog: aObject
	self showsLog ifFalse: [^self].
	Transcript cr; show: aObject.
	! !

!GplTokenHandler methodsFor: 'initialize-release' stamp: 'kf 5/29/2009 11:17'!
initialize
	super initialize.
	showsLog := false.
	self resetStack.
	! !

!GplTokenHandler methodsFor: 'syntax check' stamp: 'kf 5/30/2009 09:31'!
notImplementedToken: aGplToken
	^self syntaxMessage: 'RESERVED BUT NOT IMPLEMENTED' token: aGplToken.
! !

!GplTokenHandler methodsFor: 'analysis-postfix' stamp: 'kf 5/29/2009 11:11'!
pop
	| result |
	result := stack last.
	stack := stack allButLast.
	^result.! !

!GplTokenHandler methodsFor: 'analysis-postfix' stamp: 'kf 5/29/2009 11:11'!
push: aToken
	stack add: aToken.! !

!GplTokenHandler methodsFor: 'initialize-release' stamp: 'kf 5/29/2009 11:17'!
resetStack
	stack := OrderedCollection new.
	! !

!GplTokenHandler methodsFor: 'accessing' stamp: 'kf 5/29/2009 11:13'!
showsLog
	^showsLog! !

!GplTokenHandler methodsFor: 'accessing' stamp: 'kf 5/29/2009 11:13'!
showsLog: aBoolean
	self assert: [aBoolean isKindOf: Boolean]. 
	showsLog := aBoolean.
	! !

!GplTokenHandler methodsFor: 'syntax check' stamp: 'kf 5/30/2009 09:29'!
syntaxMessage: aMessage token: aGplToken
	^String streamContents: [:s |
		(aGplToken start + (self clientPrompt size)) - 1 timesRepeat: [s nextPut: Character space].
		aGplToken fragment size timesRepeat: [s nextPut: $^].
		s nextPut: Character space.
		s nextPutAll: (aMessage,': ', aGplToken fragment).]! !

!Object methodsFor: '*GdsCompiler' stamp: 'kf 5/23/2009 17:04'!
asGdsValue
	^GdsDataStructure cantConvertSmalltalkObject: self. ! !

WAComponent subclass: #WAGplCodeView
	instanceVariableNames: 'tokenizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Seaside'!

!WAGplCodeView methodsFor: 'rendering' stamp: 'kf 4/22/2009 18:05'!
renderContentOn: html
	| tokens |
	tokens := tokenizer tokensIgnoreSpace: false.
	html preformatted: [
		tokens do: [:token |
			self renderToken: token on: html]].! !

!WAGplCodeView methodsFor: 'as yet unclassified' stamp: 'kf 4/20/2009 20:31'!
renderToken: aToken on: html
	aToken fragment = #cr 
		ifTrue: [html break.]
		ifFalse: [
			self renderTokenDirect: aToken on: html].! !

!WAGplCodeView methodsFor: 'as yet unclassified' stamp: 'kf 4/22/2009 18:41'!
renderTokenDirect: aToken on: html
	html code class: aToken type asString; with: aToken fragment.! !

!WAGplCodeView methodsFor: 'accessing' stamp: 'kf 4/22/2009 21:57'!
sourceCode: aSourceCode
	tokenizer := GplParser new.
	tokenizer source: aSourceCode.
	tokenizer splitRanges.! !

!WAGplCodeView methodsFor: 'rendering' stamp: 'kf 4/20/2009 20:50'!
style
	^'
.comment {
  color: green;
}
	
.reserved {
  color: blue;
  font-weight: bold;
}
	
.builtinMethod {
  color: darkblue;
}	

.gdsiiMethod {
  color: #8d0d8d;
}	

.string {
  color: brown;
}	

	'! !

!Number methodsFor: '*GdsCompiler' stamp: 'kf 5/23/2009 15:35'!
asGdsValue
	^((self isInteger and: [self = 1 or: [self = 0]])
		 ifTrue: [GdsBoolean]
		ifFalse: [GdsNumber])
			fromSmalltalkObject: self.! !

!Boolean methodsFor: '*GdsCompiler' stamp: 'kf 5/23/2009 15:00'!
asGdsValue
	^GdsBoolean fromSmalltalkObject: self.
! !

!Character methodsFor: '*GdsCompiler' stamp: 'kf 5/23/2009 15:37'!
asGdsValue
	^GdsCharacter fromSmalltalkObject: self.! !

Error subclass: #GdsError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Misc'!

GdsError subclass: #GplError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Misc'!

GplError subclass: #GplPromptException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Misc'!

GplError subclass: #GplRuntimeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Misc'!

GplError subclass: #GplSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GdsCompiler-Misc'!
